#include "e0main.h"
#include "Fonts.h"

void DoHud(GLvoid){
	int i3;
	bool b=false;
	glLoadIdentity();									// Reset The Current Modelview Matrix
	glClear(GL_DEPTH_BUFFER_BIT);
	glDisable(GL_DEPTH_TEST);
	
	if(ShowObjectives){
		glTranslatef(0.0f,0.0f,-1.0f);				// Move One Unit Into The Screen
		glRasterPos2f(-0.51f,0.253f);
		glPrint("OBJECTIVES");
		for(i3=0;i3<NoOfObjectives;i3++){
			glRasterPos2f(-0.51f,0.2f-(0.03f*i3));
			glPrint(ObjectiveList[i3]);
			if(ObjectiveComplete[i3])
				glPrint(" (done)");
			if(TagArray[ObjectiveLink[i3]])
				ObjectiveComplete[i3]=true;
		}
	}

	glLoadIdentity();									// Reset The Current Modelview Matrix
	glClear(GL_DEPTH_BUFFER_BIT);
	glDisable(GL_DEPTH_TEST);
	glTranslatef(0.0f,0.0f,-1.0f);				// Move One Unit Into The Screen
	
	//Draw the Belt
	
	glEnable(GL_TEXTURE_2D);

	glTranslatef(-0.51f,-0.373f,0.0f);
	
	if(PrefsHideBelt&&PrefsBeltTrans>0.0f)
		PrefsBeltTrans-=0.01f;
	if(PrefsTermTrans>0.0f)
		PrefsTermTrans-=0.005f;
	if(PlayerSelection-(PrefsBeltSize/2)<=0)
		b=true;

	for(i=1;i<PrefsBeltSize;i++){
		glEnable(GL_TEXTURE_2D);
		if(b)
			i2=i;
		else
			i2=PlayerSelection-(PrefsBeltSize/2)+i;

		if(PlayerInventory[i2]<=0)
			glBindTexture(GL_TEXTURE_2D,BitmapArray[1]);
		else
			glBindTexture(GL_TEXTURE_2D,BitmapArray[ItemInfoArray[i2].invgraphic]);

		
		if(i2==PlayerSelection)
				glColor4ub(255,255,255,72*PrefsBeltTrans);
			else
				glColor4ub(255,255,255,32*PrefsBeltTrans);
		
		if(PrefsMinimalInterface)
			glColor4ub(255,255,255,0);

		glBegin(GL_QUADS);
			glTexCoord2f(0.0f, 0.0f); glVertex2f(-0.03f, -0.03f);
			glTexCoord2f(1.0f, 0.0f); glVertex2f(0.03f, -0.03f);
			glTexCoord2f(1.0f, 1.0f); glVertex2f(0.03f, 0.03f);
			glTexCoord2f(0.0f, 1.0f); glVertex2f(-0.03f, 0.03f);
		glEnd();
		glDisable(GL_TEXTURE_2D);
		if(PrefsBeltTrans>0){
			glBegin(GL_QUADS);
				glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],(32*PrefsBeltTrans)+1);
				glVertex2f(-0.03f, -0.03f);
				glVertex2f(-0.03f, -0.035f);
				glColor4ub(colorarray[0][1][1],colorarray[1][1][1],colorarray[2][1][1],(255*((float)PlayerInventory[i2]/(float)ItemInfoArray[i2].max)*PrefsBeltTrans));
				glVertex2f(-0.03f+(((float)PlayerInventory[i2]/(float)ItemInfoArray[i2].max)*0.06f), -0.035f);
				glVertex2f(-0.03f+(((float)PlayerInventory[i2]/(float)ItemInfoArray[i2].max)*0.06f), -0.03f);
			glEnd();
		}
		glTranslatef(0.07f,0.0f,0.0f);
		
	}
	b=false;

	if(PlayerInventory[PlayerSelection]<0)
		for(;PlayerInventory[PlayerSelection]==0&&!b;PlayerSelection++){
			if(PlayerSelection==499){
				PlayerSelection=-1;
				b=true;
			}
		}
	glDisable(GL_TEXTURE_2D);

	//Now, the health & oxygen bars
	glLoadIdentity();
	glTranslatef(0.0f,0.0f,-1.0f);
	
	if(PrefsMinimalInterface)
		glTranslatef(0.0f,-0.06f,0.0f);


	glBegin(GL_QUADS);
		glColor4ub(128,128,128,64*PrefsBeltTrans);
		glVertex2f(-0.55f*((float)WeaponAmmo[PlayerPriSelection]/(float)WeaponInfoArray[PlayerPriSelection].clipsize),-0.325f);
		glVertex2f(-0.55f*((float)WeaponAmmo[PlayerPriSelection]/(float)WeaponInfoArray[PlayerPriSelection].clipsize),-0.315f);
		glColor4ub(0,0,0,64*PrefsBeltTrans);
		glVertex2f(-0.00f,-0.315f);
		glVertex2f(-0.00f,-0.325f);
	glEnd();
	glBegin(GL_QUADS);
		glColor4ub(128,128,128,64*PrefsBeltTrans);
		glVertex2f(0.55f*((float)WeaponAmmo[PlayerSecSelection]/(float)WeaponInfoArray[PlayerSecSelection].clipsize),-0.325f);
		glVertex2f(0.55f*((float)WeaponAmmo[PlayerSecSelection]/(float)WeaponInfoArray[PlayerSecSelection].clipsize),-0.315f);
		glColor4ub(255,255,255,64*PrefsBeltTrans);
		glVertex2f(-0.00f,-0.315f);
		glVertex2f(-0.00f,-0.325f);
	glEnd();

	glColor4ub(255,0,0,32*PrefsBeltTrans);
	glBegin(GL_QUADS);
		glVertex2f(-0.55f*((float)Player.health/(float)MonsterInfoArray[Player.type].startinghealth),-0.325f);
		glVertex2f(-0.55f*((float)Player.health/(float)MonsterInfoArray[Player.type].startinghealth),-0.335f);
		glVertex2f(-0.00f,-0.335f);
		glVertex2f(-0.00f,-0.325f);
	glEnd();
	
	if(Player.health>MonsterInfoArray[Player.type].startinghealth){
		glColor4ub(255,255,0,24*PrefsBeltTrans);
		glBegin(GL_QUADS);
			glVertex2f(-0.55f*(((float)Player.health-MonsterInfoArray[Player.type].startinghealth)/(float)MonsterInfoArray[Player.type].startinghealth),-0.325f);
			glVertex2f(-0.55f*(((float)Player.health-MonsterInfoArray[Player.type].startinghealth)/(float)MonsterInfoArray[Player.type].startinghealth),-0.335f);
			glVertex2f(-0.00f,-0.335f);
			glVertex2f(-0.00f,-0.325f);
		glEnd();
	}
	if(Player.health>MonsterInfoArray[Player.type].startinghealth*2){
		glColor4ub(128,0,192,32*PrefsBeltTrans);
		glBegin(GL_QUADS);
			glVertex2f(-0.55f*(((float)Player.health-(MonsterInfoArray[Player.type].startinghealth*2))/(float)MonsterInfoArray[Player.type].startinghealth),-0.325f);
			glVertex2f(-0.55f*(((float)Player.health-(MonsterInfoArray[Player.type].startinghealth*2))/(float)MonsterInfoArray[Player.type].startinghealth),-0.335f);
			glVertex2f(-0.00f,-0.335f);
			glVertex2f(-0.00f,-0.325f);
		glEnd();

	}
	if(Player.health>MonsterInfoArray[Player.type].startinghealth*3){
		glColor4ub(255,255,255,100*PrefsBeltTrans);
		glBegin(GL_QUADS);
			glVertex2f(-0.55f*(((float)Player.health-(MonsterInfoArray[Player.type].startinghealth*3))/(float)MonsterInfoArray[Player.type].startinghealth),-0.325f);
			glVertex2f(-0.55f*(((float)Player.health-(MonsterInfoArray[Player.type].startinghealth*3))/(float)MonsterInfoArray[Player.type].startinghealth),-0.335f);
			glVertex2f(-0.00f,-0.335f);
			glVertex2f(-0.00f,-0.325f);
		glEnd();

	}
	glColor4ub(0,0,255,32*PrefsBeltTrans);
	glBegin(GL_QUADS);
		glVertex2f(0.55f*((float)Player.oxygen/100000.0f),-0.325f);
		glVertex2f(0.55f*((float)Player.oxygen/100000.0f),-0.335f);
		glVertex2f(0.00f,-0.335f);
		glVertex2f(0.00f,-0.325f);
	glEnd();
//Terminal

	glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],(colorarray[3][0][1]*PrefsTermTrans)+2);

	glRasterPos2f(-0.50f, 0.35f);
	glPrint(TermText);
	glColor4ub(colorarray[0][1][1],colorarray[1][1][1],colorarray[2][1][1],colorarray[3][1][1]*PrefsTermTrans);
	
	glBegin(GL_QUADS);
		glVertex2f(-0.75f, 0.345f);
		glVertex2f(1.00f, 0.345f);
		glVertex2f(1.00f, 0.37f);
		glVertex2f(-0.75f, 0.37f);
	glEnd();
	//glLoadIdentity();
	glDisable(GL_DEPTH_TEST);
	//Remember not to remove this... if you're forced to change weapons it must update
	if(ItemInfoArray[PlayerSelection].effect==1){
		PlayerPriSelection=ItemInfoArray[PlayerSelection].weapon1;
		PlayerSecSelection=ItemInfoArray[PlayerSelection].weapon2;
	}else{
		PlayerPriSelection=0;
		PlayerSecSelection=0;
	}
	
	
	char ammoinfo[255];

	
	glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],colorarray[3][1][1]*PrefsBeltTrans);
	glLoadIdentity();
	glTranslatef(-0.54f, -0.315f,-1.0f);
	if(PrefsMinimalInterface)
		glTranslatef(0.0f,-0.05f,0.0f);
	glRasterPos2f(0.0f,0.0f);
	switch(ItemInfoArray[PlayerSelection].effect){
		case 1:
			sprintf(ammoinfo,"%i/%ix%i     %i/%ix%i",WeaponAmmo[PlayerPriSelection],WeaponInfoArray[PlayerPriSelection].clipsize,PlayerInventory[WeaponInfoArray[PlayerPriSelection].ammotype],WeaponAmmo[PlayerSecSelection],WeaponInfoArray[PlayerSecSelection].clipsize,PlayerInventory[WeaponInfoArray[PlayerSecSelection].ammotype]);
			break;
		case 2:
			sprintf(ammoinfo,"%i clips",PlayerInventory[PlayerSelection]);
			if(PlayerInventory[PlayerSelection]==1)
				sprintf(ammoinfo,"1 clip");
		break;
		default:
			sprintf(ammoinfo,"%i items",PlayerInventory[PlayerSelection]);
			if(PlayerInventory[PlayerSelection]==1)
				sprintf(ammoinfo,"1 item");
	}
	//Slow!
	glPrint(ammoinfo);

	glLoadIdentity();

	return;
}


void DoCrosshairs(GLvoid){
	GLfloat temp=Player.inaccuracy;

	if(ScanVision){
		glPolygonMode (GL_BACK, GL_FILL);
		glPolygonMode (GL_FRONT, GL_FILL);
	}
	//Don't remove this. It matters.
	if(WeaponInfoArray[PlayerPriSelection].accdelay==-1.0f)
		Player.inaccuracy=0.0f;
	glLoadIdentity();		//Let's start drawing crosshairs...
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);		// Turn Blending On
	glDisable(GL_DEPTH_TEST);	// Turn Depth Testing Off
	
	glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],colorarray[3][0][1]);
	
	glLineWidth(PrefsCrosshairThickness);
	
	if(ItemInfoArray[PlayerSelection].crosshairtype == 1){
		glBegin(GL_LINES);
			glVertex3f((-Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)-PrefsCrosshairWidth,0.0f,-1.0f);
			glVertex3f(-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor),0.0f,-1.0f);
			
			glVertex3f((Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)+PrefsCrosshairWidth,0.0f,-1.0f);
			glVertex3f((Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor),0.0f,-1.0f);
			
			glVertex3f(0.0f,(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)+PrefsCrosshairHeight,-1.0f);
			glVertex3f(0.0f,(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor),-1.0f);
			
			glVertex3f(0.0f,-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)-PrefsCrosshairHeight,-1.0f);
			glVertex3f(0.0f,-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor),-1.0f);
		glEnd();
	}
	if(ItemInfoArray[PlayerSelection].crosshairtype == 2){
		glBegin(GL_LINES);
			glVertex3f(-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)-0.001f,0.0f,-1.0f);
			glVertex3f((Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)+0.001f,0.0f,-1.0f);
		glEnd();
	}
	
	if(ItemInfoArray[PlayerSelection].crosshairtype == 3){
		glBegin(GL_LINES);
			glVertex3f(-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor),0.0f,-1.0f);
			glVertex3f(-PrefsCrosshairWidth,0.0f,-1.0f);
			
			glVertex3f((Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor),0.0f,-1.0f);
			glVertex3f(PrefsCrosshairWidth,0.0f,-1.0f);
			
			glVertex3f(0.0f,(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor),-1.0f);
			glVertex3f(0.0f,PrefsCrosshairHeight,-1.0f);
			
			glVertex3f(0.0f,-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor),-1.0f);
			glVertex3f(0.0f,-PrefsCrosshairHeight,-1.0f);
		glEnd();
	}
	
	if(ItemInfoArray[PlayerSelection].crosshairtype == 4){
		glBegin(GL_LINES);
			
			glVertex3f(-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)-PrefsCrosshairWidth,0.0f,-1.0f);
			glVertex3f(0.0f,0.0f,-1.0f);
			
			glVertex3f((Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)+PrefsCrosshairWidth,0.0f,-1.0f);
			glVertex3f(0.0f,0.0f,-1.0f);
			
			glVertex3f(0.0f,(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)+PrefsCrosshairHeight,-1.0f);
			glVertex3f(0.0f,0.0f,-1.0f);
			
			glVertex3f(0.0f,-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)-PrefsCrosshairHeight,-1.0f);
			glVertex3f(0.0f,0.0f,-1.0f);
			
			gf=(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)/3.0f;
			//Draw the box thingy
			glVertex3f(-gf,-gf,-1.0f);
			glVertex3f(gf,-gf,-1.0f);
			
			glVertex3f(gf,-gf,-1.0f);
			glVertex3f(gf,gf,-1.0f);
			
			glVertex3f(gf,gf,-1.0f);
			glVertex3f(-gf,gf,-1.0f);
			
			glVertex3f(-gf,gf,-1.0f);
			glVertex3f(-gf,-gf,-1.0f);
		glEnd();
	}
	
	if(ItemInfoArray[PlayerSelection].crosshairtype == 5){
		glBegin(GL_LINES);
			glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],0);
			glVertex3f(-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)-PrefsCrosshairWidth,0.0f,-1.0f);
			glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],colorarray[2][0][1]);
			glVertex3f(0.0f,0.0f,-1.0f);
			
			glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],0);
			glVertex3f((Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)+PrefsCrosshairWidth,0.0f,-1.0f);
			glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],colorarray[2][0][1]);
			glVertex3f(0.0f,0.0f,-1.0f);
			
			glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],0);
			glVertex3f(0.0f,(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)+PrefsCrosshairHeight,-1.0f);
			glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],colorarray[2][0][1]);
			glVertex3f(0.0f,0.0f,-1.0f);
			
			glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],0);
			glVertex3f(0.0f,-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)-PrefsCrosshairHeight,-1.0f);
			glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],colorarray[2][0][1]);
			glVertex3f(0.0f,0.0f,-1.0f);
		glEnd();
	}
	
	if(ItemInfoArray[PlayerSelection].crosshairtype == 6){
		glBegin(GL_LINES);
			glVertex3f(-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)-0.001f,0.0f,-1.0f);
			glVertex3f(0.0f,(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)+0.001f,-1.0f);
			
			glVertex3f(0.0f,(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)+0.001f,-1.0f);
			glVertex3f((Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)+0.001f,0.0f,-1.0f);
			
			glVertex3f((Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)+0.001f,0.0f,-1.0f);
			glVertex3f(0.0f,-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)-0.001f,-1.0f);
			
			glVertex3f(0.0f,-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)-0.001f,-1.0f);
			glVertex3f(-(Player.inaccuracy/WeaponInfoArray[PlayerPriSelection].inaccfactor)-0.001f,0.0f,-1.0f);
			


			glVertex3f(-PrefsCrosshairWidth,0.0f,-1.0f);
			glVertex3f(0.0f,PrefsCrosshairHeight,-1.0f);
			
			glVertex3f(0.0f,PrefsCrosshairHeight,-1.0f);
			glVertex3f(PrefsCrosshairWidth,0.0f,-1.0f);
			
			glVertex3f(PrefsCrosshairWidth,0.0f,-1.0f);
			glVertex3f(0.0f,-PrefsCrosshairHeight,-1.0f);
			
			glVertex3f(0.0f,-PrefsCrosshairHeight,-1.0f);
			glVertex3f(-PrefsCrosshairWidth,0.0f,-1.0f);
			
		glEnd();
	}
	Player.inaccuracy=temp;
	return;
}
int nx, ny;		//Mouse stuff
GLfloat ix=0.0f, iy=0.0f;
void DoInput(GLvoid){
	int i, i2;
	GLfloat f1=0, f2=0;
	GLfloat pf1=0, pf2=0;
	bool b=false;
	bool b2=false;
	char shotloc[255];

	/*
	SDL_Surface *sparesurface;
	if(keys[SDLK_F11]){
		keys[SDLK_F11]=false;
		sparesurface = SDL_CreateRGBSurface( SDL_SWSURFACE,screenwidth, screenheight, bitdepth,0xff000000,0x00ff0000,0x0000ff00,0x000000ff);
		//SDL_LockSurface(surface);
		//SDL_LockSurface(sparesurface);

		
		sprintf(shotloc,"e0shot%i.bmp",ShotNo);
		SDL_BlitSurface(surface,NULL,sparesurface,NULL);
		SDL_SaveBMP(sparesurface,shotloc);
		sprintf(TermText,"Saved screenshot to %s",shotloc);
		PrefsTermTrans = 1.0f;
		ShotNo++;

		//SDL_UnlockSurface(sparesurface);
		//SDL_UnlockSurface(surface);

		SDL_FreeSurface(sparesurface);
	}
*/
	

	if(PrefsUseMouse){
        SDL_GetMouseState(&nx, &ny);
		SDL_WarpMouse(screenwidth/2, screenheight/2);
		if(MonsterInfoArray[Player.type].ta!=0.0f){
			if(iy<-85)
				iy=-85;
			if(iy>85)
				iy=85;
			if(PrefsInterpolateMouse){
				if(!Zooming){
					ix-=((screenwidth/2)-nx)*PrefsMouseSens;
					if(PrefsInvertMouse)
						iy+=((screenheight/2)-ny)*PrefsMouseSens;
					else
						iy-=((screenheight/2)-ny)*PrefsMouseSens;
				}else{
					ix-=((screenwidth/2)-nx)*PrefsMouseSens/ZoomAmount;
					if(PrefsInvertMouse)
						iy+=((screenheight/2)-ny)*PrefsMouseSens/ZoomAmount;
					else
						iy-=((screenheight/2)-ny)*PrefsMouseSens/ZoomAmount;
				}

				Player.xdir=((Player.xdir*9)+ix)/10.0f;
				Player.ydir=((Player.ydir*9)+iy)/10.0f;
			}else{
					if(!Zooming){
					Player.xdir-=((screenwidth/2)-nx)*PrefsMouseSens;
					if(PrefsInvertMouse)
						Player.ydir+=((screenheight/2)-ny)*PrefsMouseSens;
					else
						Player.ydir-=((screenheight/2)-ny)*PrefsMouseSens;
				}else{
					Player.xdir-=((screenwidth/2)-nx)*PrefsMouseSens/ZoomAmount;
					if(PrefsInvertMouse)
						Player.ydir+=((screenheight/2)-ny)*PrefsMouseSens/ZoomAmount;
					else
						Player.ydir-=((screenheight/2)-ny)*PrefsMouseSens/ZoomAmount;
				}
			}
		}
	}

	if(Player.ydir<-85)
		Player.ydir=-85;
	if(Player.ydir>85)
		Player.ydir=85;

	if(keys[SDLK_TAB]){
		int thepoly=0;
		for(i=0;i<PolygonArraySize&&thepoly==0;i++){
			if(sqrt(((Player.x-PolygonArray[i].centerx)*(Player.x-PolygonArray[i].centerx))+((Player.z-PolygonArray[i].centery)*(Player.z-PolygonArray[i].centery)))<1.5f){
				for(i2=0;i2<PlatformArraySize;i2++){
					if(PlatformArray[i2].poly==i){
						PlatformArray[i2].active=true;
						PlatformArray[i2].delayed=false;
						PlatformArray[i2].timer=0.0f;
					}
						
				}
			}
		}
			
	}
	if( (keys[SDLK_LALT]&&keys['r']) || (Player.health<=0 && keys[SDLK_TAB]) ){
		fprintf(stderr,"Resetting\n");
		CleanUp();
		LoadMap(CurrentLevel);
		//to do: clear inventory/ammo/etc
	}
	if((keys[SDLK_LALT]||keys[SDLK_RALT])&&keys['w'])
		Quit(0);
	if((keys[SDLK_LALT]||keys[SDLK_RALT])&&keys[SDLK_F4])
		Quit(0);

	if(keys['t']&&TermEditPoint==-1){
		for(i2=0;i2<255;i2++)
			TermText[i2]=' ';
		TermEditPoint=0;
		keys['t']=0;
		PrefsShowFPS = false;
		PrefsShowPosition = false;
	}


	if(TermEditPoint!=-1){
		if(TermEditPoint==255)
			TermEditPoint=254;
		PrefsTermTrans=1.0f;
		for(i=0;i<255;i++){
			if(keys[SDLK_RETURN]){
				ProcessLine(TermText);
				initGL();
				TermEditPoint=-1;
				for(i2=0;i2<255;i2++){
					TermText[i2]=' ';}
			}else{
				if(keys[SDLK_BACKSPACE]&&TermEditPoint>0){
					TermEditPoint--;
					TermText[TermEditPoint]=' ';
					keys[SDLK_BACKSPACE]=0;
				}
				if((keys[SDLK_RSHIFT]||keys[SDLK_LSHIFT])&&!keys[SDLK_SPACE]){
					if(keys[i]){
						TermText[TermEditPoint]=i-32;
						TermEditPoint++;
						keys[i]=0;
					}
				}else{
					if(keys[i]){
						TermText[TermEditPoint]=i;
						TermEditPoint++;
						keys[i]=0;
					}
				}
			}
		}
	}
	if(inputmode == 0&&TermEditPoint==-1){
		if(keys['m']){
			subscreen=!subscreen;
			glPolygonMode (GL_BACK, GL_FILL);
			glPolygonMode (GL_FRONT, GL_FILL);
			keys['m']=0;
		}
		if(keys['o']){
			ShowObjectives=!ShowObjectives;
			keys['o']=false;
		}
		if(ItemInfoArray[PlayerSelection].effect==1){
			if(LButtonDown){
				Player.shoot(0,PlayerPriSelection, false);
				if(!WeaponInfoArray[PlayerPriSelection].wauto)
					LButtonDown=false;
			}
			if(RButtonDown){
				if(WeaponInfoArray[PlayerPriSelection].zooms){
					RButtonDown=false;
					Zooming=!Zooming;
					ZoomAmount=WeaponInfoArray[PlayerPriSelection].zoomfactor;
				}else{
					Player.shoot(0,PlayerSecSelection, true);
					if(!WeaponInfoArray[PlayerSecSelection].wauto)
						RButtonDown=false;
				}
			}
		}
		if(PlayerInventory[PlayerSelection]<=0&&PlayerSelection>0)
			PlayerSelection--;


		if(WeaponAmmo[PlayerSecSelection]==0&&PlayerInventory[WeaponInfoArray[PlayerSecSelection].ammotype]>0){
			PlayerInventory[WeaponInfoArray[PlayerSecSelection].ammotype]--;
			WeaponAmmo[PlayerSecSelection]=WeaponInfoArray[PlayerSecSelection].clipsize;
			PrefsBeltTrans=PrefsMaxBeltTrans;
			RButtonDown=false;
			/*for(;PlayerInventory[PlayerSelection]==0&&!b;PlayerSelection--)
				if(PlayerSelection==0)
					b=true;*/
		}

		if(WeaponAmmo[PlayerPriSelection]==0&&PlayerInventory[WeaponInfoArray[PlayerPriSelection].ammotype]>0){
			PlayerInventory[WeaponInfoArray[PlayerPriSelection].ammotype]--;
			WeaponAmmo[PlayerPriSelection]=WeaponInfoArray[PlayerPriSelection].clipsize;
			PrefsBeltTrans=PrefsMaxBeltTrans;
			LButtonDown=false;
			//for(;PlayerInventory[PlayerSelection]==0&&!b;PlayerSelection--)
		}

		b=false;

		if(keys['[']){
			PrefsBeltTrans=PrefsMaxBeltTrans;
			PlayerSelection--;
			for(;PlayerInventory[PlayerSelection]==0&&PlayerSelection>0;PlayerSelection--);
			b2=true;
			keys['[']=false;
		}

		f1=PlayerSelection;
		b=false;
		if(keys[']']&&PlayerSelection<500){
			PrefsBeltTrans=PrefsMaxBeltTrans;
			PlayerSelection++;
			for(;PlayerInventory[PlayerSelection]==0&&!b;PlayerSelection++){
				if(PlayerSelection==499){
					PlayerSelection=f1-1;
					b=true;
				}
			}
			b2=true;
			keys[']']=false;
		}
		if(keys['`']){
			PlayerSelection=0;
			b2=true;}
		if(keys['1']){
			PlayerSelection=1;
			b2=true;}
		if(keys['2']){
			PlayerSelection=2;
			b2=true;}
		if(keys['3']){
			PlayerSelection=3;
			b2=true;}
		if(keys['4']){
			PlayerSelection=4;
			b2=true;}
		if(keys['5']){
			PlayerSelection=5;
			b2=true;}
		if(keys['6']){
			PlayerSelection=6;
			b2=true;}
		if(keys['7']){
			PlayerSelection=7;
			b2=true;}
		if(keys['8']){
			PlayerSelection=8;
			b2=true;}
		if(keys['9']){
			PlayerSelection=9;
			b2=true;}
		if(keys['0']){
			PlayerSelection=10;
			b2=true;}

		if(b2){
			if(ItemInfoArray[PlayerSelection].effect==1){
				PlayerPriSelection=ItemInfoArray[PlayerSelection].weapon1;
				PlayerSecSelection=ItemInfoArray[PlayerSelection].weapon2;
			}else{
				PlayerPriSelection=0;
				PlayerSecSelection=0;
			}
			Zooming=false;
			
			
			if(WeaponInfoArray[PlayerPriSelection].accdelay==-1.0f){
				Player.inaccuracy=WeaponInfoArray[PlayerPriSelection].inaccfactor;
			}else{
				Player.inaccuracy=MonsterInfoArray[Player.type].ics*WeaponInfoArray[PlayerPriSelection].inaccfactor;
			}
			
			PrefsBeltTrans=PrefsMaxBeltTrans;
			if(PlayerInventory[PlayerSelection]<1)
				PlayerSelection=0;
			
			sprintf(TermText,"Selected %s",ItemInfoArray[PlayerSelection].name);
			PrefsTermTrans=1.0f;
		}
		if(keys[SDLK_LEFT] && Player.ts > 0-MonsterInfoArray[Player.type].mts){
			Player.ts-=MonsterInfoArray[Player.type].ta;
		}
		if(keys[SDLK_RIGHT] && Player.ts < MonsterInfoArray[Player.type].mts){
			Player.ts+=MonsterInfoArray[Player.type].ta;
		}
		if(keys[SDLK_SPACE] && Player.onground)
			Player.ys+=MonsterInfoArray[Player.type].jumpforce;
		if(Player.ts!=0.0f){
			ix=Player.xdir;
		}
		if(Player.onground||MonsterInfoArray[Player.type].canmoveoffground){
			if(MonsterInfoArray[Player.type].lateralpro){
				if(!keys['a'] && !keys['d']){
					if(keys['s']){
						f1=+(cos(Player.xdir*radians)*MonsterInfoArray[Player.type].ics);
						f2=-(sin(Player.xdir*radians)*MonsterInfoArray[Player.type].ics);
						pf1=+(cos(Player.xdir*radians)*MonsterInfoArray[Player.type].a);
						pf2=-(sin(Player.xdir*radians)*MonsterInfoArray[Player.type].a);
						Player.bobheightphase-=MonsterInfoArray[Player.type].bobspeed*speedfactor;
					}

					if(keys['w']){
						f1=-(cos(Player.xdir*radians)*MonsterInfoArray[Player.type].ics);
						f2=+(sin(Player.xdir*radians)*MonsterInfoArray[Player.type].ics);
						pf1=-(cos(Player.xdir*radians)*MonsterInfoArray[Player.type].a);
						pf2=+(sin(Player.xdir*radians)*MonsterInfoArray[Player.type].a);
						Player.bobheightphase+=MonsterInfoArray[Player.type].bobspeed*speedfactor;
					}
					if(keys['w'] || keys['s']){
						if(f1>0.0f){
							if(Player.zs+pf1<f1){
								Player.zs=Player.zs+pf1;}
						}else{
							if(Player.zs+pf1>f1){
								Player.zs=Player.zs+pf1;}}
						if(f2>0.0f){
							if(Player.xs+pf2<f2){
								Player.xs=Player.xs+pf2;}
						}else{
							if(Player.xs+pf2>f2){
								Player.xs=Player.xs+pf2;}}
						//Improve grip
						if(Player.zs>=sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*0.8f||Player.xs>=sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*0.8f||Player.zs<=-sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*0.8f||Player.xs<=-sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*0.8f){
							if(Player.zs<sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*1.4f&&Player.xs<sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*1.4f&&Player.zs>sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*-1.4f&&Player.xs>sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*-1.4f){
								Player.zs=-(cos(Player.xdir*radians)*MonsterInfoArray[Player.type].ics);
								Player.xs=(sin(Player.xdir*radians)*MonsterInfoArray[Player.type].ics);
							}
						}

					}
					
					
				}
			}else{
					if(keys['s']){
						f1=+(cos(Player.xdir*radians)*MonsterInfoArray[Player.type].ics);
						f2=-(sin(Player.xdir*radians)*MonsterInfoArray[Player.type].ics);
						pf1=+(cos(Player.xdir*radians)*MonsterInfoArray[Player.type].a);
						pf2=-(sin(Player.xdir*radians)*MonsterInfoArray[Player.type].a);
						Player.bobheightphase-=MonsterInfoArray[Player.type].bobspeed*speedfactor/2.0f;
					}

					if(keys['w']){
						f1=-(cos(Player.xdir*radians)*MonsterInfoArray[Player.type].ics);
						f2=+(sin(Player.xdir*radians)*MonsterInfoArray[Player.type].ics);
						pf1=-(cos(Player.xdir*radians)*MonsterInfoArray[Player.type].a);
						pf2=+(sin(Player.xdir*radians)*MonsterInfoArray[Player.type].a);
						Player.bobheightphase+=MonsterInfoArray[Player.type].bobspeed*speedfactor;
					}
					if(keys['w'] || keys['s']){
						if(f1>0.0f){
							if(Player.zs+pf1<f1)
								Player.zs=Player.zs+pf1;
						}else{
							if(Player.zs+pf1>f1)
								Player.zs=Player.zs+pf1;
						}
						if(f2>0.0f){
							if(Player.xs+pf2<f2)
								Player.xs=Player.xs+pf2;
						}else{
							if(Player.xs+pf2>f2)
								Player.xs=Player.xs+pf2;
						}
						//Improve grip
						/*if(Player.zs>=sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*0.8f||Player.xs>=sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*0.8f||Player.zs<=-sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*0.8f||Player.xs<=-sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*0.8f){
							if(Player.zs<sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*1.1f&&Player.xs<sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*1.1f&&Player.zs>sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*-1.1f&&Player.xs>sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs))*-1.1f){
								Player.zs=-(cos(Player.xdir*radians)*MonsterInfoArray[Player.type].ics);
								Player.xs=(sin(Player.xdir*radians)*MonsterInfoArray[Player.type].ics);
								//Player.zs=0.0f;
								//Player.xs=0.0f;
								
							}
						}*/


					}
			}
			//if(keys['d'])
				//Player.ydir-=0.1f;
			//if(keys['c'])
				//Player.ydir+=0.1f;
			if(keys['a'] && !keys['d']){
						f1=-(cos((Player.xdir-90.0f)*radians)*MonsterInfoArray[Player.type].ics);
						f2=+(sin((Player.xdir-90.0f)*radians)*MonsterInfoArray[Player.type].ics);
						pf1=-(cos((Player.xdir-90.0f)*radians)*MonsterInfoArray[Player.type].a);
						pf2=+(sin((Player.xdir-90.0f)*radians)*MonsterInfoArray[Player.type].a);
						if(!keys['w']&&!keys['2'])
							Player.bobheightphase+=MonsterInfoArray[Player.type].bobspeed*speedfactor;
			}
			if(keys['d'] && !keys['a']){
						f1=-(cos((Player.xdir+90.0f)*radians)*MonsterInfoArray[Player.type].ics);
						f2=+(sin((Player.xdir+90.0f)*radians)*MonsterInfoArray[Player.type].ics);
						pf1=-(cos((Player.xdir+90.0f)*radians)*MonsterInfoArray[Player.type].a);
						pf2=+(sin((Player.xdir+90.0f)*radians)*MonsterInfoArray[Player.type].a);
						if(!keys['w']&&!keys['2'])
							Player.bobheightphase+=MonsterInfoArray[Player.type].bobspeed*speedfactor;
			}
			if(keys['d'] || keys['a']){
				if(keys['d'] && keys['a']){}else{		//not a good way of doing things, fix this sometime
					if(f1>0.0f){
						if(Player.zs+pf1<f1)
							Player.zs=Player.zs+pf1;
					}else{
						if(Player.zs+pf1>f1)
							Player.zs=Player.zs+pf1;}
					if(f2>0.0f){
						if(Player.xs+pf2<f2)
							Player.xs=Player.xs+pf2;
					}else{
						if(Player.xs+pf2>f2)
							Player.xs=Player.xs+pf2;}
				}
			}
		}
	}
	//Set the (in)accuracy amount
	
	
	if(WeaponInfoArray[PlayerPriSelection].accdelay==-1.0f){
		Player.inaccuracy=WeaponInfoArray[PlayerPriSelection].inaccfactor;
	}else{
		gf=sqrt((Player.xs*Player.xs)+(Player.zs*Player.zs));
		if(Player.inaccuracy<gf*WeaponInfoArray[PlayerPriSelection].inaccfactor)
			Player.inaccuracy=gf*WeaponInfoArray[PlayerPriSelection].inaccfactor;
		else{
			if(WeaponInfoArray[PlayerPriSelection].accdelay==0.0f)
				Player.inaccuracy=gf;
			else
				Player.inaccuracy-=WeaponInfoArray[PlayerPriSelection].accdelay;
		}
	}
	if(Player.inaccuracy<WeaponInfoArray[PlayerPriSelection].accdelay||Player.inaccuracy<0.0f)
		Player.inaccuracy = 0.0f;
	
	if(Player.ydir<-85.0f)
		Player.ydir=-85.0f;
	if(Player.ydir>85.0f)
		Player.ydir=85.0f;


	return;
}

void DoMenus(){
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear Screen And Depth Buffer
	glLoadIdentity();
	glTranslatef(0.0f,0.0f,-1.0f);				// Move One Unit Into The Screen
	
	if(subscreen == 8){
		
		glColor3ub(colorarray[0][1][1],colorarray[1][1][1],colorarray[2][1][1]);
		
		glBegin(GL_QUADS);
			glVertex3f(-1.0f,-1.0f,-1.0f);
			glColor3ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1]);
			glVertex3f(-1.0f,1.0f,-1.0f);
			glColor3ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1]);
			glVertex3f(1.0f,1.0f,-1.0f);
			glColor3ub(colorarray[0][1][1],colorarray[1][1][1],colorarray[2][1][1]);
			glVertex3f(1.0f,-1.0f,-1.0f);
		glEnd();
		
		glColor3ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1]);
		gf=gf+0.0001f;
		glRasterPos2f(-0.4f, gf);
		glPrint("ENGINE/ZERO");
		glRasterPos2f(-0.4f, gf-0.03f);
		glPrint("Programming by: Lewis Hosie");
		glRasterPos2f(-0.45f, gf-0.06f);
		glPrint("Aka: Me!!, Me_43, Ascension[of]Chaos, AoC and Lewdude");
		glRasterPos2f(-0.45f, gf-0.09f);
		glPrint("(Underpants thief since October 2004)");
		glRasterPos2f(-0.45f, gf-0.12f);
		glPrint("Network Code by: Arlen Cuss");
		
		glRasterPos2f(-0.45f, gf-0.31f);
		glPrint("And, as seen on one of the early screen shots:");
		glColor3ub(255,0,0);
		glRasterPos2f(-0.4f, gf-0.34f);

		
		glPrint("THIS R0X0RZ Y0UR B0X0RZ!!");
		
	}
	
	
	
	
	return;
}
void DoTerminal(GLvoid){
	//Here we do the terminal/s

	
	
	return;
}

void DoColors(GLvoid){
	for(i=0;i<4;i++){
		if(pulsecolor[0]){
			//Text/Primary color
			if(colorarray[i][0][1] < colorarray[i][0][2])
				colorarray[i][0][1]++;
			if(colorarray[i][0][1] > colorarray[i][0][2])
				colorarray[i][0][1]--;
			if(colorarray[i][0][1] == colorarray[i][0][2])
				colorarray[i][0][2] = (rand()%128)+128;
		}
		if(pulsecolor[1]){
			//Background color
			if(colorarray[i][1][1] < colorarray[i][1][2])
				colorarray[i][1][1]++;
			if(colorarray[i][1][1] > colorarray[i][1][2])
				colorarray[i][1][1]--;
			if(colorarray[i][1][1] == colorarray[i][1][2])
				colorarray[i][1][2] = (rand()%254)+1;
		}
		
	}
	//Now make flashes fade out
	if(colorarray[4][2][0]>0){
		colorarray[4][2][0]-=FlashFadeSpeed;
	}
	if(colorarray[4][2][0]<=0){
		FlashMode=0;
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);  //Normal blending, if any.
	}
		//Color array for selections, interface, etc
				//RGBA/ColorNo(Selection=0,Background=1,Flash=2)/Normal(0) vs Target(1)

	return;
}


	int lphse=1;
	int lo=1;
	void DoLoadingScreen(void){
		subscreen++;
		if(lphse==1){
			if(subscreen>=2&&lo>0){
				lo=LoadTexture(lo);
				subscreen=0;
			}
			if(lo==0){
				lphse=2;
				subscreen=0;
				lo=1;
				fprintf(stderr,"Loading sounds.\n");
			}

		}
		if(lphse==2){
			if(subscreen>=2&&lo>0){
				fprintf(stderr,"Loading sound %i.\n",lo);
				lo=LoadSound(lo);
				subscreen=0;
			}
			if(lo>=SoundArraySize){
				lphse=3;
				subscreen=0;
				lo=0;
				sprintf(TermText,"Building Display List 1");
				fprintf(stderr,"Building display lists.\n");
			}
		}
		if(lphse==3){
			if(subscreen>=5&&lo<=SequenceArraySize){
				fprintf(stderr,"Building list %i.\n",lo);
				BuildList(lo);
				lo++;
			}
			if(lo>SequenceArraySize){
				fprintf(stderr,"Loading map.\n");
				LoadMap(CurrentLevel);
				ChooseLandscape();


				currentscreen=1;
				subscreen=0;
				isloaded=true;
				sprintf(TermText,"Finished loading");
				fprintf(stderr,"Finished loading.\n");
			}
		}
		glLoadIdentity();									// Reset The Current Modelview Matrix
		glTranslatef(0.0f,0.0f,-1.0f);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],(colorarray[3][0][1]*PrefsTermTrans)+2);
		
		glRasterPos2f(-0.30f, 0.0f);
		glPrint(TermText);

		if(lphse==1&&lo>1){
			glEnable(GL_TEXTURE_2D);
			glLoadIdentity();
			glColor4ub(255,255,255,255);
			glTranslatef(1.0f,-1.4f,-6.0f);
			glBindTexture(GL_TEXTURE_2D,BitmapArray[lo-1]);
			glBegin(GL_QUADS);
				glTexCoord2f(0.0f,0.0f); glVertex3f(-1.0f,-1.0f,0.0f);
				glTexCoord2f(1.0f,0.0f); glVertex3f(1.0f,-1.0f,0.0f);
				glTexCoord2f(1.0f,1.0f); glVertex3f(1.0f,1.0f,0.0f);
				glTexCoord2f(0.0f,1.0f); glVertex3f(-1.0f,1.0f,0.0f);
			glEnd();
			glDisable(GL_TEXTURE_2D);
		}
		if(lphse==3&&lo>1){
			glPolygonMode(GL_BACK, GL_LINE);
			glPolygonMode(GL_FRONT, GL_LINE);


			glLoadIdentity();
			glColor4ub(255,255,255,255);
			glTranslatef(1.0f,-1.4f,-6.0f);

			glCallList(SequenceArray[lo-1].lists[1].thelist[PrefsFramesSkipFactor]);
			

			glPolygonMode(GL_BACK, GL_FILL);
			glPolygonMode(GL_FRONT, GL_FILL);

		}
		sprintf(TermText,"");

	}