#ifndef E0H
#define E0H

//#define MACOSX
//#define LINUX
//#define WIN32		//This should be auto defined anyway
//#define USEGLAUX
#define USE_SDL_IMAGE
#define userastafont

#ifdef _MSC_VER
#pragma warning(disable:4244 4305)  // for VC++, no precision loss complaints
#endif

#pragma comment(lib, "SDL.lib")
#pragma comment(lib, "SDL_net.lib")
#pragma comment(lib, "SDLmain.lib")
#pragma comment(lib, "GLU32.lib")
#pragma comment(lib, "GLUT32.lib")
#pragma comment(lib, "GLAUX.lib")
#pragma comment(lib, "OPENGL32.lib")
#pragma comment(lib, "SDL_mixer.lib")
#pragma comment(lib, "SDL_image.lib")


#ifdef WIN32
	#include <Windows.h>
	#include "SDL_syswm.h"
	#ifdef USEGLAUX
		#include <gl/glaux.h>
		#pragma comment(lib, "GLAUX.lib")
	#endif
#endif
//#include <SDL_net.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/////////
// These are optional; added for MP3 support only.
// If they're causing trouble, just comment them out.
// Edit: Doesn't work... can't do any harm to remove them
// Just use OGG
//#include <smpeg.h>
//#pragma comment(lib, "smpeg.lib")
/////////

//#include <cstdarg>
//#include <GLUT/glut.h>
#ifdef MACOSX     //MacOSX has an oddish rand function
	#include <OpenGL/gl.h>
	#include <OpenGL/OpenGL.h>
	#include <OpenGL/glu.h>
	#include <OpenGL/glut.h>
	/*#include <SDL/SDL.h>
	#include <SDL/SDL_image.h>
	#include <SDL/SDL_mixer.h>
	#include <SDL/SDL_audio.h>*/
	//Switched to because I use Fink (occasionally, fools). Subject of ridicule
	#include </sw/include/SDL/SDL.h>
	#include </sw/include/SDL/SDL_image.h>
	#include </sw/include/SDL/SDL_mixer.h>
	#include </sw/include/SDL/SDL_audio.h>
#else
	#include <GL/glut.h>
	#include <GL/gl.h>
	#include <GL/glu.h>
	#include <SDL.h>
	#include <SDL_mixer.h>
	#include <SDL_audio.h>
	#ifndef USEGLAUX
		#include <SDL_image.h>
	#endif
#endif



// Welcome to Hell.

#define LinesPerPoly 8
#define pie 3.1415926539f
#define radians pie/180.0f 		//The piece of sh!t maths lib takes radians, yeah *they're* cool, not
#define degrees pie*180.0f
#define appversion "Engine/Zero Prerelease 0.0"			// Set The App Name And Version
#define Player MonsterArray[0]
#define ParticleArraySize 9999
#define ParticleInfoArraySize 500
#define MaxShotArraySize 1024
#define SolidArraySize 500
#define FlashArraySize 500
#define rand() (rand()%65536)		//Unix has a different RAND_MAX or whatever it is.

//#define modelformatobj
#define modelformatmeshwork
//#define modelformat3dmf


//Declare the 'texture' structure
class texture{		
	public:
					int bmpnumber;
					int maskbmpnumber;
					float xoffset;
					float yoffset;
					float xstretch;
					float ystretch;
					int transfer;
					float transfervar1;
					float transfervar2;
				};

class lighttype{
	public:
					bool SecPhase;
					bool Active;
					float Pos;
					int CurR; //Current red brightness
					int CurG;
					int CurB;
					
					int ActPriSpd;
					int ActSecSpd;
					int InActPriSpd;
					int InActSecSpd;
					
					int ActSecMode;
					int ActPriMode;
					int InActSecMode;
					int InActPriMode;
					
					int ActPriBriR;
					int ActSecBriR;
					int ActPriBriG;
					int ActSecBriG;
					int ActPriBriB;
					int ActSecBriB;
					
					int InActPriBriR;
					int InActSecBriR;
					int InActPriBriG;
					int InActSecBriG;
					int InActPriBriB;
					int InActSecBriB;
					
					int ActPriDel;
					int ActSecDel;
					int InActPriDel;
					int InActSecDel;
					
					int CurrentDelta;
					int CurrentFDelta;
				};

//Declare the 'line' structure
class linet {
	public:
					float x;
					float y;
					float x2;
					float y2;
					bool shared;
					bool used;
					bool drawn;
					bool unique;
					bool enableptest;
					int primarytexture;
					int secondarytexture;
					int tertiarytexture;
					int primarylight;
					int secondarylight;
					int tertiarylight;
					int user1;
					int user2;
					float ytexoffset1;
					float ytexoffset2;
			};

//And now the all-important polygon structure
class polyt{		
	public:
					int lines[LinesPerPoly];
					int links[LinesPerPoly];
					bool valid;
					int floorlink;
					int ceilinglink;
					int floortexture;
					int ceilingtexture;																				// YOU'RE A GERMAN!! I AM MR. WRIGHT!! Oh wait, no I'm not
					float ceilingheight;
					float floorheight;
					float centerx;
					float centery;
					float highestpointdist;
					int ceilinglight;
					int floorlight;
					int media;
			};

//model point
class tobjpoint{
	public:
					float x;
					float y;
					float z;
				};
//Poly/element/normal
class tobjpoly{
	public:
					int opoint[4];
					int normal;
				};
class shottype{
	public:
					float x;
					float y;
					float z;
					float xs;
					float ys;
					float zs;
					int beamno;
					int origin;
					int type;
					int polyparent;
					int target;
					float xdir;
					float ydir;
					float zdir;
					bool frameinter;
					float curspeed;
					int frame;
					int age;
					float frametimer;
					bool penetratesliquidboundary;
					float transsidehitchance;

					void turntopoint(float nx, float ny, float nz);
				};
class shotinfotype{
	public:
					float speed;
					float grav;
					int damage;
					
					bool instant;
					bool guided;
					int target;
					int sequence;
					int skin;
					float radius;
					float disruption;
					float knock;
					float turnspeed;
					bool inclusivehits;
					bool flat;
					bool intercol;
					int flash;
					bool sharp;
					int lifetime;
					int particle;
					int noofparticles;
					int deathparticle;
					int noofdeathparticles;
					int deathsound;
				};
class weaponinfotype{
	public:
					float xo;
					float yo;
					float zo;
					bool wauto;
					bool seperatedelays;
					bool zooms;
					bool leeches;		// <- =uses same ammo as primary trigger WHEN SECONDARY
					bool charges;		//unimplemented
					bool hideammo;		//un done too
					int wot;
					int clipsize;
					int ammotype;
					float inaccfactor;
					int rate;
					int reps;
					float accdelay;
					float kick;		//Weapon kick upwards
					float recoil;		//Weapon kick backwards
					float knock;		//Weapon knock backwards
					float zoomfactor;
					int shotsound;
					int shotparticle;
					int noofshotparticles;
					int shotspershot;		//...I'm an idiot.

					int idlesequence;
					int shootsequence;
					int reloadsequence;
					float frametimer;
					int frame;
					int sequence;
					int skin;

				};
class itemtype{
	public:
					//Instance info
					float x;
					float y;
					float z;
					float direction;
					int polyparent;
					int type;
					int model;
					int nextmodel;
					int crosshairtype;
					float curspeed;
					char name[255];
					float ys;

					//int parameter1;
					//int parameter2;
					int frame;
					
					//Type info
					float frametimer;
					int sequence;
					int skin;
					int weapon1;
					int weapon2;
					int max;		//max carryable
					int effect;
					int invgraphic;
					bool seperatetriggers;
					float grav;
				};
// A monster/player structure
class monstertype{	
	public:
					//Direction variables
					float xdir;			//X Direction (Left/Right)
					float ydir;			//Y Direction (Up/down)
					float zdir;			//Z Direction (Anti-clockwise/Clockwise)
					float oxdir;			//Original X Direction (ie. for knock/shellshock)
					float oydir;			//Original Y Direction
					float ozdir;			//Original Z Direction (!used currently)
					
					//Position variables
					float x;				//X Position
					float y;				//Y Position
					float z;				//Z Position
					float xs;				//X Speed
					float ys;				//Y Speed
					float zs;				//Z Speed
					float ts;				//Turning Speed	
					
					bool tisobj;			//Is the target an object or a poly?
					float tx;				//Target's X Position
					float ty;				//Target's Y Position
					float tz;				//Target's Z Position
					float td;				//Direction the current target is in

					bool onground;			//Is it currently on the ground? Or in the air?	
					int knocktimer; 	//Knock/shellshock timer
					float bobheightphase;	//Head bobbing current phase
					float inaccuracy;	//Determines the (in)accuracy due to movement
					int type;
					int polyparent;
					float wep1timer;
					float wep2timer;
					int wep1;
					int wep2;
					int health;
					int cursequence;
					int curaction;
					int frame;
					int repsleft;
					int target;
					int nearestpoly;	//other than the one we're in dumbarse. This isn't updated much at all
					float frametimer;
					float curspeed;
					bool frameinter;
					float shotdelay;
					float shotdelay2;
					float oxygen;
					bool killflag;		//Flag to kill the fag
					bool visible;

					void facepoint(float nx, float ny, float nz);
					void turntopoint(float nx, float ny, float nz);
					void findnewtarget(void);
					void walkfowards(void);
					void shoot(int theobject, int wep, bool sec);
				};
class monsterinfotype{
	public:
					char name[128];
					float ta;				//Turn Accel Rate			
					float mts;			//Maximum Turning Speed
					float td;				//Turning Deacceleration Speed
					
					float a;				//Acceleration Rate
					float va;				//Vertical Acceleration Rate (Aka. Gravity)
					float ics;			//Maximum Controlled Speed
					float mas;			//Maximum Absolute Speed
					float ad;				//Absolute deacceleration (Much easier than directional)
					float aad;            //Abs. De-accel when in midair
					float radius;			//How wide is the object? (Detections are cylindrical)
					float height;			//How tall is the object?
					float camheight;		//Camera height
					float jumpforce;		//How high can it jump, if at all?
					float stepheight;		//What's the biggest step it can climb?
					float stepforce;		//What force should be applied to climb steps?
					float mass;			//Duuuh. Mass.
					float forcemultiplier;	//Higher = knocked around more easily
					float itemradius;		//How far away you can pick up items from... best is about rad*1.2

					bool lateralpro;		//Does it have lateral protection? (a la Counter-Strike)
					bool bunnyhoppro;		//Does it have bunnyhop protection?
					bool isplayer; 			//Is it a player/bot? (Multiplayer only)
/******************/bool flies;/************///THIS IS USELESS, MSVC++ bug compensation >:@
					bool flying;				//Can it fly? [NPC only at the moment]
					int aitype;				//Is it computer controlled? In what way?
					bool bouncecol;			//Uses bouncy physics? (Dodgey)
					bool canmoveoffground;
					bool bridge;		//Can you stand on it?
					bool immovable;		//Is it un-moveable?
					float bobspeed;
					float maxbobheight;	//Head/View bobbing max height
					bool solid;
					int sequence[20];
					int skin;
					int corpse;				//What corpse does it leave?
					int objclass;			//Is it a BoB? Pfhor? etc

					int weapon1;
					int weapon2;
					float range1;
					float range2;
					int hesitation1;
					int hesitation2;
					
					int hurtparticle;
					int noofhurtparticles;

					int startinghealth;				//How tough is it?
					
					int deathsound[FlashArraySize];
					int hitsound[FlashArraySize];
					int deathsequence[FlashArraySize];
					
					float damagefactor[FlashArraySize];
					int sharphitparticletype;
					int sharphitparticleno;
					int item;
					bool friendly;		//For AI.
				};
class pointtype{
	public:
					float x;
					float y;
					float z;
				};
class liststype{
	public:
					GLuint *thelist;
				};
class sequencetype{
	public:
					int frames;
					char frame[128][255];
					float scale[128];
					float xoffset[128], yoffset[128], zoffset[128];
					float xrot[128], yrot[128], zrot[128];
					int speed[128];
					bool inter[128];   //Is the frame interpolated?
					bool ignore[128];         //If interpolating, ignore poly order? (enable if using straight Meshwork files)
					liststype lists[128];		//Display lists holding the frames
					int criticalframe;		//Which frame are attacks carried out at?
				};
class normaltype{
	public:
					float x;
					float y;
					float z;
				};
class texcoordtype{
	public:
					float u;
					float v;
				};
class edgetype{
	public:
					int point[2];
				};
class facetype{
	public:
					int point[3];
					int normal[3];
					int texcoord[3];
				};
class modeltype{
	public:
					facetype FaceArray[6000];
					texcoordtype TexcoordArray[6000];
					normaltype NormalArray[6000];
					pointtype PointArray[6000];
					edgetype EdgeArray[6000];
					int FaceArraySize;
					int TexcoordArraySize;
					int NormalArraySize;
					int PointArraySize;
				};
class flashtype{
	public:
					int r;
					int g;
					int b;
					int a;
					int fadespeed;
					int mode;
				};
class particletype{
	public:
					float x,   y,   z;	//Position
					float x2,  y2,  z2;	//Other point - for lines.
					float xs,  ys,  zs;	//Speed
					float xr,  yr,  zr;	//Rotation
					float xrs, yrs, zrs;	//Rotation speed
					int type;
					int parent;
					float life;
					int startlife;
					int opupdate;
				};
class particleinfotype{
	public:
					float trans;
					float speed;
					float spin;
					float grav;
					float bounce;
					float bouncedelta;
					int model;
					int mode;
					int lifespan;
					int r, g, b;	//Color
				};
class platformtype{
	public:
					float thickness;		//Minus one is floor to ceiling
					float risespeed;		//How quickly does it rise?
					float fallspeed;		//How quickly does it fall?
					float highestfloor;
					float lowestfloor;
					float highestceiling;
					float lowestceiling;
					float floorposition;
					float ceilingposition;
					float timer;			//How long left to wait before movement
					int poly;
					int apexisrelative;		//Does the roof follow the floor?
					int actbytag;			//What tag is it activated by?
					int tagact;				//What tag does it activate?
					int apexdelay;			//How long to wait when at the apex
					int nadirdelay;			//How long to wait when at the nadir
					int texture[7];			//What textures do the edges of the platform have?
					int parent;				//If activated by another platform, which one?
					bool floorrising;
					bool ceilingrising;
					bool delayed;
					bool active;			//Is it moving?
					bool cap;				//Can't Activate Parent
					bool actadj;			//Activates adjacent platforms
				};
class solidtype{
	public:
					int texture;
					int light[3];
					float x[3], y[3], z[3];
				};
class ambientsoundtype{
	public:
					float volume;
					float x, y, z;
					int thesound;
					int volumelight;	//0 = none
					bool obstructable;
				};
class soundtype{
	public:
					Mix_Chunk *TheSound;
					int Alts[32];
					int NoOfAlts;
				};
class mediatype{
public:
					int damage;
					int damagetype;
					int texture;
					int texturemask;
					int lightbase;
					int light;
					float current;
					float currentdir;
					float apex;
					float nadir;
					float oxygendrain;
					float curlevel;
				};

//------------VARIABLE DEFINITIONS------------------------------------------------------

extern bool	active;		// Window Active Flag Set To TRUE By Default
extern bool	fullscreen;	// Yes, windowed mode sucks.



//For finding FPS count
extern GLint T0;
extern GLint Frames;

//Temp data and loop integers
extern int i, i2;
extern float gf;
//I shouldn't make these global... but it's just so much easier

extern int inputmode;								//Input mode. 0 == local. 1 == demo. 2 == network.
extern float colorarray[4][3][2];				//Color array for selections, interface, etc
				//RGBA/ColorNo(Selection=0,Background=1)/Normal(0) vs Target(1)
extern bool pulsecolor[2];

//Misc data
extern bool	keys[256];						// Array used for the keyboard routines

extern int currentscreen, subscreen;	// Holds the screen/subscreen we're at 
extern float pulsetimer;

//Level definitons

extern mediatype MediaArray[200];
extern int MediaArraySize;


extern weaponinfotype WeaponInfoArray[300];
extern int WeaponInfoArraySize;

extern monsterinfotype MonsterInfoArray[250];
extern int MonsterInfoArraySize;

extern flashtype FlashArray[FlashArraySize];



//For graphics (beams) - Don't be fooled, this does NOT
//mean you can only have one beam onscreen at once.
extern float hitpointx, hitpointy, hitpointz;

						//You'd be *amazed* how quickly you can go
extern particletype ParticleArray[ParticleArraySize+1];	//through 5000 particles...
extern particleinfotype ParticleInfoArray[ParticleInfoArraySize+1];

extern monstertype MonsterArray[1000];
extern int MonsterArraySize;

extern polyt PolygonArray[10000];					//The Holy Polygon Array
extern int PolygonArraySize;					//And it's size definition

extern linet LineArray[10000];							//The Line Array.
extern int LineArraySize;							//And it's size definition

extern texture *TextureArray;			//The texture array holds texture info
extern int TextureArraySize;

extern GLuint StaticTextures[32];


extern GLuint *BitmapArray;			//Whereas the bitmap array hold the actual graphics
extern int BitmapArraySize;
extern int CustomBitmapArraySize;

extern Mix_Music *TheMusic;

extern soundtype *SoundArray;
extern int SoundArraySize;

extern lighttype LightArray[150];
extern int LightArraySize;

extern itemtype ItemInfoArray[250];
extern int ItemInfoArraySize;

extern itemtype ItemArray[250];
extern int ItemArraySize;

extern shottype ShotArray[MaxShotArraySize];
extern int ShotArraySize;

extern sequencetype SequenceArray[1000];
extern int SequenceArraySize;

extern shotinfotype ShotInfoArray[1000];
extern int ShotInfoArraySize;

extern solidtype SolidArray[SolidArraySize];

extern bool TagArray[500];				//Yep. FIVE HUNDRED TAGS. Got to wonder who would use them...
extern bool InterLevelTagArray[100];	//...
extern int InterLevelIntArray[100];

extern platformtype *PlatformArray;
extern int PlatformArraySize;

extern char PlayerName[255];
extern int PlayerInventory[500];
extern int WeaponAmmo[100];
extern int PlayerPriSelection;
extern int PlayerSecSelection;
extern int PlayerSelection;

extern char ScenarioName[255];
extern char ScenarioGraphicsType[255];
extern char CurrentSong[255];

extern pointtype ModelPointArray[50][1500];
extern pointtype ModelNormalArray[50][500];
extern facetype ModelPolyArray[50][1500];
extern edgetype ModelEdgeArray[50][1500];

//float radians

extern SDL_CD *cdrom;		//Used to access music from a CD

extern int FlashMode;
extern int FlashFadeSpeed;

extern int ShotNo;     //which screenshot we're up to

extern bool XRayVision;	
extern bool NightVision;
extern bool ScanVision;
extern bool Zooming;
extern float ZoomAmount;

////////////////////////////////////////////////

extern char	TermText[255];
extern int		TermEditPoint;

extern char	ObjectiveList[32][255];
extern bool	ObjectiveComplete[32];
extern bool	ShowObjectives;
extern int		ObjectiveLink[32];
extern int		NoOfObjectives;


// For displaying
/*extern int		PolyList[500];
extern int		PolyListSize;
extern int		PolyDepth[500];*/
extern int		Trans;

extern char	ScenarioDir[255];

//Level info variables
extern int	CurrentLevel;
extern char	LevelName[255];				//Level info - author
extern char	LevelAuthor[255];				//Level info - author
extern char	LevelDateCompleted[255];		//Level info - date completed
extern char	LevelComments[255];			//Level info - author's comments
extern float TheLight[];
extern int PolysToVisit[32];
extern int LastVisit;

extern bool	LButtonDown;
extern bool	MButtonDown;
extern bool	RButtonDown;

//Controls
extern bool			PrefsInterpolateMouse;		//Smooths mouse motions, giving an effect some people love and other hate.
extern bool			PrefsInvertMouse;			//Flips mouse on Y axis
extern bool			PrefsUseMouse;				//Using the mouse at all?

//Preference variables

extern int				PrefsBeltSize;			//How big is the on-screen inventory 'belt'?
extern float			PrefsMaxBeltTrans;		//Usual Belt Transparency Factor
extern float			PrefsBeltTrans;		//Belt Transparency Factor
extern bool			PrefsHideBelt;
extern bool			PrefsMinimalInterface;

extern float			PrefsTermTrans;		//Term Transparency Factor
//Stupid (Don't touch these)

//Crosshair
extern float 		PrefsCrosshairHeight;		//Pref - Crosshair Height
extern float 		PrefsCrosshairWidth;		//Pref - Crosshair Width
extern int 			PrefsCrosshairThickness;		//Pref - Crosshair Thickness

//Graphics
extern bool			PrefsMipMapping;				//MIPmapping enabled?
extern bool			PrefsParticleFX;				//Particles enabled?
extern bool			PrefsFarLinearFiltering;		//Pref - Linear or nearest filtering for distant objects?
extern bool			PrefsNearLinearFiltering;	//Pref - Linear or nearest filtering for close objects?
extern bool			PrefsBetterPerspective;		//Pref - Use Nicest perspective correction?
//bool			PrefsAdditiveAlpha;			//Pref - What mode of transparency? Now rarely set to additive
extern int bitdepth, screenwidth, screenheight;
//bool			PrefsE0Lighting;				//Pref - New or Marathon style lighting?
extern bool			Prefs3rdPerson;				//3rd person view?
extern bool			PrefsShowFPS;				//Count the frames per second?
extern bool			PrefsCompensativeSpeed;		//Constant speed? (Only enable if PrefsFrameSkipFactor is 1)
extern bool			Prefs3DMap;					//3D Map?
extern bool			PrefsShowPosition;			//
extern float		PrefsViewDistance;

extern int			PrefsFramesSkipFactor;			//Frame skipping factor ( 1 is normal, increase to cut load times but make animations look worse)
extern int			PrefsGameDelay;				//Controls game speed
extern bool			PrefsNostalgiaMode;
extern bool			PrefsText;

//Noise
extern bool			PrefsCDMusic;				//Play music from a CD if available?

//Control
extern float 		PrefsMouseSens;

//Setup our booleans
#ifndef true
	#define true  1
	#define false 0
#endif
#ifndef TRUE
	#define TRUE  1
	#define FALSE 0
#endif
// The SDL surface
extern SDL_Surface *surface;


extern int landscapeno;
extern float speedfactor;
extern long int noofframes;
extern bool	isloaded;

//----------Function/Sub Declarations---------------------------------
//Shell and housekeeping
void Quit(int returnCode);
int GameInit(GLvoid);

int resizeWindow(int width, int height);
void handleKeyPress(SDL_keysym *keysym);
void handleKeyRelease(SDL_keysym *keysym);
int main(int argc, char **argv);

//Graphics & Menus
int initGL(GLvoid);
void DoTerminal(GLvoid);								//Declare DoTerminal (This is *NOT* the same as the ingame info terms)
void DoHud(GLvoid);										//Wonder what this is? Guh
void DoColors(GLvoid);									//Woo. Colors.
void DoCrosshairs(GLvoid);								//Crosshairs. Amazingly long code for something so simple
int CreateParticles(int type, int number, float x, float y, float z, int parent);
void DrawMap(void);
void DrawNormally(void);									//Draw the polies in the list. As above
int DrawGLScene(GLvoid);  								//Declaration for DrawGLScene
void DoAnimations(void);
void ChooseLandscape(void);

void BuildList(int thelist);

void DoMenus(GLvoid);									//Declare DoMenus
SDL_Surface *SDL_ConvertForGL(SDL_Surface *s, bool want_alpha);
int SDL_InvertSurface(SDL_Surface* image);
int invert_image(int pitch, int height, void *image_pixels);
void SDL_PutPixel(SDL_Surface *surface, int x, int y, Uint32 pixel);

//Files
int LoadPhysics(int thefile);
int LoadSequences(int thefile);
int LoadPrefs(void);
int LoadShape(int model); 
GLuint EmptyTexture();							//Declare function to make an empty texture
//int LoadASound(const char filepath[], ...);
int PreprocessASound(const char filepath[], ...);
int LoadScenario(int scen);
int LoadMap(int themap);
void ProcessLine(const char linedata[], ...);
void ValidateMap(int themap);
int LoadCustomTexture(char* filepath, int thetexture);
int LoadTexture(int thetexture);
int LoadSound(int thesound);
void PreprocessTexture(int thetexture);
void ReadLine(FILE *f,char *string);					//Declare ReadLine. Duhhhh
void ReadMeshLine(FILE *f,char *string);				//Used for loading Mesh and 3dmf files. Carriage-return independant.
void BuildStaticTextures(void);
void CleanUp(void);

//Physics & game logic
void DoAI(GLvoid);  									//Declaration for DoAI
void DoPhysics(GLvoid);  								//Declaration for DoPhysics
void DoInput(GLvoid);  									//Declaration for DoInput
bool TestObjectYThingy(int i, int parent);
void TestShotCol(void);
void DestroyShot(int theshot, bool makeparticles);
void ObjectShoot(int theobject, int wep, bool sec);

//Sounds
void DoSounds(GLvoid);  								//Declaration for DoSounds
void PlayASound(int thesound);
void SetupSounds(void);
int LoadAndPlaySong(const char thefile[]);
void PlayASound(int thesound);


///TEMP!!
float APx, APy;
float APx2, APy2;

#endif
