#include "e0main.h"

//Level
int LastFoundPoint = 1, LastFoundPoly = 1, LastFoundTexture = 1;
int LastFoundLight = 1, LastFoundItem = 1, LastFoundEnemy = 1;
int LastFoundMedia = 1, LastFoundSound = 1, LastFoundAltSound = 1;
int LastFoundPlatform = 1, LastFoundGoal = 1;
//Physics
int mtype=1, lwtype=1, ltype=1;
int litype=1,lqtype=1,lftype=1;
int lqframe=1, lptype=1, currentseq=1;

void CleanUp(void){
	LastFoundPoint = 1; LastFoundPoly = 1; LastFoundTexture = 1;
	LastFoundLight = 1; LastFoundItem = 1; LastFoundEnemy = 1;
	LastFoundMedia = 1; LastFoundSound = 1; LastFoundAltSound = 1;
	LastFoundPlatform = 1; LastFoundGoal = 1;

	mtype=1; lwtype=1; ltype=1;
	litype=1;lqtype=1;lftype=1;
	lqframe=1; lptype=1; currentseq=1;

	for(i=0;i<LineArraySize;i++){
		LineArray[i].used=false;	LineArray[i].shared=false;
	}
	for(i=0;i<PolygonArraySize;i++){
		PolygonArray[i].centerx=0.0f;	PolygonArray[i].centery=0.0f;
	}
	for(i=0;i<MonsterArraySize;i++){
		MonsterArray[i].health=0;	MonsterArray[i].type=0;
	}
	MonsterArraySize=0;	ItemArraySize=0;	ShotArraySize=0;
	LineArraySize=0;	PolygonArraySize=0;

	/*delete PolygonArray;
	delete LineArray;
	delete MonsterArray;
	delete ItemArray;
	delete TextureArray;
	delete MediaArray;
	delete PlatformArray;
	delete LightArray;*/

//Do more cleanup here.





}
int LoadMap(int themap){
	FILE *fptr;
	char linedata[255];
	char filepath[255];
	int li = 0;
	int i3=0;
	GLfloat fi[12];
	
	//Check this for breakingness!!
	LastFoundPoint=1;	LastFoundPoly=1;	LastFoundTexture=1;	LastFoundLight=1;
	LastFoundItem=1;	LastFoundEnemy=1;	LastFoundMedia=1;	LastFoundSound = 1; 
	LastFoundAltSound=1;LastFoundGoal=1;

	sprintf(filepath,"%s/Map%i.txt",ScenarioDir,themap);
	
	if((fptr = fopen(filepath, "rt"))==NULL){       //Open filestream
		fprintf(stderr,"Can't open map file %s.\n",filepath);
		return 1;
	}
	fprintf(stderr,"Opening map file.\n");
	do{
		i++;
		ReadLine(fptr,linedata);
		//read author, date, comments sometime
		if(sscanf(linedata, "author %s\n", &LevelAuthor))
			for(li=0;li<255;li++)
				if(LevelAuthor[li]=='_')
					LevelAuthor[li]=' ';
		if(sscanf(linedata, "name %s\n", &LevelName))
			for(li=0;li<255;li++)
				if(LevelName[li]=='_')
					LevelName[li]=' ';

		ProcessLine(linedata);
		

		
		}while(linedata[0]!='f');
	fclose(fptr);		//Close filestream.
	for(i=0;i<PolygonArraySize;i++){
		for(i2=0;i2<LinesPerPoly+1;i2++){
			//LineArray[PolygonArray[i].lines[i2]].unique=true;
			if(!LineArray[PolygonArray[i].lines[i2]].used){
				LineArray[PolygonArray[i].lines[i2]].used=true;
				LineArray[PolygonArray[i].lines[i2]].user1=i;
				
			}else{
				if(LineArray[PolygonArray[i].lines[i2]].user1!=i){
					LineArray[PolygonArray[i].lines[i2]].shared=true;
					LineArray[PolygonArray[i].lines[i2]].user2=i;
				}
			}
		}
		for(i2=0;i2<LinesPerPoly+1;i2++){
			if(LineArray[PolygonArray[i].lines[i2]].user1==i)
				PolygonArray[i].links[i2]=LineArray[PolygonArray[i].lines[i2]].user1;
			else
				PolygonArray[i].links[i2]=LineArray[PolygonArray[i].lines[i2]].user2;
		}
		
		for(i2=0;i2<LinesPerPoly;i2++){
			fi[i2]=LineArray[PolygonArray[i].lines[i2]].x;
			fi[i2+LinesPerPoly]=LineArray[PolygonArray[i].lines[i2]].x2;
		}
			
		for(i2=0;i2<LinesPerPoly;i2++){
			if(PolygonArray[i].lines[i2]<=0)
				i2=LinesPerPoly;
			else{
				i3=i2+1;
				PolygonArray[i].centerx+=fi[i2];
				PolygonArray[i].centerx+=fi[i2+LinesPerPoly];
			}
		}
		PolygonArray[i].centerx=PolygonArray[i].centerx/(i3*2);
		
		
		for(i2=0;i2<LinesPerPoly;i2++){
			fi[i2]=LineArray[PolygonArray[i].lines[i2]].y;
			fi[i2+LinesPerPoly]=LineArray[PolygonArray[i].lines[i2]].y2;
		}
			
		for(i2=0;i2<LinesPerPoly;i2++){
			if(PolygonArray[i].lines[i2]<=0)
				i2=LinesPerPoly;
			else{
				i3=i2+1;
				PolygonArray[i].centery+=fi[i2];
				PolygonArray[i].centery+=fi[i2+LinesPerPoly];
			}
		}

		/*for(i2=0;i2<LinesPerPoly;i2++){
			GLfloat x=LineArray[PolygonArray[i].lines[i2]].x, y=LineArray[PolygonArray[i].lines[i2]].y, x2=LineArray[PolygonArray[i].lines[i2]].x2, y2=LineArray[PolygonArray[i].lines[i2]].y2;
			GLfloat td=sqrt(((x2-x)*(x2-x))+((y2-y)*(y2-y))), dir=asin((x/td)/degrees);
			for(i3=0;i3<LinesPerPoly;i3++){
				GLfloat ax=LineArray[PolygonArray[i].lines[i3]].x, ay=LineArray[PolygonArray[i].lines[i2]].y, ax2=LineArray[PolygonArray[i].lines[i2]].x2, ay2=LineArray[PolygonArray[i].lines[i2]].y2;
				GLfloat atd=sqrt(((ax2-ax)*(ax2-ax))+((ay2-ay)*(ay2-ay))), adir=asin((ax/atd)/degrees);
				
				if(dir==adir){
					LineArray[PolygonArray[i].lines[i3]].enableptest=true;
					LineArray[PolygonArray[i].lines[i2]].enableptest=true;
				}
			}
		}*/

		PolygonArray[i].centery=PolygonArray[i].centery/(i3*2);

			

		
	}
	for(i=0;i<MonsterArraySize;i++){
		if(MonsterArray[i].health==0)
			MonsterArray[i].health = MonsterInfoArray[MonsterArray[i].type].startinghealth;
		MonsterArray[i].oxygen=1.0f;
	}
	for(i=0;i<TextureArraySize;i++){
		if(TextureArray[i].bmpnumber<0)
			TextureArray[i].bmpnumber=BitmapArraySize-TextureArray[i].bmpnumber;
	}

	for(i=1;i<PlatformArraySize+1;i++){
		PlatformArray[i].floorposition=PlatformArray[i].highestfloor;
		PlatformArray[i].floorrising=false;
		PlatformArray[i].ceilingrising=true;
		PlatformArray[i].ceilingposition=PlatformArray[i].lowestceiling;
	}

	return 1;
}

void ReadLine(FILE *f,char *string)					// Read In A String
{
	do								// Start A Loop
	{
		fgets(string, 255, f);	// Read One Line
	} while ((string[0] == '#') || (string[0] == ';') || (string[0] == '\n')|| (string[0] == 9) || (string[0] == 10));	// See if it's a comment or null
}

void ValidateMap(int themap){
	char filepath[255];
	FILE *fptr;
	char linedata[255];
	int li = 0;
	GLfloat fi[12];
	int ti;
	int LargestCustomTex=0;
	
	sprintf(filepath,"%s/Map%i.txt",ScenarioDir,themap);
	if((fptr = fopen(filepath, "rt"))==NULL){       //Open filestream
		fprintf(stderr,"Can't validate map file %s.\n",filepath);
		return;
	}
	fprintf(stderr,"Validating map file.\n");
	/*	if(sscanf(linedata, "ctex %i %s\n",&tmp2, &tmp)){
		CustomBitmapArraySize = BitmapArraySize+tmp2;
		LoadCustomTexture(tmp,CustomBitmapArraySize);
	}*/
	do{
		ReadLine(fptr,linedata);
		i++;
		//read author, date, comments sometime
		if(sscanf(linedata, "line %f %f %f %f %i %i %i\n",
							&fi[0],
							&fi[1],
							&fi[2],
							&fi[3],
							&fi[4],
							&fi[5],
							&fi[6]
							))
						LineArraySize++;
		if(sscanf(linedata, "item %f %f %f %i %i\n",
							&fi[0],
							&fi[1],
							&fi[2],
							&fi[3],
							&fi[4]
							))
						ItemArraySize++;
		if(sscanf(linedata, "light %i",
							&fi[0]
							))
						LightArraySize++;
		if(sscanf(linedata, "poly %f %f * %i %i %i %i %i %i %i %i * %i %i\n",
							&fi[0],
							&fi[1],
							&fi[2],
							&fi[3],
							&fi[4],
							&fi[5],
							&fi[6],
							&fi[7],
							&fi[8],
							&fi[9],
							&fi[10],
							&fi[11]
							))
						PolygonArraySize++;
		if(sscanf(linedata, "texture %i %i %f %f %f %f\n",
							&fi[0],
							&fi[1],
							&fi[2],
							&fi[3],
							&fi[4],
							&fi[5]
							))
						TextureArraySize++;
		if(sscanf(linedata, "plat %i",&fi[0]))
			PlatformArraySize++;
		
		
		if(sscanf(linedata, "ctex %i",&ti)){
			if(LargestCustomTex<ti)
				LargestCustomTex=ti;
		}	
	}while(linedata[0]!='f');
	PlatformArray = new platformtype[PlatformArraySize+1];
	TextureArray = new texture[TextureArraySize+1];
	BitmapArray = new GLuint[BitmapArraySize+LargestCustomTex+1];
	fclose(fptr);		//Close filestream.
	return;
}




void ProcessLine(const char linedata[], ...){
	char tmp[255];
	int tmp2;
	
	
	#ifndef MACOSX
		if(sscanf(linedata, "gsound %i\n", &LastFoundSound))
			LastFoundAltSound=1;
		if(sscanf(linedata, " altsound %i\n", &SoundArray[LastFoundSound].Alts[LastFoundAltSound])){
			SoundArray[LastFoundSound].NoOfAlts=LastFoundAltSound;
			SoundArray[LastFoundSound].Alts[LastFoundAltSound+1]=SoundArray[LastFoundSound].Alts[LastFoundAltSound];
			LastFoundAltSound++;
		}
	#endif
	



	if(sscanf(linedata, "song %s\n", &CurrentSong)){
		Mix_HaltMusic();
		LoadAndPlaySong(CurrentSong);
	}

	if(sscanf(linedata, "objective %i", &PolysToVisit[LastFoundGoal]))
		LastFoundGoal++;
	if(sscanf(linedata, "plat %i %f %i %f %f %f %f",&PlatformArray[LastFoundPlatform].poly,&PlatformArray[LastFoundPlatform].risespeed,&PlatformArray[LastFoundPlatform].apexdelay,&PlatformArray[LastFoundPlatform].lowestfloor,&PlatformArray[LastFoundPlatform].highestfloor,&PlatformArray[LastFoundPlatform].lowestceiling,&PlatformArray[LastFoundPlatform].highestceiling))
		LastFoundPlatform++;
	//index speed delay bottom top
	
	if(sscanf(linedata,"report")){
		fprintf(stderr,"Player is in poly %i.\n",Player.polyparent);
		fprintf(stderr,"Current goal is %i.\n",PolysToVisit[LastVisit]);
		fprintf(stderr,"There are %i monsters.\n",MonsterArraySize);
	
	}
	
	sscanf(linedata, "playerhealth %i\n", &Player.health);
	sscanf(linedata, "playerpos %f %f %f %i\n", &Player.x,&Player.y,&Player.z,&Player.polyparent);
	
	sscanf(linedata, "m %i\n", &mtype);
	sscanf(linedata, " mname %s\n", &MonsterInfoArray[mtype].name);
	sscanf(linedata, " mfriendly %i\n", &MonsterInfoArray[mtype].friendly);
	sscanf(linedata, " mimmovable %i\n", &MonsterInfoArray[mtype].immovable);
	sscanf(linedata, " mta %f\n", &MonsterInfoArray[mtype].ta);
	sscanf(linedata, " mmts %f\n", &MonsterInfoArray[mtype].mts);
	sscanf(linedata, " mtd %f\n", &MonsterInfoArray[mtype].td);
	sscanf(linedata, " ma %f\n", &MonsterInfoArray[mtype].a);
	sscanf(linedata, " mva %f\n", &MonsterInfoArray[mtype].va);
	sscanf(linedata, " mics %f\n", &MonsterInfoArray[mtype].ics);
	sscanf(linedata, " mmas %f\n", &MonsterInfoArray[mtype].mas);
	sscanf(linedata, " mad %f\n", &MonsterInfoArray[mtype].ad);
	sscanf(linedata, " maad %f\n", &MonsterInfoArray[mtype].aad);
	if(sscanf(linedata, " mradius %f\n", &MonsterInfoArray[mtype].radius))
		if(MonsterInfoArray[mtype].itemradius==0.0f)
			MonsterInfoArray[mtype].itemradius=MonsterInfoArray[mtype].radius;
	sscanf(linedata, " mitemradius %f\n", &MonsterInfoArray[mtype].itemradius);
	sscanf(linedata, " mheight %f\n", &MonsterInfoArray[mtype].height);
	sscanf(linedata, " mcamheight %f\n", &MonsterInfoArray[mtype].camheight);
	sscanf(linedata, " mforcemultiplier %f\n", &MonsterInfoArray[mtype].forcemultiplier);
	sscanf(linedata, " mjumpforce %f\n", &MonsterInfoArray[mtype].jumpforce);
	sscanf(linedata, " mstepheight %f\n", &MonsterInfoArray[mtype].stepheight);
	sscanf(linedata, " mstepforce %f\n", &MonsterInfoArray[mtype].stepforce);
	sscanf(linedata, " mlateralpro %i\n", &MonsterInfoArray[mtype].lateralpro);
	sscanf(linedata, " mbunnyhoppro %i\n", &MonsterInfoArray[mtype].bunnyhoppro);
	sscanf(linedata, " misplayer %i\n", &MonsterInfoArray[mtype].isplayer);
	sscanf(linedata, " maitype %i\n", &MonsterInfoArray[mtype].aitype);
	sscanf(linedata, " mbouncecol %i\n", &MonsterInfoArray[mtype].bouncecol);
	sscanf(linedata, " mcanmoveoffground %i\n", &MonsterInfoArray[mtype].canmoveoffground);
	sscanf(linedata, " mbobspeed %f\n", &MonsterInfoArray[mtype].bobspeed);
	sscanf(linedata, " mbobheight %f\n", &MonsterInfoArray[mtype].maxbobheight);
	sscanf(linedata, " mhealth %i\n", &MonsterInfoArray[mtype].startinghealth);
	sscanf(linedata, " mweapon1 %i\n", &MonsterInfoArray[mtype].weapon1);
	sscanf(linedata, " mweapon2 %i\n", &MonsterInfoArray[mtype].weapon2);
	sscanf(linedata, " mrange1 %f\n", &MonsterInfoArray[mtype].range1);
	sscanf(linedata, " mrange2 %f\n", &MonsterInfoArray[mtype].range2);
	sscanf(linedata, " mhes1 %i\n", &MonsterInfoArray[mtype].hesitation1);
	sscanf(linedata, " mhes2 %i\n", &MonsterInfoArray[mtype].hesitation2);
	sscanf(linedata, " mhurtparticles %i %i\n", &MonsterInfoArray[mtype].hurtparticle, &MonsterInfoArray[mtype].noofhurtparticles);
	sscanf(linedata, " mbridge %i\n", &MonsterInfoArray[mtype].bridge);
	sscanf(linedata, " mcorpse %i\n", &MonsterInfoArray[mtype].corpse);
	sscanf(linedata, " mflies %i\n", &MonsterInfoArray[mtype].flying);
	sscanf(linedata, " msolid %i\n", &MonsterInfoArray[mtype].solid);
	sscanf(linedata, " mskin %i\n", &MonsterInfoArray[mtype].skin);
	sscanf(linedata, " mitem %i\n", &MonsterInfoArray[mtype].item);
	sscanf(linedata, " msharphit %i %i\n", &MonsterInfoArray[mtype].sharphitparticletype,&MonsterInfoArray[mtype].sharphitparticleno); ;
	//sscanf(linedata, " model %i\n", &MonsterInfoArray[mtype].model);
	sscanf(linedata, " msequence %i %i %i %i %i %i %i %i %i %i\n",
						&MonsterInfoArray[mtype].sequence[1],
						&MonsterInfoArray[mtype].sequence[2],
						&MonsterInfoArray[mtype].sequence[3],
						&MonsterInfoArray[mtype].sequence[4],
						&MonsterInfoArray[mtype].sequence[5],
						&MonsterInfoArray[mtype].sequence[6],
						&MonsterInfoArray[mtype].sequence[7],
						&MonsterInfoArray[mtype].sequence[8],
						&MonsterInfoArray[mtype].sequence[9],
						&MonsterInfoArray[mtype].sequence[10]
						);
	if(sscanf(linedata, "q %i\n", &lqtype)){
		lqframe=1;
		if(SequenceArraySize<lqtype)
			SequenceArraySize=lqtype;
	}
	sscanf(linedata, " qcf %i\n", &SequenceArray[lqtype].criticalframe);
	if(sscanf(linedata, " qm %s %i %i %i %f o %f %f %f r %f %f %f\n", &SequenceArray[lqtype].frame[lqframe],&SequenceArray[lqtype].speed[lqframe],&SequenceArray[lqtype].inter[lqframe],&SequenceArray[lqtype].ignore[lqframe],&SequenceArray[lqtype].scale[lqframe],&SequenceArray[lqtype].xoffset[lqframe],&SequenceArray[lqtype].yoffset[lqframe],&SequenceArray[lqtype].zoffset[lqframe],&SequenceArray[lqtype].xrot[lqframe],&SequenceArray[lqtype].yrot[lqframe],&SequenceArray[lqtype].zrot[lqframe])){
		SequenceArray[lqtype].frames=lqframe;
		lqframe++;
	}
	sscanf(linedata, "p %i\n", &lptype);		//particle type
	sscanf(linedata, " psrg %f %f %f\n", &ParticleInfoArray[lptype].speed,&ParticleInfoArray[lptype].spin,&ParticleInfoArray[lptype].grav);		//Speed, Rotation & Gravity
	sscanf(linedata, " plt %i\n", &ParticleInfoArray[lptype].lifespan);//Set their lifespan
	sscanf(linedata, " pm %i\n", &ParticleInfoArray[lptype].mode);//Drawing mode
	sscanf(linedata, " pmod %i\n", &ParticleInfoArray[lptype].model);//OBJ model (if any)
	sscanf(linedata, " pcol %i %i %i\n", &ParticleInfoArray[lptype].r,&ParticleInfoArray[lptype].g,&ParticleInfoArray[lptype].b);
	sscanf(linedata, " pb %f\n", &ParticleInfoArray[lptype].bounce);
	sscanf(linedata, " pbd %f\n", &ParticleInfoArray[lptype].bouncedelta);
	sscanf(linedata, " pt %f\n", &ParticleInfoArray[lptype].trans);

	sscanf(linedata, "w %i\n", &lwtype);
	sscanf(linedata, " wxo %f\n", &WeaponInfoArray[lwtype].xo);
	sscanf(linedata, " wyo %f\n", &WeaponInfoArray[lwtype].yo);
	sscanf(linedata, " wzo %f\n", &WeaponInfoArray[lwtype].zo);
	sscanf(linedata, " wot %i\n", &WeaponInfoArray[lwtype].wot);

	if(sscanf(linedata, " winacc %f\n", &WeaponInfoArray[lwtype].inaccfactor))
		if(WeaponInfoArray[lwtype].inaccfactor==0.0f)
			WeaponInfoArray[lwtype].inaccfactor=0.000001f;
	sscanf(linedata, " wskin %i\n", &WeaponInfoArray[lwtype].skin);
	sscanf(linedata, " widleseq %i\n", &WeaponInfoArray[lwtype].idlesequence);
	sscanf(linedata, " wshootseq %i\n", &WeaponInfoArray[lwtype].shootsequence);
	sscanf(linedata, " wrelseq %i\n", &WeaponInfoArray[lwtype].reloadsequence);
	sscanf(linedata, " wrate %i\n", &WeaponInfoArray[lwtype].rate);
	sscanf(linedata, " waccdelay %f\n", &WeaponInfoArray[lwtype].accdelay);
	sscanf(linedata, " wrecoil %f\n", &WeaponInfoArray[lwtype].recoil);
	sscanf(linedata, " wkick %f\n", &WeaponInfoArray[lwtype].kick);
	sscanf(linedata, " wknock %f\n", &WeaponInfoArray[lwtype].knock);
	sscanf(linedata, " wauto %i\n", &WeaponInfoArray[lwtype].wauto);
	sscanf(linedata, " wzooms %i\n", &WeaponInfoArray[lwtype].zooms);
	sscanf(linedata, " wzoomfactor %f\n", &WeaponInfoArray[lwtype].zoomfactor);
	sscanf(linedata, " wshotsound %i\n", &WeaponInfoArray[lwtype].shotsound);
	sscanf(linedata, " wreps %i\n", &WeaponInfoArray[lwtype].reps);
	sscanf(linedata, " wshotparticles %i %i\n", &WeaponInfoArray[lwtype].shotparticle, &WeaponInfoArray[lwtype].noofshotparticles);
	sscanf(linedata, " wshotnumber %i\n", &WeaponInfoArray[lwtype].shotspershot);
	sscanf(linedata, " wclipsize %i\n", &WeaponInfoArray[lwtype].clipsize);
	sscanf(linedata, " wammotype %i\n", &WeaponInfoArray[lwtype].ammotype);
	
	sscanf(linedata, "s %i\n", &ltype);
	if(sscanf(linedata, " sspeed %f\n", &ShotInfoArray[ltype].speed)&&ShotInfoArray[ltype].instant&&ShotInfoArray[ltype].grav==0.0f&&ShotInfoArray[ltype].speed==0.0f)
		ShotInfoArray[ltype].speed=0.01f;
	if(sscanf(linedata, " sgrav %f\n", &ShotInfoArray[ltype].grav)&&ShotInfoArray[ltype].speed==0.0f&&ShotInfoArray[ltype].instant&&ShotInfoArray[ltype].grav==0.0f)
		ShotInfoArray[ltype].speed=0.01f;
	sscanf(linedata, " sdamage %i\n", &ShotInfoArray[ltype].damage);
	sscanf(linedata, " sdsound %i\n", &ShotInfoArray[ltype].deathsound);
	sscanf(linedata, " ssharp%i\n", &ShotInfoArray[ltype].sharp);
	sscanf(linedata, " sguided %i\n", &ShotInfoArray[ltype].guided);
	sscanf(linedata, " sturnspeed %f\n", &ShotInfoArray[ltype].turnspeed);
	sscanf(linedata, " ssequence %i\n", &ShotInfoArray[ltype].sequence);
	if(sscanf(linedata, " sinstant %i\n", &ShotInfoArray[ltype].instant)&&ShotInfoArray[ltype].instant&&ShotInfoArray[ltype].speed==0.0f&&ShotInfoArray[ltype].grav==0.0f)
		ShotInfoArray[ltype].speed=0.01f;
	sscanf(linedata, " sinclusive %i\n", &ShotInfoArray[ltype].inclusivehits);
	sscanf(linedata, " sintercol %i\n", &ShotInfoArray[ltype].intercol);
	sscanf(linedata, " sflash %i\n", &ShotInfoArray[ltype].flash);
	sscanf(linedata, " sskin %i\n", &ShotInfoArray[ltype].skin);
	sscanf(linedata, " slife %i\n", &ShotInfoArray[ltype].lifetime);
	sscanf(linedata, " sdis %f\n", &ShotInfoArray[ltype].disruption);
	sscanf(linedata, " sknock %f\n", &ShotInfoArray[ltype].knock);
	sscanf(linedata, " sp %i %i\n", &ShotInfoArray[ltype].particle, &ShotInfoArray[ltype].noofparticles);
	sscanf(linedata, " sdp %i %i\n", &ShotInfoArray[ltype].deathparticle, &ShotInfoArray[ltype].noofdeathparticles);
	sscanf(linedata, "i %i\n", &litype);
	sscanf(linedata, " iskin %i\n", &ItemInfoArray[litype].skin);
	sscanf(linedata, " isequence %i\n", &ItemInfoArray[litype].sequence);
	sscanf(linedata, " iwep1 %i\n", &ItemInfoArray[litype].weapon1);
	sscanf(linedata, " iwep2 %i\n", &ItemInfoArray[litype].weapon2);
	sscanf(linedata, " ieffect %i\n", &ItemInfoArray[litype].effect);
	sscanf(linedata, " iinvgraphic %i\n", &ItemInfoArray[litype].invgraphic);
	sscanf(linedata, " imax %i\n", &ItemInfoArray[litype].max);
	sscanf(linedata, " iname %s\n", &ItemInfoArray[litype].name);
	sscanf(linedata, " icrosshair %i\n", &ItemInfoArray[litype].crosshairtype);
	sscanf(linedata, " igrav %f\n", &ItemInfoArray[litype].grav);
	sscanf(linedata, " idual %i\n", &ItemInfoArray[litype].seperatetriggers);

	sscanf(linedata, "b %i\n", &lftype);
	sscanf(linedata, " bc %i %i %i %i\n", &FlashArray[lftype].r,&FlashArray[lftype].g,&FlashArray[lftype].b,&FlashArray[lftype].a);
	sscanf(linedata, " bm %i\n", &FlashArray[lftype].mode);
	sscanf(linedata, " bd %i\n", &FlashArray[lftype].fadespeed);
	

	sscanf(linedata, "Prefs3DMap %i\n", &Prefs3DMap);
	sscanf(linedata, "PrefsGameDelay %i\n", &PrefsGameDelay);
	sscanf(linedata, "PrefsNostalgiaMode %i\n", &PrefsNostalgiaMode);
	sscanf(linedata, "PrefsFramesSkipFactor %i\n", &PrefsFramesSkipFactor);
	if(sscanf(linedata, "PrefsBeltSize %i\n", &PrefsBeltSize))
			PrefsBeltSize++;
	sscanf(linedata, "PrefsMaxBeltTrans %f\n", &PrefsMaxBeltTrans);
	sscanf(linedata, "PrefsBeltTrans %f\n", &PrefsBeltTrans);
	sscanf(linedata, "PrefsHideBelt %i\n", &PrefsHideBelt);
	sscanf(linedata, "PrefsTermTrans %i\n", &PrefsTermTrans);
	sscanf(linedata, "PrefsMipMapping %i\n", &PrefsMipMapping);

	sscanf(linedata, "PrefsInterpolateMouse %i\n", &PrefsInterpolateMouse);
	sscanf(linedata, "PrefsInvertMouse %i\n", &PrefsInvertMouse);
	sscanf(linedata, "PrefsUseMouse %i\n", &PrefsUseMouse);

	sscanf(linedata, "PrefsCrosshairHeight %f", &PrefsCrosshairHeight);
	sscanf(linedata, "PrefsCrosshairWidth %f", &PrefsCrosshairWidth);
	sscanf(linedata, "PrefsCrosshairThickness %i", &PrefsCrosshairThickness);
	
	sscanf(linedata, "PrefsParticleFX %i", &PrefsParticleFX);
	sscanf(linedata, "PrefsFarLinearFiltering %i", &PrefsFarLinearFiltering);
	sscanf(linedata, "PrefsNearLinearFiltering %i", &PrefsNearLinearFiltering);
	sscanf(linedata, "PrefsBetterPerspective %i", &PrefsBetterPerspective);
	sscanf(linedata, "bitdepth %i", &bitdepth);
	sscanf(linedata, "fullscreen %i", &fullscreen);
	sscanf(linedata, "screenwidth %i", &screenwidth);
	sscanf(linedata, "screenheight %i", &screenheight);
	sscanf(linedata, "Prefs3rdPerson %i", &Prefs3rdPerson);
	sscanf(linedata, "PrefsShowFPS %i", &PrefsShowFPS);
	sscanf(linedata, "PrefsCDMusic %i", &PrefsCDMusic);
	sscanf(linedata, "PrefsMouseSens %f", &PrefsMouseSens);
	sscanf(linedata, "PrefsMinimalInterface %i", &PrefsMinimalInterface);
	sscanf(linedata, "PrefsShowPosition %i", &PrefsShowPosition);
	//if(sscanf(linedata, "PrefsViewDistance %f", &PrefsViewDistance))
	//	gluPerspective( 45.0f, (1024.0f/768.0f), 0.1f, PrefsViewDistance );
	sscanf(linedata, "PrefsText %i", &PrefsText);
	
	sscanf(linedata, "XRayVision %i", &XRayVision);
	sscanf(linedata, "NightVision %i", &NightVision);
	sscanf(linedata, "ScanVision %i", &ScanVision);
	sscanf(linedata, "Zooming %i", &Zooming);
	sscanf(linedata, "ZoomAmount %f", &ZoomAmount);
	sscanf(linedata, "ShowObjectives %i", &ShowObjectives);

	if(!isloaded){
		if(sscanf(linedata, "ctex %i %s\n",&tmp2, &tmp)){
			CustomBitmapArraySize = BitmapArraySize+tmp2;
			LoadCustomTexture(tmp,CustomBitmapArraySize);
		}
	}
	

	if(NoOfObjectives<32){
		if(sscanf(linedata, "Objective %s %i", &ObjectiveList[NoOfObjectives], &ObjectiveLink[NoOfObjectives])){
			for(i2=0;i2<255;i2++)
				if(ObjectiveList[NoOfObjectives][i2]=='_')
					ObjectiveList[NoOfObjectives][i2]=' ';
			NoOfObjectives++;
		}

	}
	if(sscanf(linedata, "line %f %f %f %f * %i %i %i * %i %i %i\n",
							&LineArray[LastFoundPoint].x,
							&LineArray[LastFoundPoint].y,
							&LineArray[LastFoundPoint].x2,
							&LineArray[LastFoundPoint].y2,
							&LineArray[LastFoundPoint].primarytexture,
							&LineArray[LastFoundPoint].secondarytexture,
							&LineArray[LastFoundPoint].tertiarytexture,
							&LineArray[LastFoundPoint].primarylight,
							&LineArray[LastFoundPoint].secondarylight,
							&LineArray[LastFoundPoint].tertiarylight
							))
						LastFoundPoint++;
		if(sscanf(linedata, "light %i %i %i %i * %i %i %i %i %i %i * %i %i %i %i * %i %i %i %i %i %i * %i %i %i %i\n",
							&LightArray[LastFoundLight].ActPriMode,
							&LightArray[LastFoundLight].ActSecMode,
							&LightArray[LastFoundLight].InActPriMode,
							&LightArray[LastFoundLight].InActSecMode,
							
							&LightArray[LastFoundLight].ActPriBriR,
							&LightArray[LastFoundLight].ActSecBriR,
							&LightArray[LastFoundLight].ActPriBriG,
							&LightArray[LastFoundLight].ActSecBriG,
							&LightArray[LastFoundLight].ActPriBriB,
							&LightArray[LastFoundLight].ActSecBriB,
							
							&LightArray[LastFoundLight].ActPriSpd,
							&LightArray[LastFoundLight].ActSecSpd,
							&LightArray[LastFoundLight].InActPriSpd,
							&LightArray[LastFoundLight].InActSecSpd,
							
							&LightArray[LastFoundLight].InActPriBriR,
							&LightArray[LastFoundLight].InActSecBriR,
							&LightArray[LastFoundLight].InActPriBriG,
							&LightArray[LastFoundLight].InActSecBriG,
							&LightArray[LastFoundLight].InActPriBriB,
							&LightArray[LastFoundLight].InActSecBriB,
							
							&LightArray[LastFoundLight].ActPriDel,
							&LightArray[LastFoundLight].ActSecDel,
							&LightArray[LastFoundLight].InActPriDel,
							&LightArray[LastFoundLight].InActSecDel
							))
						LastFoundLight++;
		if(sscanf(linedata, "texture %i %i %f %f %f %f %i\n",
							&TextureArray[LastFoundTexture].bmpnumber,
							&TextureArray[LastFoundTexture].transfer,
							&TextureArray[LastFoundTexture].xoffset,
							&TextureArray[LastFoundTexture].yoffset,
							&TextureArray[LastFoundTexture].transfervar1,
							&TextureArray[LastFoundTexture].transfervar2,
							&TextureArray[LastFoundTexture].maskbmpnumber
							))
						LastFoundTexture++;
		if(sscanf(linedata, "media %i %i %i %i %i %i - %f %f %f %f %f\n",
							&MediaArray[LastFoundMedia].damagetype,
							&MediaArray[LastFoundMedia].damage,
							&MediaArray[LastFoundMedia].texture,
							&MediaArray[LastFoundMedia].texturemask,
							&MediaArray[LastFoundMedia].lightbase,
							&MediaArray[LastFoundMedia].light,
							&MediaArray[LastFoundMedia].current,
							&MediaArray[LastFoundMedia].currentdir,
							&MediaArray[LastFoundMedia].apex,
							&MediaArray[LastFoundMedia].nadir,
							&MediaArray[LastFoundMedia].oxygendrain
							))
						LastFoundMedia++;
		if(sscanf(linedata, "item %f %f %f %i %i\n",
							&ItemArray[LastFoundItem].x,
							&ItemArray[LastFoundItem].y,
							&ItemArray[LastFoundItem].z,
							&ItemArray[LastFoundItem].type,
							&ItemArray[LastFoundItem].polyparent
							))
						LastFoundItem++;
		if(sscanf(linedata, "enemy %f %f %f %i %i %i %f\n",
							&MonsterArray[LastFoundEnemy].x,
							&MonsterArray[LastFoundEnemy].y,
							&MonsterArray[LastFoundEnemy].z,
							&MonsterArray[LastFoundEnemy].type,
							&MonsterArray[LastFoundEnemy].polyparent,
							&MonsterArray[LastFoundEnemy].health,
							&MonsterArray[LastFoundEnemy].xdir
							))
						LastFoundEnemy++;
		if(sscanf(linedata, "poly %f %f * %i %i %i %i %i %i %i %i * %i %i %i %i * %i %i * %i\n",
							&PolygonArray[LastFoundPoly].ceilingheight,
							&PolygonArray[LastFoundPoly].floorheight,
							&PolygonArray[LastFoundPoly].lines[0],
							&PolygonArray[LastFoundPoly].lines[1],
							&PolygonArray[LastFoundPoly].lines[2],
							&PolygonArray[LastFoundPoly].lines[3],
							&PolygonArray[LastFoundPoly].lines[4],
							&PolygonArray[LastFoundPoly].lines[5],
							&PolygonArray[LastFoundPoly].lines[6],
							&PolygonArray[LastFoundPoly].lines[7],
							&PolygonArray[LastFoundPoly].ceilinglink,
							&PolygonArray[LastFoundPoly].floorlink,
							&PolygonArray[LastFoundPoly].ceilingtexture,
							&PolygonArray[LastFoundPoly].floortexture,
							&PolygonArray[LastFoundPoly].ceilinglight,
							&PolygonArray[LastFoundPoly].floorlight,
							&PolygonArray[LastFoundPoly].media
							))
						LastFoundPoly++;

	LineArraySize=LastFoundPoint;
	PolygonArraySize=LastFoundPoly;
	TextureArraySize=LastFoundTexture;
	LightArraySize=LastFoundLight;
	ItemArraySize=LastFoundItem;
	MonsterArraySize=LastFoundEnemy+1;
	MediaArraySize=LastFoundMedia+1;


	return;
}


int LoadSequences(int thefile){
	char filepath[255];
	FILE *fptr;
	char linedata[255];
	int i2;
	sprintf(filepath,"%s/Sequences%i.txt",ScenarioDir,thefile);
	if((fptr = fopen(filepath, "rt"))==NULL){       //Open filestream
		fprintf(stderr,"Couldn't open sequences file %s\n",filepath);
		return 1;
	}
	
	fprintf(stderr,"Opening sequences file.\n");
	do{
		ReadLine(fptr,linedata);
		ProcessLine(linedata);
	}while(linedata[0]!='f');
	
	fclose(fptr);		//Close filestream.
	
	
	return 0;
}

int LoadPhysics(int thefile){
	char filepath[255];
	FILE *fptr;
	char linedata[255];
	int i2;
	sprintf(filepath,"%s/Physics%i.txt",ScenarioDir,thefile);
	if((fptr = fopen(filepath, "rt"))==NULL){       //Open filestream
		fprintf(stderr,"Couldn't open physics file %s\n",filepath);
		return 1;
	}
	
	fprintf(stderr,"Opening physics file.\n");
	do{
		ReadLine(fptr,linedata);
		ProcessLine(linedata);
		}while(linedata[0]!='f');
	
	ItemInfoArraySize=litype+1;
	
	WeaponInfoArraySize=lwtype;

	//Remove underscores from item names
	for(i=0;i<ItemInfoArraySize;i++)
		for(i2=0;i2<255;i2++)
			if(ItemInfoArray[i].name[i2]=='_')
				ItemInfoArray[i].name[i2]=' ';
		
	//Remove underscores from monster names
	for(i=0;i<MonsterInfoArraySize;i++)
		for(i2=0;i2<255;i2++)
			if(MonsterInfoArray[i].name[i2]=='_')
				MonsterInfoArray[i].name[i2]=' ';

	fclose(fptr);		//Close filestream.
	
	
	return 0;
}
void ReadMeshLine(FILE *f,char *string){
		int ki=-1;
		do{
			ki++;
			string[ki]=fgetc(f);
		}while(string[ki]!='\n'&&string[ki]!=10&&string[ki]!=13&&string[ki]!=EOF);
}
int LoadPrefs(void){
	char filepath[255];
	char linedata[255];
	FILE *fptr;
	sprintf(filepath,"%s/prefs.txt",ScenarioDir);
	if((fptr = fopen(filepath, "rt"))==NULL){       //Open filestream
		fprintf(stderr,"Prefs file missing: %s\n",filepath);
		return 1;
	}
	fprintf(stderr,"Reading prefs.\n");
	do{
		ReadLine(fptr,linedata);
		ProcessLine(linedata);
	}while(linedata[0]!='f');
	fclose(fptr);		//Close filestream.
	return 0;
}
/*#ifdef modelformatmeshwork
int LoadShape(int model){
	FILE *fptr;
	int fi=false;
	int ki=0;
	char filepath[255];
	char linedata[255];
	int fodder;
	int LastFoundNormal=0;
	int LastFoundTexcoord=0;
	int LastFoundFace=0;
	int LastFoundPoint=0;
	int LastFoundEdge=0;
	sprintf(filepath,"%s/Model%i.mesh",ScenarioDir,model);
	sprintf(TermText,"Loading '%s'",filepath);
	if((fptr = fopen(filepath, "rt"))==NULL){       //Open filestream
		fprintf(stderr,"Number of models:%i\n",model-1);
		return 0;
	}
	
	ReadMeshLine(fptr,linedata);
	
	if(sscanf(linedata,"Mesh")){
		fprintf(stderr,"Model %i ain't no Meshwork file.\n",model);
		return 0;
	}
	fprintf(stderr,"Adding mesh file %i...\n", model);
	ReadMeshLine(fptr,linedata);
	
	do{
		ReadMeshLine(fptr,linedata);
		fi=sscanf(linedata, "%i",&LastFoundPoint);
		fi=sscanf(linedata, "%i	%f	%f	%f\n",
				&fodder,
				&ModelArray[model].PointArray[LastFoundPoint].x,
				&ModelArray[model].PointArray[LastFoundPoint].y,
				&ModelArray[model].PointArray[LastFoundPoint].z);
	}while(!sscanf(linedata,"END\n")&&!sscanf(linedata,"EDGES\n")&&fi);
	ReadMeshLine(fptr,linedata);
	do{
		ReadMeshLine(fptr,linedata);
		fi=sscanf(linedata, "%i	%i\n",
				&ModelArray[model].EdgeArray[LastFoundEdge].point[1],
				&ModelArray[model].EdgeArray[LastFoundEdge].point[2]);
		if(fi)
			LastFoundEdge++;
	}while(!sscanf(linedata,"END\n")&&fi);

	do{
		ReadMeshLine(fptr,linedata);
		fi=sscanf(linedata, "%i	%i %i\n",
				&ModelArray[model].FaceArray[LastFoundFace].point[1],
				&ModelArray[model].FaceArray[LastFoundFace].point[2],
				&ModelArray[model].FaceArray[LastFoundFace].point[3]);
		if(fi)
			LastFoundFace++;
	}while(!sscanf(linedata,"END\n")&&fi);

	do{
		ReadMeshLine(fptr,linedata);
		fi=sscanf(linedata, "%i",&LastFoundTexcoord);
		fi=sscanf(linedata, "%i	%f	%f\n",
				&fodder,
				&ModelArray[model].TexcoordArray[LastFoundTexcoord].u,
				&ModelArray[model].TexcoordArray[LastFoundTexcoord].v);
	}while(!sscanf(linedata,"END\n")&&!sscanf(linedata,"EDGES\n")&&fi);
	ModelArray[model].FaceArraySize=LastFoundFace;
	ModelArray[model].PointArraySize=LastFoundPoint;
	ModelArray[model].TexcoordArraySize=LastFoundTexcoord;
	ModelArray[model].NormalArraySize=LastFoundNormal;
	fclose(fptr);		//Close filestream.
	return model + 1;
}
#endif
#ifdef modelformatobj
int LoadShape(int model){
	FILE *fptr;
	char filepath[255];
	char linedata[255];
	int LastFoundNormal=1;
	int LastFoundTexcoord=1;
	int LastFoundFace=1;
	int LastFoundPoint=1;
	sprintf(filepath,"%s/Model%i.obj",ScenarioDir,model);
	sprintf(TermText,"Loading '%s'",filepath);
	if((fptr = fopen(filepath, "rt"))==NULL){       //Open filestream
		return 0;
	}
	//fgets(string, 255, f);	// Read One Line
	while(fscanf(fptr, "%s", linedata) != EOF){
		i++;
		switch(linedata[0]){
		case 'v':
			switch(linedata[1]){
			case 'n':
				//ReadLine(fptr,linedata);
				fscanf(fptr, "%f %f %f",
									&ModelArray[model].NormalArray[LastFoundNormal].x,
									&ModelArray[model].NormalArray[LastFoundNormal].y,
									&ModelArray[model].NormalArray[LastFoundNormal].z
									);
				LastFoundNormal++;
				break;
			case '\0':
				fscanf(fptr, "%f %f %f",
									&ModelArray[model].PointArray[LastFoundPoint].x,
									&ModelArray[model].PointArray[LastFoundPoint].y,
									&ModelArray[model].PointArray[LastFoundPoint].z
									);
				LastFoundPoint++;
			}
			break;
		case 't':
			ReadLine(fptr,linedata);
			sscanf(linedata, "%f %f",
								&ModelArray[model].TexcoordArray[LastFoundTexcoord].u,
								&ModelArray[model].TexcoordArray[LastFoundTexcoord].v
								);
			LastFoundTexcoord++;
			break;
		case 'f':
			ReadLine(fptr,linedata);
			sscanf(linedata, "%i//%i %i//%i %i//%i",
					&ModelArray[model].FaceArray[LastFoundFace].point[1],
					&ModelArray[model].FaceArray[LastFoundFace].normal[1],
					&ModelArray[model].FaceArray[LastFoundFace].point[2],
					&ModelArray[model].FaceArray[LastFoundFace].normal[2],
					&ModelArray[model].FaceArray[LastFoundFace].point[3],
					&ModelArray[model].FaceArray[LastFoundFace].normal[3]
				);
			sscanf(linedata, "%i/%i/%i %i/%i/%i %i/%i/%i",
					&ModelArray[model].FaceArray[LastFoundFace].point[1],
					&ModelArray[model].FaceArray[LastFoundFace].normal[1],
					&ModelArray[model].FaceArray[LastFoundFace].texcoord[1],
					&ModelArray[model].FaceArray[LastFoundFace].point[2],
					&ModelArray[model].FaceArray[LastFoundFace].normal[2],
					&ModelArray[model].FaceArray[LastFoundFace].texcoord[2],
					&ModelArray[model].FaceArray[LastFoundFace].point[3],
					&ModelArray[model].FaceArray[LastFoundFace].normal[3],
					&ModelArray[model].FaceArray[LastFoundFace].texcoord[3]
				);
			sscanf(linedata, "%i/%i %i/%i %i/%i",
					&ModelArray[model].FaceArray[LastFoundFace].point[1],
					&ModelArray[model].FaceArray[LastFoundFace].texcoord[1],
					&ModelArray[model].FaceArray[LastFoundFace].point[2],
					&ModelArray[model].FaceArray[LastFoundFace].texcoord[2],
					&ModelArray[model].FaceArray[LastFoundFace].point[3],
					&ModelArray[model].FaceArray[LastFoundFace].texcoord[3]
				);
			sscanf(linedata, "%i %i %i",
					&ModelArray[model].FaceArray[LastFoundFace].point[1],
					&ModelArray[model].FaceArray[LastFoundFace].point[2],
					&ModelArray[model].FaceArray[LastFoundFace].point[3]
				);
			LastFoundFace++;
			break;
		}
	}
	ModelArray[model].FaceArraySize=LastFoundFace;
	ModelArray[model].PointArraySize=LastFoundPoint;
	ModelArray[model].TexcoordArraySize=LastFoundTexcoord;
	ModelArray[model].NormalArraySize=LastFoundNormal;
	
	fclose(fptr);		//Close filestream.
	return model + 1;
}
#endif
*/
int LoadScenario(int scen){
	char filepath[255];
	FILE *fptr;
	char linedata[255];
	int li = 0;
	
	sprintf(filepath,"%s/Scenario%i.txt",ScenarioDir,scen);
	if((fptr = fopen(filepath, "rt"))==NULL){       //Open filestream
		fprintf(stderr,"Can't open scenario file %s.\n",filepath);
		return 1;
	}
	fprintf(stderr,"Reading scenario file.\n");
	do{
		ReadLine(fptr,linedata);
		i++;
		//read author, date, comments sometime
		sscanf(linedata, "name %s\n", &ScenarioName);
		sscanf(linedata, "graphicsextension %s\n", &ScenarioGraphicsType);
		sscanf(linedata, "interfacefore %f %f %f %f\n",
										&colorarray[0][0][1],
										&colorarray[1][0][1],
										&colorarray[2][0][1],
										&colorarray[3][0][1]
										);
		sscanf(linedata, "interfaceback %f %f %f %f\n",
										&colorarray[0][1][1],
										&colorarray[1][1][1],
										&colorarray[2][1][1],
										&colorarray[3][1][1]
										);
		sscanf(linedata, "pulse fore %i back %i\n",
										&pulsecolor[0],
										&pulsecolor[1]
										);
		
		}while(linedata[0]!='f');
	
	for(li=0;li<255;li++)
		if(ScenarioName[i]=='_')
			ScenarioName[i]=' ';
	fclose(fptr);		//Close filestream.
	return 0;
}



#ifdef USEGLAUX
AUX_RGBImageRec *LoadBMP(char *Filename){
        FILE *File=NULL;							//File Handle
        File=fopen(Filename,"r");					//Check it exists
        if (File){									//It does, so...
			fclose(File);							//...close the Handle...
			return auxDIBImageLoad(Filename);		//...And load it.
        }
        return NULL;							//If the load failed return NULL
}
int LoadTexture(int thetexture){
	int Status=FALSE;							// Status Indicator
	AUX_RGBImageRec *TextureImage[1];					// Create Storage Space For The Texture
	char filepath[255];
	sprintf(filepath,"%s/Graphics/Graphic%i%s",ScenarioDir,thetexture,ScenarioGraphicsType);
	memset(TextureImage,0,sizeof(void *)*1);				// Set The Pointer To NULL
	sprintf(TermText,"Loading '%s'",filepath);
	fprintf(stderr,"Loading texture %i\n",thetexture);
	// Load The Bitmap, Check For Errors, If Bitmap's !Found Quit
	if (TextureImage[0]=LoadBMP(filepath)){
		Status=TRUE;							// Set The Status To TRUE
		glGenTextures(1, &BitmapArray[thetexture]);					// Create The Texture
		// Typical Texture Generation Using Data From The Bitmap
		glBindTexture(GL_TEXTURE_2D, BitmapArray[thetexture]);
		//Quality Settings
		if(PrefsNearLinearFiltering)
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	// Linear Filtering
		else
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);	// Dodgey Filtering
		if(PrefsFarLinearFiltering && PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);	// Linear Filtering
			gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		}
		if(!PrefsFarLinearFiltering && PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST_MIPMAP_NEAREST);	// Cheapo Fast Filtering
			gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		}
		if(PrefsFarLinearFiltering && !PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);	// Linear Filtering
			glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		}
		if(!PrefsFarLinearFiltering && !PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);	// Crap Filtering
			glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		}
	}
	if (TextureImage[0]){							// If Texture Exists
		if (TextureImage[0]->data)					// If Texture Image Exists
			free(TextureImage[0]->data);				// Free The Texture Image Memory
		free(TextureImage[0]);						// Free The Image Structure
	}
	if(Status==TRUE){
		BitmapArraySize=thetexture;
		//LoadTexture(thetexture+1);
		return thetexture+1;
	}
	return 0;								// Return The Status
}
int LoadCustomTexture( char* filepath, int thetexture){
	char newfilepath[255];
	int Status=FALSE;							// Status Indicator
	AUX_RGBImageRec *TextureImage[1];					// Create Storage Space For The Texture
	

	sprintf(newfilepath,"%s/%s",ScenarioDir,filepath);

	fprintf(stderr,"Loading custom texture %s into slot %i\n",filepath,thetexture);
	memset(TextureImage,0,sizeof(void *)*1);				// Set The Pointer To NULL
	if (TextureImage[0]=LoadBMP(newfilepath))
	{
		Status=TRUE;							// Set The Status To TRUE
		glGenTextures(1, &BitmapArray[thetexture]);					// Create The Texture
		// Typical Texture Generation Using Data From The Bitmap
		glBindTexture(GL_TEXTURE_2D, BitmapArray[thetexture]);
		//Quality Settings
		if(PrefsNearLinearFiltering)
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	// Linear Filtering
		else
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);	// Dodgey Filtering
		if(PrefsFarLinearFiltering && PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);	// Linear Filtering
			gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		}
		if(!PrefsFarLinearFiltering && PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST_MIPMAP_NEAREST);	// Cheapo Fast Filtering
			gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		}
		if(PrefsFarLinearFiltering && !PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);	// Linear Filtering
			glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		}
		if(!PrefsFarLinearFiltering && !PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);	// Crap Filtering
			glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
		}
	}else
		fprintf(stderr,"Missing custom texture: %s in slot %i\n", filepath, thetexture);
	if (TextureImage[0]){							// If Texture Exists
		if (TextureImage[0]->data)					// If Texture Image Exists
			free(TextureImage[0]->data);				// Free The Texture Image Memory
		free(TextureImage[0]);						// Free The Image Structure
	}
	return Status;								// Return The Status
}

void PreprocessTexture(int thetexture){
	char filepath[255];
	FILE *File=NULL;
	
	sprintf(filepath,"%s/Graphics/Graphic%i%s",ScenarioDir,thetexture,ScenarioGraphicsType);
	memset(TextureImage,0,sizeof(void *)*1);				// Set The Pointer To NULL

    File=fopen(Filename,"r");					//Check it exists
    if(File){
		fclose(File);
		BitmapArraySize=thetexture+1;
		PreprocessTexture(thetexture+1);
	}else
		fprintf(stderr,"Expected number of textures: %i\n", thetexture-1);
	return;
}
void BuildStaticTextures(void){
	AUX_RGBImageRec *Temp[1];
	int ni=3;
	int ri;
	char path[255];

	sprintf(path,"%s/Graphics/Graphic1.bmp",ScenarioDir);
	memset(Temp,0,sizeof(void *)*1);
	if (!(Temp[0]=LoadBMP(path)))
		return;
	
	for(ni=0;ni<32;ni++){
		glGenTextures(1, &StaticTextures[ni]);	//Make space for a texture
		glBindTexture(GL_TEXTURE_2D, StaticTextures[ni]);
		for(ri=0;ri<Temp[0]->sizeX*Temp[0]->sizeY*3;ri++)
			Temp[0]->data[ri]=rand()%(255);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		
		glTexImage2D(GL_TEXTURE_2D, 0, 3, Temp[0]->sizeX, Temp[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, Temp[0]->data);
		
	}
	if (Temp[0]){							// If Texture Exists
		if (Temp[0]->data)					// If Texture Image Exists
			free(Temp[0]->data);				// Free The Texture Image Memory
		free(Temp[0]);						// Free The Image Structure
	}
}
#else
void SDL_PutPixel(SDL_Surface *surface, int x, int y, Uint32 pixel){
	int bpp = surface->format->BytesPerPixel;
	// Here p is the address to the pixel we want to set
	Uint8 *p;
	p= (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

	switch(bpp){
		case 1:
			*p = pixel;
			break;

		case 2:
			*(Uint16 *)p = pixel;
			break;

		case 3:
			if (SDL_BYTEORDER == SDL_BIG_ENDIAN)
			{
				p[0] = (pixel >> 16) & 0xff;
				p[1] = (pixel >> 8) & 0xff;
				p[2] = pixel & 0xff;
			} else {
				p[0] = pixel & 0xff;
				p[1] = (pixel >> 8) & 0xff;
				p[2] = (pixel >> 16) & 0xff;
			}
			break;

		case 4:
			*(Uint32 *)p = pixel;
			break;
	}
}

// SDL_GetPixel!
Uint32 SDL_GetPixel( SDL_Surface *surface, Uint16 x, Uint16 y )
{
	SDL_PixelFormat *fmt;
	SDL_Color *color;
	Uint8 index, red, green, blue, alpha, *img;
	Uint32 temp, pixel = 255;

	fmt = surface->format;
	img = (Uint8 *)surface->pixels + (x * fmt->BytesPerPixel) + (surface->pitch * y);

	//Check the bit depth of the surface.
	if(fmt->BitsPerPixel == 8){
		/* Get the top left pixel. */
		index = *img;
		color = &(fmt->palette->colors[index]);
		alpha = 255;
		red = color->r;
		green = color->g;
		blue = color->b;
	}
	else
	{
		#ifdef MACOSX
//hahah, little endian shit. doesn't work for BMPs for some reason
		pixel = *(Uint32*)img;

		/* Get Red component */
		temp = pixel & fmt->Rmask; 	/* Isolate the red component. */
		temp = temp >> fmt->Rshift;	/* Shift it down to 8-bit. */
		temp = temp << fmt->Rloss; 	/* Expand to a full 8-bit number. */
		green = (Uint8)temp;
		
		temp = pixel & fmt->Gmask;
		temp = temp >> fmt->Gshift;
		temp = temp << fmt->Gloss; 
		red = (Uint8)temp;

		temp = pixel & fmt->Bmask;
		temp = temp >> fmt->Bshift;
		temp = temp << fmt->Bloss;
		blue = (Uint8)temp;

		temp = pixel & fmt->Amask;
		temp = temp >> fmt->Ashift;
		temp = temp << fmt->Aloss;
		alpha = (Uint8)temp;
		#else
		/* Extracting color components from a 32-bit color value */
		pixel = *(Uint32*)img;

		/* Get Red component */
		temp = pixel & fmt->Rmask; 	/* Isolate the red component. */
		temp = temp >> fmt->Rshift;	/* Shift it down to 8-bit. */
		temp = temp << fmt->Rloss; 	/* Expand to a full 8-bit number. */
		red = (Uint8)temp;
		
		temp = pixel & fmt->Gmask;
		temp = temp >> fmt->Gshift;
		temp = temp << fmt->Gloss; 
		green = (Uint8)temp;

		temp = pixel & fmt->Bmask;
		temp = temp >> fmt->Bshift;
		temp = temp << fmt->Bloss;
		blue = (Uint8)temp;

		temp = pixel & fmt->Amask;
		temp = temp >> fmt->Ashift;
		temp = temp << fmt->Aloss;
		alpha = (Uint8)temp;
		#endif
	}

	return (alpha << 24) | (blue << 16) | (green << 8) | red;
}
// SDL_GetPixel!
Uint32 SDL_GetPixel2( SDL_Surface *surface, Uint16 x, Uint16 y )
{
	SDL_PixelFormat *fmt;
	SDL_Color *color;
	Uint8 index, red, green, blue, alpha, *img;
	Uint32 temp, pixel = 255;

	fmt = surface->format;
	img = (Uint8 *)surface->pixels + (x * fmt->BytesPerPixel) + (surface->pitch * y);

	//Check the bit depth of the surface.
	if(fmt->BitsPerPixel == 8){
		/* Get the top left pixel. */
		index = *img;
		color = &(fmt->palette->colors[index]);
		alpha = 255;
		red = color->r;
		green = color->g;
		blue = color->b;
	}
	else
	{

		pixel = *(Uint32*)img;

		/* Get Red component */
		temp = pixel & fmt->Rmask; 	/* Isolate the red component. */
		temp = temp >> fmt->Rshift;	/* Shift it down to 8-bit. */
		temp = temp << fmt->Rloss; 	/* Expand to a full 8-bit number. */
		blue = (Uint8)temp;
		
		temp = pixel & fmt->Gmask;
		temp = temp >> fmt->Gshift;
		temp = temp << fmt->Gloss; 
		red = (Uint8)temp;

		temp = pixel & fmt->Bmask;
		temp = temp >> fmt->Bshift;
		temp = temp << fmt->Bloss;
		green = (Uint8)temp;

		temp = pixel & fmt->Amask;
		temp = temp >> fmt->Ashift;
		temp = temp << fmt->Aloss;
		alpha = (Uint8)temp;

	}

	return (alpha << 24) | (blue << 16) | (green << 8) | red;
}

int ChangeToBGR(SDL_Surface* theimage){
	//Arlen stuffed up PutPixel slightly... but that makes this bit much easier.
	int xi, yi;
	Uint32 tp, sp;
	for(xi=0;xi<theimage->w-1;xi++){
		for(yi=0;yi<theimage->h/2;yi++){
			sp=SDL_GetPixel(theimage,xi,yi);
			tp=SDL_GetPixel(theimage,xi,theimage->h-1-yi);
			SDL_PutPixel(theimage, xi, yi, tp);
			SDL_PutPixel(theimage, xi, theimage->h-1-yi, sp);
		}
	}

	return 0;

}



int LoadCustomTexture( char* filepath, int thetexture){
	char newfilepath[255];
	int aStatus = FALSE;							// Status Indicator
	SDL_Surface *TextureImage;
	
	sprintf(newfilepath,"%s/%s",ScenarioDir,filepath);

#ifdef USE_SDL_IMAGE
	if (TextureImage = IMG_Load(newfilepath)){
#else
	if (TextureImage = SDL_LoadBMP(newfilepath)){
#endif
		aStatus=TRUE;							// Set The Status To TRUE
		glGenTextures(1, &BitmapArray[thetexture]);					// Create The Texture
		// Typical Texture Generation Using Data From The Bitmap
		glBindTexture(GL_TEXTURE_2D, BitmapArray[thetexture]);
		//Quality Settings
		
	fprintf(stderr,"Loading custom texture %s into slot %i\n",filepath,thetexture);
		
		ChangeToBGR(TextureImage);
		SDL_LockSurface(TextureImage);

		if(PrefsNearLinearFiltering)
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	// Linear Filtering
		else
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);	// Dodgey Filtering
		if(PrefsFarLinearFiltering && PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);	// Linear Filtering
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, TextureImage->w, TextureImage->h, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->pixels);
		}
		if(!PrefsFarLinearFiltering && PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST_MIPMAP_NEAREST);	// Cheapo Fast Filtering
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, TextureImage->w, TextureImage->h, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->pixels);
		}
		if(PrefsFarLinearFiltering && !PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);	// Linear Filtering
			glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, TextureImage->w, TextureImage->h, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->pixels);
		}
		if(!PrefsFarLinearFiltering && !PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);	// Crap Filtering
			glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, TextureImage->w, TextureImage->h, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->pixels);
		}

		SDL_UnlockSurface(TextureImage);
	}else
		fprintf(stderr,"Missing custom texture: %s in slot %i\n", filepath, thetexture);
	
	if (TextureImage)
	{
		SDL_FreeSurface(TextureImage);
	}
	return aStatus;								// Return The Status
}
#define GL_EXT_bgra                       1
/* EXT_bgra */
#define GL_BGR_EXT                        0x80E0
#define GL_BGRA_EXT                       0x80E1

int LoadTexture(int thetexture){
	int nStatus = FALSE;							// Status Indicator
	SDL_Surface *TextureImage;
	char filepath[255];
	sprintf(filepath,"%s/Graphics/Graphic%i%s",ScenarioDir,thetexture,ScenarioGraphicsType);

	sprintf(TermText,"Loading '%s'",filepath);

	fprintf(stderr,"Loading texture %i.\n",thetexture);
	// Load The Bitmap, Check For Errors, If Bitmap's !Found Quit
#ifdef USE_SDL_IMAGE
	if (TextureImage = IMG_Load(filepath)){
#else
	if (TextureImage = SDL_LoadBMP(filepath)){
#endif
		nStatus=TRUE;							// Set The Status To TRUE
		glGenTextures(1, &BitmapArray[thetexture]);					// Create The Texture
		// Typical Texture Generation Using Data From The Bitmap
		glBindTexture(GL_TEXTURE_2D, BitmapArray[thetexture]);
		//Quality Settings

		ChangeToBGR(TextureImage);
		SDL_LockSurface(TextureImage);

		if(PrefsNearLinearFiltering)
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	// Linear Filtering
		else
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);	// Dodgey Filtering
		if(PrefsFarLinearFiltering && PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);	// Linear Filtering
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, TextureImage->w, TextureImage->h, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->pixels);
		}
		if(!PrefsFarLinearFiltering && PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST_MIPMAP_NEAREST);	// Cheapo Fast Filtering
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, TextureImage->w, TextureImage->h, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->pixels);
		}
		if(PrefsFarLinearFiltering && !PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);	// Linear Filtering
			glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, TextureImage->w, TextureImage->h, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->pixels);
		}
		if(!PrefsFarLinearFiltering && !PrefsMipMapping){
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);	// Crap Filtering
			glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, TextureImage->w, TextureImage->h, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->pixels);
		}

		SDL_UnlockSurface(TextureImage);
	}
	
	if (TextureImage)
		SDL_FreeSurface(TextureImage);
	
	if(nStatus==TRUE){
		BitmapArraySize=thetexture;
		return thetexture+1;
	}
	return 0;								// Return The Status
}
void PreprocessTexture(int thetexture){
	char filepath[255];
	FILE *File=NULL;
	
	sprintf(filepath,"%s/Graphics/Graphic%i%s",ScenarioDir,thetexture,ScenarioGraphicsType);

    File=fopen(filepath,"r");					//Check it exists
    if(File){
		fclose(File);
		BitmapArraySize=thetexture;
		PreprocessTexture(thetexture+1);
	}else
		fprintf(stderr,"Expected number of textures: %i\n", thetexture-1);
	return;
}


void BuildStaticTextures(void){
	SDL_Surface *Temp;
	int ni = 3;
	int rx, ry;
	char path[255];
	
	return;

	sprintf(path,"%s/Graphics/Graphic1%s",ScenarioDir,ScenarioGraphicsType);
	#ifdef USE_SDL_IMAGE
	if (!(Temp = IMG_Load(path)))
		return;
#else
	if (!(Temp = SDL_LoadBMP(path)))
		return;
#endif

	
	for (ni = 0; ni < 32; ni++)
	{
		glGenTextures(1, &StaticTextures[ni]);	//Make space for a texture
		glBindTexture(GL_TEXTURE_2D, StaticTextures[ni]);
		for (ry = 0; ry < 128; ry++)
			for (rx = 0; rx < 128; rx++)
				SDL_PutPixel(Temp, rx, ry, SDL_MapRGB(Temp->format, rand() % 255, rand() % 255, rand() % 255));
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		
		Temp = SDL_ConvertForGL(Temp, true);
		SDL_LockSurface(Temp);
		
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, Temp->w, Temp->h, 0, GL_RGBA, GL_UNSIGNED_BYTE, Temp->pixels);

		SDL_UnlockSurface(Temp);
		
	}

	if (Temp)
		SDL_FreeSurface(Temp);
}

int PreprocessASound(int thesound){
	char newpath[255];
	FILE *fptr;
	
	sprintf(newpath,"%s/Sounds/Sound%i.wav",ScenarioDir,thesound);
	if((fptr = fopen(newpath, "rt"))==NULL){       //Open filestream
		fprintf(stderr, "Number of sounds: %i\n", thesound-1);
		SoundArray = new soundtype[thesound];
		SoundArraySize=thesound-1;
		return 0;
	}
	fclose(fptr);
	PreprocessASound(thesound+1);
	return 0;
}

int LoadSound(int thesound){
	char newpath[255];
	char mchar[255]="a";
	int li=0;
	FILE *fptr;
	
	sprintf(newpath,"%s/Sounds/Sound%i.wav",ScenarioDir,thesound);
	sprintf(TermText,"Opening sound '%s'",newpath);
	if((fptr = fopen(newpath, "rt"))==NULL){       //Open filestream
		fprintf(stderr, "Sound missing: %i\n", thesound);
		fclose(fptr);
		return 0;
	}else{
	SoundArray[thesound].TheSound=Mix_LoadWAV(newpath);
	return thesound+1;
	}
}

#endif