#include "e0main.h"

static GLdouble ScreenToClip[16];
static GLdouble EyeToClip[16];
static GLdouble EyeToScreen[16];

modeltype models[3];	//temporary data placement

void ChooseLandscape(void){
	int i;
	for(i=0;i<TextureArraySize&&TextureArray[i].transfer!=9;i++){}
	landscapeno=i;
}
int initGL( GLvoid ){
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	
	if(PrefsBetterPerspective)
			glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Nicer Perspective Calculations
	else
			glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);	// Faster Perspective Calculations
    return(true);
}
void DrawLandscape(void){
	GLfloat i;
	i = -Player.xdir;
	for(;i>360.0f;i-=360.0f);
	for(;i<0.0f;i+=360.0f);
	i/=90.0f;
	glTranslatef(i,0.0f,-1.0f);
	glDisable(GL_BLEND);
	glEnable(GL_TEXTURE_2D);
	if(TextureArray[landscapeno].bmpnumber>0)
		glBindTexture(GL_TEXTURE_2D, BitmapArray[TextureArray[landscapeno].bmpnumber]);
	else{}

	glBegin(GL_QUADS);
		glTexCoord2f(0.0f,0.0f);glVertex2f(-1.0f,-1.0f);
		glTexCoord2f(1.0f,0.0f);glVertex2f(1.0f,-1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex2f(1.0f,1.0f);
		glTexCoord2f(0.0f,1.0f);glVertex2f(-1.0f,1.0f);

		glTexCoord2f(0.0f,0.0f);glVertex2f(-3.0f,-1.0f);
		glTexCoord2f(1.0f,0.0f);glVertex2f(-1.0f,-1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex2f(-1.0f,1.0f);
		glTexCoord2f(0.0f,1.0f);glVertex2f(-3.0f,1.0f);

		glTexCoord2f(0.0f,0.0f);glVertex2f(-5.0f,-1.0f);
		glTexCoord2f(1.0f,0.0f);glVertex2f(-3.0f,-1.0f);
		glTexCoord2f(1.0f,1.0f);glVertex2f(-3.0f,1.0f);
		glTexCoord2f(0.0f,1.0f);glVertex2f(-5.0f,1.0f);
	glEnd();
	glDisable(GL_TEXTURE_2D);

	glTranslatef(-i,0.0f,1.0f);
	glClear(GL_DEPTH_BUFFER_BIT);
}
void DrawMap(void){
	
	glDisable(GL_COLOR_LOGIC_OP);
    glLoadIdentity();
	
	glDisable(GL_TEXTURE_2D);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glRotatef(90.0f,1.0f,0.0f,0.0f);
	glTranslatef(0.0f,-10.0f,0.0f);
	if(!Prefs3DMap)
		glRotatef(-Player.ydir+90.0f,-1.0f,0.0f,0.0f);
	glRotatef(Player.xdir,0.0f,1.0f,0.0f);
	glTranslatef(-Player.x,-Player.y,-Player.z);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glLineWidth (4);
	Trans=128;
	if(!Prefs3DMap){
		glPolygonMode (GL_FRONT_AND_BACK, GL_LINE);
		glColor4ub(255,255,255,96);
		for(i=1;i<PolygonArraySize;i++){
			glBegin(GL_POLYGON);
			for(i2=0;i2<LinesPerPoly&&PolygonArray[i].lines[i2]>0;i2++){
				glVertex3f(LineArray[PolygonArray[i].lines[i2]].x,PolygonArray[i].floorheight,LineArray[PolygonArray[i].lines[i2]].y);
				glVertex3f(LineArray[PolygonArray[i].lines[i2]].x2,PolygonArray[i].floorheight,LineArray[PolygonArray[i].lines[i2]].y2);
			}
			glEnd();
		}
	}else{
		for(i=1;i<PolygonArraySize;i++){
			glColor4ub(255,255,255,96);
			glBegin(GL_POLYGON);
				for(i2=0;i2<LinesPerPoly;i2++)
					if(PolygonArray[i].lines[i2] != -1){
						glVertex3f(LineArray[PolygonArray[i].lines[i2]].x,PolygonArray[i].floorheight,LineArray[PolygonArray[i].lines[i2]].y);
						glVertex3f(LineArray[PolygonArray[i].lines[i2]].x2,PolygonArray[i].floorheight,LineArray[PolygonArray[i].lines[i2]].y2);
					}
			glEnd();
			for(i2=0;i2<LinesPerPoly;i2++){
				if(PolygonArray[i].lines[i2]==-1)
					i2=LinesPerPoly;
				else{
					glBegin(GL_LINES);
						glVertex3f(LineArray[PolygonArray[i].lines[i2]].x,0.0f,LineArray[PolygonArray[i].lines[i2]].y);
						glVertex3f(LineArray[PolygonArray[i].lines[i2]].x2,0.0f,LineArray[PolygonArray[i].lines[i2]].y2);
					glEnd();
				}
			}

		}
	}
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_DST_ALPHA);
	glBegin(GL_POLYGON);
	i=Player.polyparent;
	glColor4ub(255,0,0,255);
	for(i2=0;i2<LinesPerPoly&&PolygonArray[i].lines[i2]>0;i2++){
		glVertex3f(LineArray[PolygonArray[i].lines[i2]].x,PolygonArray[i].floorheight,LineArray[PolygonArray[i].lines[i2]].y);
		glVertex3f(LineArray[PolygonArray[i].lines[i2]].x2,PolygonArray[i].floorheight,LineArray[PolygonArray[i].lines[i2]].y2);
	}
	glEnd();
	glBegin(GL_POLYGON);
	i=PolysToVisit[LastVisit];
	glColor4ub(0,0,255,255);
	for(i2=0;i2<LinesPerPoly&&PolygonArray[i].lines[i2]>0;i2++){
		glVertex3f(LineArray[PolygonArray[i].lines[i2]].x,PolygonArray[i].floorheight,LineArray[PolygonArray[i].lines[i2]].y);
		glVertex3f(LineArray[PolygonArray[i].lines[i2]].x2,PolygonArray[i].floorheight,LineArray[PolygonArray[i].lines[i2]].y2);
	}
	glEnd();
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);

	glTranslatef(Player.x,Player.y,Player.z);
	glRotatef(Player.xdir,0.0f,-1.0f,0.0f);
	glColor4ub(128,255,128,64);
	glBegin(GL_TRIANGLES);
		glVertex3f(-0.2f,0.0f,0.2f);
		glVertex3f(0.2f,0.0f,0.2f);
		glVertex3f(0.0f,0.0f,-0.2f);
	glEnd();
	glRotatef(Player.xdir,0.0f,1.0f,0.0f);
	glTranslatef(-Player.x,-Player.y,-Player.z);
	
	glTranslatef(APx,Player.y,APy);
	glColor4ub(128,128,255,64);
	glBegin(GL_LINES);
		glVertex3f(-0.2f,0.0f,-0.2f);
		glVertex3f(0.2f,0.0f,0.2f);
		glVertex3f(0.2f,0.0f,-0.2f);
		glVertex3f(-0.2f,0.0f,0.2f);
	glEnd();
	glTranslatef(-APx,-Player.y,-APy);
	/*glColor4ub(128,128,255,64);
	glBegin(GL_LINES);
		glVertex3f(APx,0.0f,APy);
		glVertex3f(APx2,0.0f,APy2);
	glEnd();*/

	sprintf(TermText,"%s",LevelName);
	PrefsTermTrans=1.0f;

	glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);

	return;
}

int DrawGLScene(GLvoid){
	glClear(GL_DEPTH_BUFFER_BIT);	// Clear Depth Buffer
	glLoadIdentity();
	glDisable(GL_COLOR_LOGIC_OP);
    glLoadIdentity( );
	Frames++;
	GLint t = SDL_GetTicks();
	// Gather our frames per second 
	GLfloat seconds = (t - T0) / 1000.0;
	GLfloat fps = Frames / seconds;
	//if (t - T0 >= 10) {
		if(PrefsCompensativeSpeed){
			speedfactor=60.0f/fps;
		}
		if(PrefsShowFPS){
			sprintf(TermText,"%d frames in %g seconds = %g FPS, with a speed factor of %f\n", Frames, seconds, fps, speedfactor);
			PrefsTermTrans=1.0f;
		}
		T0 = t;
		Frames = 0;
	//}

	
	if(FlashMode==0&&!XRayVision)
		DrawLandscape();


	if(Zooming){
		glMatrixMode( GL_PROJECTION );
		glLoadIdentity( );
		gluPerspective( 45.0f/ZoomAmount, (1024.0f/768.0f), 0.1f, PrefsViewDistance );
		glMatrixMode( GL_MODELVIEW );
	}
	if(Prefs3rdPerson)
		glTranslatef(0.0f,0.0f,-1.4f);


	glRotatef(Player.ydir,1.0f,0.0f,0.0f);
	glRotatef(Player.xdir,0.0f,1.0f,0.0f);
	glRotatef(Player.zdir,0.0f,0.0f,1.0f);
	
	glRotatef(((rand()/8192)-0.5f)*(Player.knocktimer/100.0f),1.0f,0.0f,0.0f);
	glRotatef(((rand()/8192)-0.5f)*(Player.knocktimer/100.0f),0.0f,1.0f,0.0f);
	glRotatef(((rand()/8192)-0.5f)*(Player.knocktimer/100.0f),0.0f,0.0f,1.0f);

	glTranslatef(-Player.x,-(Player.y+MonsterInfoArray[Player.type].camheight)-sin(Player.bobheightphase*radians)*MonsterInfoArray[Player.type].maxbobheight,-Player.z);
	
	glColor4ub(colorarray[0][0][1],colorarray[1][0][1],colorarray[2][0][1],colorarray[3][0][1]);
	
	glDisable(GL_BLEND);		// Turn Blending Off
	glEnable(GL_DEPTH_TEST);	// Turn Depth Testing On
	glEnable(GL_TEXTURE_2D);

	//<Insert here code, sometime, to make a sacrifice to the Polygon Gods
	// asking that this lowly polygon is never corrupted>
	if(XRayVision && FlashMode==0){
		glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
		glEnable(GL_BLEND);
		glDisable(GL_DEPTH_TEST);
		Trans=255;
		glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	}
	if(FlashMode==2||FlashMode==3){  //If we're shellshocked/blurred...
		glEnable(GL_BLEND);
		Trans=(255-(colorarray[4][2][0]/16))/3;
	}
	if(FlashMode==5){				//Tripping Mode. Really cool.
		glEnable(GL_BLEND);
		Trans=255-(colorarray[4][2][0]/16);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_DST_ALPHA);  //"Normal" blending, ehehe
	}
	if(ScanVision){
		glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glCullFace (GL_NONE);
		glPolygonMode (GL_BACK, GL_LINE);
		glPolygonMode (GL_FRONT, GL_LINE);
		glDisable(GL_DEPTH_TEST);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE);
		glDisable(GL_TEXTURE_2D);
		glLineWidth (4);
		Trans=128;
	}
	switch(subscreen){
	case 0:
		DrawNormally();
		break;
	case 1:
		DrawMap();
		break;
	}
	if(Zooming){
		glMatrixMode( GL_PROJECTION );
		glLoadIdentity( );
		gluPerspective( 45.0f, (1024.0f/768.0f), 0.1f, PrefsViewDistance );
		glMatrixMode( GL_MODELVIEW );
	}

	glLoadIdentity();
	glDisable(GL_BLEND);		// Turn Blending On
	glEnable(GL_DEPTH_TEST);	// Turn Depth Testing Off
	glClear( GL_DEPTH_BUFFER_BIT);
	
	//Weapon-in-hand shit
	i = PlayerPriSelection;

	glColor4ub(255,255,255,Trans);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,BitmapArray[WeaponInfoArray[i].skin]);
	if(WeaponInfoArray[i].sequence>0&&WeaponInfoArray[i].frame>0&&PlayerInventory[PlayerSelection]>0)
		glCallList(SequenceArray[WeaponInfoArray[i].sequence].lists[WeaponInfoArray[i].frame].thelist[(int)WeaponInfoArray[i].frametimer]);
	else{
		WeaponInfoArray[i].sequence=WeaponInfoArray[i].idlesequence;
		WeaponInfoArray[i].frame=1;
		WeaponInfoArray[i].frametimer=0;
	}

	i = PlayerSecSelection;

	glColor4ub(255,255,255,Trans);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,BitmapArray[WeaponInfoArray[i].skin]);
	if(PlayerInventory[PlayerSelection]>1){
		if(WeaponInfoArray[i].sequence>0&&WeaponInfoArray[i].frame>0)
			glCallList(SequenceArray[WeaponInfoArray[i].sequence].lists[WeaponInfoArray[i].frame].thelist[(int)WeaponInfoArray[i].frametimer]);
		else{
			WeaponInfoArray[i].sequence=WeaponInfoArray[i].idlesequence;
			WeaponInfoArray[i].frame=1;
			WeaponInfoArray[i].frametimer=0;
		}
	}



	glEnable(GL_BLEND);		// Turn Blending On
	glDisable(GL_DEPTH_TEST);	// Turn Depth Testing Off




	glLineWidth (1);
	glDisable(GL_TEXTURE_2D);
	if(!subscreen)
		DoCrosshairs();
	DoTerminal();
	DoHud();
	
	if(FlashMode==1||FlashMode==3||FlashMode==4||FlashMode==6||FlashMode==7){  //If we've been flashed...	
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glEnable(GL_BLEND);
		if(FlashMode==1)
			glColor4ub(colorarray[1][2][0],colorarray[2][2][0],colorarray[3][2][0],colorarray[4][2][0]/16);
		if(FlashMode==3)
			glColor4ub(colorarray[1][2][0],colorarray[2][2][0],colorarray[3][2][0],colorarray[4][2][0]/64);
		if(FlashMode==4){			//Inverse - fusion
			glBlendFunc(GL_ONE_MINUS_DST_COLOR,GL_ONE_MINUS_SRC_COLOR);
			glColor3ub((colorarray[4][2][0]/16),(colorarray[4][2][0]/16),(colorarray[4][2][0]/16));
		}
		if(FlashMode==6)			//PsychoFlicker
			glColor4ub(rand()%255,rand()%255,rand()%255,colorarray[4][2][0]/16);
		if(FlashMode==7){
			glColor3ub((rand()%255)*(colorarray[4][2][0]/8160.0f),(rand()%255)*(colorarray[4][2][0]/8160.0f),(rand()%255)*(colorarray[4][2][0]/8160.0f));
			glEnable(GL_COLOR_LOGIC_OP);
			glLogicOp(GL_XOR);
		}
		glBegin(GL_QUADS);
			glVertex3f(-1.0f,-1.0f,-1.0f);
			glVertex3f(1.0f,-1.0f,-1.0f);
			glVertex3f(1.0f,1.0f,-1.0f);
			glVertex3f(-1.0f,1.0f,-1.0f);
		glEnd();
		if(FlashMode==4)
			glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		if(FlashMode==7)
			glDisable(GL_COLOR_LOGIC_OP);
	}
	return 1;										// Everything Went More Or Less OK																								
}
int TimeToWait=999999;
void DoAnimations(void){
	int ki;
	TimeToWait++;
	if(TimeToWait>=PrefsFramesSkipFactor){
		TimeToWait=0;
		for(ki=1;ki<WeaponInfoArraySize;ki++){
			WeaponInfoArray[ki].frametimer+=speedfactor*PrefsFramesSkipFactor;
			if(WeaponInfoArray[ki].frametimer>=SequenceArray[WeaponInfoArray[ki].sequence].speed[WeaponInfoArray[ki].frame]||WeaponInfoArray[ki].frametimer<0){
				WeaponInfoArray[ki].frame++;
				WeaponInfoArray[ki].frametimer=0;
			}
			if(SequenceArray[WeaponInfoArray[ki].sequence].frame[WeaponInfoArray[ki].frame][0]=='-'||WeaponInfoArray[ki].frame<=0){
				WeaponInfoArray[ki].frame=1;
				WeaponInfoArray[ki].sequence = WeaponInfoArray[ki].idlesequence;
			}
			//WeaponInfoArray[ki].curspeed=SequenceArray[WeaponInfoArray[ki].sequence].speed[WeaponInfoArray[ki].frame];
		}
		for(ki=1;ki<ShotArraySize;ki++){
			ShotArray[ki].frametimer+=speedfactor*PrefsFramesSkipFactor;
			if(ShotArray[ki].frametimer>=SequenceArray[ShotInfoArray[ShotArray[ki].type].sequence].speed[ShotArray[ki].frame]||ItemInfoArray[ki].frametimer<0){
				ShotArray[ki].frame++;
				ShotArray[ki].frametimer=0;
			}
			if(SequenceArray[ShotInfoArray[ShotArray[ki].type].sequence].frame[ShotArray[ki].frame][0]=='-'||ShotArray[ki].frame<=0)
				ShotArray[ki].frame=1;
			ShotArray[ki].curspeed=SequenceArray[ShotInfoArray[ShotArray[ki].type].sequence].speed[ShotArray[ki].frame];
		}
		for(ki=1;ki<ItemInfoArraySize;ki++){
			ItemInfoArray[ki].frametimer+=speedfactor*PrefsFramesSkipFactor;
			if(ItemInfoArray[ki].frametimer>=SequenceArray[ItemInfoArray[ki].sequence].speed[ItemInfoArray[ki].frame]){
				ItemInfoArray[ki].frame++;
				ItemInfoArray[ki].frametimer=0;
			}
			if(SequenceArray[ItemInfoArray[ki].sequence].frame[ItemInfoArray[ki].frame][0]=='-')
				ItemInfoArray[ki].frame=1;
			ItemInfoArray[ki].curspeed=SequenceArray[ItemInfoArray[ki].sequence].speed[ItemInfoArray[ki].frame];
		}
		for(ki=1;ki<MonsterArraySize;ki++){
			if(MonsterArray[ki].cursequence==0)
				MonsterArray[ki].cursequence=MonsterInfoArray[MonsterArray[ki].type].sequence[1];
			MonsterArray[ki].frametimer+=speedfactor*PrefsFramesSkipFactor;
			if(MonsterArray[ki].frametimer>=SequenceArray[MonsterArray[ki].cursequence].speed[MonsterArray[ki].frame]){
				MonsterArray[ki].frame++;
				MonsterArray[ki].frametimer=0;
			}
			if(SequenceArray[MonsterArray[ki].cursequence].frame[MonsterArray[ki].frame][0]=='-'){
				if(MonsterArray[ki].curaction==4){
					MonsterArray[ki].killflag=true;
					MonsterArray[ki].frame=MonsterArray[ki].frame-1;
				}else{
					MonsterArray[ki].frame=1;
					//MonsterArray[ki].cursequence=MonsterInfoArray[MonsterArray[ki].type].sequence[1];
					MonsterArray[ki].curaction=1;
				}
			}
			MonsterArray[ki].curspeed=SequenceArray[MonsterArray[ki].cursequence].speed[MonsterArray[ki].frame];
		}
	}
	for(i=0;i<TextureArraySize;i++){
		TextureArray[i].xstretch=0.0f;
		TextureArray[i].ystretch=0.0f;
		if(TextureArray[i].transfer==2){
			TextureArray[i].xoffset+=TextureArray[i].transfervar1*speedfactor;
			TextureArray[i].yoffset+=TextureArray[i].transfervar2*speedfactor;
		}
		if(TextureArray[i].transfer==3){	//Wander, not the best but it'll do
			TextureArray[i].xoffset+=(sin(cos(pulsetimer*radians)*pulsetimer*radians)*TextureArray[i].transfervar1)*speedfactor;
			TextureArray[i].yoffset+=(cos(sin(pulsetimer*radians)*pulsetimer*radians)*TextureArray[i].transfervar2)*speedfactor;
		}
		if(TextureArray[i].transfer==8){	//Pulsate
			TextureArray[i].xstretch=(sin(pulsetimer*radians*TextureArray[i].transfervar1)*TextureArray[i].transfervar2);
			TextureArray[i].ystretch=(sin(pulsetimer*radians*TextureArray[i].transfervar1)*TextureArray[i].transfervar2);
		}

	}
	return;
}

void DrawPrimary(int theline){
	int thepoly = LineArray[theline].user1;
	int i3=LineArray[theline].primarytexture;
	glBegin(GL_QUADS);
	glTexCoord2f(LineArray[theline].x+LineArray[theline].y+TextureArray[i3].xoffset+TextureArray[i3].xstretch,PolygonArray[thepoly].floorheight+TextureArray[i3].yoffset+TextureArray[i3].ystretch);
	glColor4ub(LightArray[LineArray[theline].primarylight].CurR,LightArray[LineArray[theline].primarylight].CurG,LightArray[LineArray[theline].primarylight].CurB,Trans);
	glVertex3f(LineArray[theline].x,PolygonArray[thepoly].floorheight,LineArray[theline].y);
	
	glTexCoord2f(LineArray[theline].x+LineArray[theline].y+TextureArray[i3].xoffset+TextureArray[i3].xstretch,PolygonArray[thepoly].ceilingheight+TextureArray[i3].yoffset-TextureArray[i3].ystretch);
	glColor4ub(LightArray[LineArray[theline].primarylight].CurR,LightArray[LineArray[theline].primarylight].CurG,LightArray[LineArray[theline].primarylight].CurB,Trans);
	glVertex3f(LineArray[theline].x,PolygonArray[thepoly].ceilingheight,LineArray[theline].y);
	
	
	glTexCoord2f(LineArray[theline].x+LineArray[theline].y+sqrt(((LineArray[theline].x2-LineArray[theline].x)*(LineArray[theline].x2-LineArray[theline].x))+((LineArray[theline].y2-LineArray[theline].y)*(LineArray[theline].y2-LineArray[theline].y)))+TextureArray[i3].xoffset-TextureArray[i3].xstretch, PolygonArray[thepoly].ceilingheight+TextureArray[i3].yoffset-TextureArray[i3].ystretch);
	glColor4ub(LightArray[LineArray[theline].primarylight].CurR,LightArray[LineArray[theline].primarylight].CurG,LightArray[LineArray[theline].primarylight].CurB,Trans);
	glVertex3f(LineArray[theline].x2,PolygonArray[thepoly].ceilingheight,LineArray[theline].y2);
	
	glTexCoord2f(LineArray[theline].x+LineArray[theline].y+sqrt(((LineArray[theline].x2-LineArray[theline].x)*(LineArray[theline].x2-LineArray[theline].x))+((LineArray[theline].y2-LineArray[theline].y)*(LineArray[theline].y2-LineArray[theline].y)))+TextureArray[i3].xoffset-TextureArray[i3].xstretch, PolygonArray[thepoly].floorheight+TextureArray[i3].yoffset+TextureArray[i3].ystretch);	
	glColor4ub(LightArray[LineArray[theline].primarylight].CurR,LightArray[LineArray[theline].primarylight].CurG,LightArray[LineArray[theline].primarylight].CurB,Trans);
	glVertex3f(LineArray[theline].x2,PolygonArray[thepoly].floorheight,LineArray[theline].y2);
	glEnd();
}
void DrawNext(int i5, bool tertiary){
	int i3=LineArray[i5].user1;
	int i4=LineArray[i5].user2;
	int i6=LineArray[i5].secondarytexture;
	int light=LineArray[i5].secondarylight;
	
	GLfloat th1=PolygonArray[i3].ceilingheight, th2=PolygonArray[i4].ceilingheight;
	glBegin(GL_QUADS);
	if(tertiary){
		i6=LineArray[i5].tertiarytexture;
		th1=PolygonArray[i3].floorheight;
		th2=PolygonArray[i4].floorheight;
		light=LineArray[i5].tertiarylight;
	}
	glTexCoord2f(LineArray[i5].x+LineArray[i5].y+TextureArray[i6].xoffset-TextureArray[i6].xstretch,th1+TextureArray[i6].yoffset+TextureArray[i6].ystretch);
	glColor4ub(LightArray[light].CurR,LightArray[light].CurG,LightArray[light].CurB,Trans);
	glVertex3f(LineArray[i5].x,th1,LineArray[i5].y);
	///////////////////
	glTexCoord2f(LineArray[i5].x+LineArray[i5].y+TextureArray[i6].xoffset-TextureArray[i6].xstretch,th2+TextureArray[i6].yoffset-TextureArray[i6].ystretch);
	glColor4ub(LightArray[light].CurR,LightArray[light].CurG,LightArray[light].CurB,Trans);
	glVertex3f(LineArray[i5].x,th2,LineArray[i5].y);

	glTexCoord2f(
		LineArray[i5].x+LineArray[i5].y+sqrt(((LineArray[i5].x2-LineArray[i5].x)*(LineArray[i5].x2-LineArray[i5].x))
			+((LineArray[i5].y2-LineArray[i5].y)*(LineArray[i5].y2-LineArray[i5].y)))
			+TextureArray[i6].xoffset+TextureArray[i6].xstretch
			,th2+TextureArray[i6].yoffset-TextureArray[i6].ystretch);
	glColor4ub(LightArray[light].CurR,LightArray[light].CurG,LightArray[light].CurB,Trans);
	glVertex3f(LineArray[i5].x2,th2,LineArray[i5].y2);

	//////////
	glTexCoord2f(
		LineArray[i5].x+LineArray[i5].y+sqrt(((LineArray[i5].x2-LineArray[i5].x)*(LineArray[i5].x2-LineArray[i5].x))
			+((LineArray[i5].y2-LineArray[i5].y)*(LineArray[i5].y2-LineArray[i5].y)))
			+TextureArray[i6].xoffset+TextureArray[i6].xstretch
			,th1+TextureArray[i6].yoffset+TextureArray[i6].ystretch);
	glColor4ub(LightArray[light].CurR,LightArray[light].CurG,LightArray[light].CurB,Trans);
	glVertex3f(LineArray[i5].x2,th1,LineArray[i5].y2);

	glEnd();
}
bool ActivateTransfer(int thingy, bool transt){
	glBindTexture(GL_TEXTURE_2D, BitmapArray[TextureArray[thingy].bmpnumber]);
	switch(TextureArray[thingy].transfer){
		case 0:
			return true;
			break;
		case 6:
			if(!transt)
				return true;
			else
				Trans=TextureArray[thingy].transfervar1;
			break;
		case 5:
			TextureArray[thingy].xoffset=(rand()%1280)/1280.0f;
			TextureArray[thingy].yoffset=(rand()%1280)/1280.0f;
		case 4:
			glBindTexture(GL_TEXTURE_2D, StaticTextures[rand()%8]);
		case 7:
			glEnable(GL_COLOR_LOGIC_OP);
			glLogicOp(GL_XOR);
			break;

		default:
			glDisable(GL_COLOR_LOGIC_OP);
		}
	return 0;
}

void DrawTransparents(void){
	int i3=0, i4=0, i5=0, i6=0;
	int mi=1, ci=1, thepoly=0;
	GLfloat flx1, flx2, flx3, fly1, fly2, fly3, flz1, flz2, flz3;
	
	glEnable(GL_BLEND);
	glEnable(GL_TEXTURE_2D);
	glDepthMask(GL_FALSE);
	//Draw normal sides
	for(i=0;i<PolygonArraySize;i++){
		thepoly=i;
		for(i2=0;i2<LinesPerPoly;i2++){
			if(PolygonArray[thepoly].lines[i2]>0){
				i3=LineArray[PolygonArray[thepoly].lines[i2]].primarytexture;
				if(TextureArray[i3].transfer==6&&LineArray[PolygonArray[thepoly].lines[i2]].primarytexture>0){
					if(!ActivateTransfer(i3,true))
						DrawPrimary(PolygonArray[thepoly].lines[i2]);
				}
				i3=LineArray[PolygonArray[thepoly].lines[i2]].secondarytexture;
				if(TextureArray[i3].transfer==6&&LineArray[PolygonArray[thepoly].lines[i2]].shared&&LineArray[PolygonArray[thepoly].lines[i2]].secondarytexture>0){
					if(!ActivateTransfer(i3,true)){
						TextureArray[i3].yoffset-=LineArray[PolygonArray[thepoly].lines[i2]].ytexoffset2;
						DrawNext(PolygonArray[thepoly].lines[i2],false);
						TextureArray[i3].yoffset+=LineArray[PolygonArray[thepoly].lines[i2]].ytexoffset2;
					}
				}
				i3=LineArray[PolygonArray[thepoly].lines[i2]].tertiarytexture;
				if(TextureArray[i3].transfer==6&&LineArray[PolygonArray[thepoly].lines[i2]].shared&&LineArray[PolygonArray[thepoly].lines[i2]].tertiarytexture>0){
					if(!ActivateTransfer(i3,true)){
						TextureArray[i3].yoffset-=LineArray[PolygonArray[thepoly].lines[i2]].ytexoffset1;
						DrawNext(PolygonArray[thepoly].lines[i2],true);
						TextureArray[i3].yoffset+=LineArray[PolygonArray[thepoly].lines[i2]].ytexoffset1;
					}
				}
			}
		

		}
		i6=0;
		i3=PolygonArray[thepoly].ceilingtexture;
		if(TextureArray[i3].transfer==6&&i3>0){
			glBindTexture(GL_TEXTURE_2D, BitmapArray[TextureArray[i3].bmpnumber]);
			glColor4ub(LightArray[PolygonArray[thepoly].ceilinglight].CurR,LightArray[PolygonArray[thepoly].ceilinglight].CurG,LightArray[PolygonArray[thepoly].ceilinglight].CurB,Trans);
			if(!ActivateTransfer(i3,true))
				if(!i6){
					glBegin(GL_POLYGON);
						for(i2=0;i2<LinesPerPoly;i2++)
							if(PolygonArray[thepoly].lines[i2] != -1){
								glTexCoord2f((LineArray[PolygonArray[thepoly].lines[i2]].x+TextureArray[i3].xoffset)-(TextureArray[i3].xstretch*(LineArray[PolygonArray[thepoly].lines[i2]].x-PolygonArray[thepoly].centerx)), (LineArray[PolygonArray[thepoly].lines[i2]].y+TextureArray[i3].yoffset)-(TextureArray[i3].ystretch*(LineArray[PolygonArray[thepoly].lines[i2]].y-PolygonArray[thepoly].centery)));
								glVertex3f(LineArray[PolygonArray[thepoly].lines[i2]].x,PolygonArray[thepoly].ceilingheight,LineArray[PolygonArray[thepoly].lines[i2]].y);
								glTexCoord2f((LineArray[PolygonArray[thepoly].lines[i2]].x2+TextureArray[i3].xoffset)-(TextureArray[i3].xstretch*(LineArray[PolygonArray[thepoly].lines[i2]].x2-PolygonArray[thepoly].centerx)), (LineArray[PolygonArray[thepoly].lines[i2]].y2+TextureArray[i3].yoffset)-(TextureArray[i3].ystretch*(LineArray[PolygonArray[thepoly].lines[i2]].y2-PolygonArray[thepoly].centery)));
								glVertex3f(LineArray[PolygonArray[thepoly].lines[i2]].x2,PolygonArray[thepoly].ceilingheight,LineArray[PolygonArray[thepoly].lines[i2]].y2);
							}
					glEnd();
				}
		}
			i6=0;
		i3=PolygonArray[thepoly].floortexture;
		if(TextureArray[i3].transfer==6&&i3>0){
		glBindTexture(GL_TEXTURE_2D, BitmapArray[TextureArray[i3].bmpnumber]);
		glColor4ub(LightArray[PolygonArray[thepoly].floorlight].CurR,LightArray[PolygonArray[thepoly].floorlight].CurG,LightArray[PolygonArray[thepoly].floorlight].CurB,Trans);
		if(!ActivateTransfer(i3,true))
			if(!i6){
				glBegin(GL_POLYGON);
					for(i2=0;i2<LinesPerPoly;i2++)
						if(PolygonArray[thepoly].lines[i2] != -1){
							glTexCoord2f((LineArray[PolygonArray[thepoly].lines[i2]].x+TextureArray[i3].xoffset)-(TextureArray[i3].xstretch*(LineArray[PolygonArray[thepoly].lines[i2]].x-PolygonArray[thepoly].centerx)), (LineArray[PolygonArray[thepoly].lines[i2]].y+TextureArray[i3].yoffset)-(TextureArray[i3].ystretch*(LineArray[PolygonArray[thepoly].lines[i2]].y-PolygonArray[thepoly].centery)));
							glVertex3f(LineArray[PolygonArray[thepoly].lines[i2]].x,PolygonArray[thepoly].floorheight,LineArray[PolygonArray[thepoly].lines[i2]].y);
							glTexCoord2f((LineArray[PolygonArray[thepoly].lines[i2]].x2+TextureArray[i3].xoffset)-(TextureArray[i3].xstretch*(LineArray[PolygonArray[thepoly].lines[i2]].x2-PolygonArray[thepoly].centerx)), (LineArray[PolygonArray[thepoly].lines[i2]].y2+TextureArray[i3].yoffset)-(TextureArray[i3].ystretch*(LineArray[PolygonArray[thepoly].lines[i2]].y2-PolygonArray[thepoly].centery)));
							glVertex3f(LineArray[PolygonArray[thepoly].lines[i2]].x2,PolygonArray[thepoly].floorheight,LineArray[PolygonArray[thepoly].lines[i2]].y2);
						}
				glEnd();
			}
		}

		
		i6=PolygonArray[thepoly].media;
		i3=MediaArray[i6].texture;
		if(i3>0&&i3>0){
			flx1=((LightArray[MediaArray[i6].lightbase].CurR+LightArray[MediaArray[i6].lightbase].CurG+LightArray[MediaArray[i6].lightbase].CurB)/3)/255.0f;
			flx2=MediaArray[i6].nadir+((MediaArray[i6].apex-MediaArray[i6].nadir)*flx1);
			glBindTexture(GL_TEXTURE_2D, BitmapArray[TextureArray[i3].bmpnumber]);
			glColor4ub(LightArray[MediaArray[i6].light].CurR,LightArray[MediaArray[i6].light].CurG,LightArray[MediaArray[i6].light].CurB,128);
			if(!ActivateTransfer(i3,false)){
				glBegin(GL_POLYGON);
					for(i2=0;i2<LinesPerPoly;i2++)
						if(PolygonArray[thepoly].lines[i2] != -1){
							glTexCoord2f(LineArray[PolygonArray[thepoly].lines[i2]].x+TextureArray[i3].xoffset, LineArray[PolygonArray[thepoly].lines[i2]].y+TextureArray[i3].yoffset);
							glVertex3f(LineArray[PolygonArray[thepoly].lines[i2]].x,flx2,LineArray[PolygonArray[thepoly].lines[i2]].y);
							glTexCoord2f(LineArray[PolygonArray[thepoly].lines[i2]].x2+TextureArray[i3].xoffset, LineArray[PolygonArray[thepoly].lines[i2]].y2+TextureArray[i3].yoffset);
							glVertex3f(LineArray[PolygonArray[thepoly].lines[i2]].x2,flx2,LineArray[PolygonArray[thepoly].lines[i2]].y2);
						}
				glEnd();
			}
		}

	}
	
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);	//I really shouldn't, but it does make things much prettier

	glDisable(GL_TEXTURE_2D);
	if(PrefsParticleFX){
		for(i=0;i<ParticleArraySize;i++){
			if(ParticleArray[i].type>0){
				glTranslatef(ParticleArray[i].x,ParticleArray[i].y,ParticleArray[i].z);
				glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,((float)ParticleArray[i].life/ParticleArray[i].startlife)*ParticleInfoArray[ParticleArray[i].type].trans);
				if(ParticleInfoArray[ParticleArray[i].type].mode==1){
					glRotatef(ParticleArray[i].xr,1.0f,0.0f,0.0f);
					glRotatef(ParticleArray[i].yr,0.0f,1.0f,0.0f);
					glRotatef(ParticleArray[i].zr,0.0f,0.0f,1.0f);
					glBegin(GL_TRIANGLES);
						glVertex3f(0.03f,0.0f,0.0f);
						glVertex3f(0.0f,0.03f,0.0f);
						glVertex3f(0.0f,0.0f,0.03f);
					glEnd();
					glRotatef(ParticleArray[i].zr,0.0f,0.0f,-1.0f);
					glRotatef(ParticleArray[i].yr,0.0f,-1.0f,0.0f);
					glRotatef(ParticleArray[i].xr,-1.0f,0.0f,0.0f);
				}
				if(ParticleInfoArray[ParticleArray[i].type].mode==2){
					glBegin(GL_LINES);
						glVertex3f(0.0f,0.0f,0.0f);
						glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,0);
						glVertex3f(-(ParticleArray[i].xs*4.0f),-(ParticleArray[i].ys*4.0f),-(ParticleArray[i].zs*4.0f));
					glEnd();
				}
				if(ParticleInfoArray[ParticleArray[i].type].mode==3){
					glBegin(GL_TRIANGLES);
						glVertex3f(-0.003f,0.0f,0.0f);
						glVertex3f(0.003f,0.0f,0.0f);
						glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,0);
						glVertex3f(-(ParticleArray[i].xs*4.0f),-(ParticleArray[i].ys*4.0f),-(ParticleArray[i].zs*4.0f));
						glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,((float)ParticleArray[i].life/ParticleArray[i].startlife)*ParticleInfoArray[ParticleArray[i].type].trans);
						glVertex3f(0.0f,0.0f,0.003f);
						glVertex3f(0.0f,0.0f,-0.003f);
						glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,0);
						glVertex3f(-(ParticleArray[i].xs*4.0f),-(ParticleArray[i].ys*4.0f),-(ParticleArray[i].zs*4.0f));
					glEnd();
				}
				if(ParticleInfoArray[ParticleArray[i].type].mode==4){
					glBegin(GL_POINTS);
						glVertex3f(0.0f,0.0f,0.0f);
					glEnd();
				}
				if(ParticleInfoArray[ParticleArray[i].type].mode==5||ParticleInfoArray[ParticleArray[i].type].mode==8){
					glRotatef(Player.zdir,0.0f,0.0f,-1.0f);
					glRotatef(Player.xdir,0.0f,-1.0f,0.0f);
					glRotatef(Player.ydir,-1.0f,0.0f,0.0f);
					glTranslatef(0.0f,0.0f,0.2f);
					//Soft particles.
					glRotatef(ParticleArray[i].zr,0.0f,0.0f,1.0f);
					glBegin(GL_TRIANGLES);
						glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,((float)ParticleArray[i].life/ParticleArray[i].startlife)*ParticleInfoArray[ParticleArray[i].type].trans); glVertex3f(0.0f,0.0f,0.0f);
						glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,0); glVertex3f(-0.01f*ParticleInfoArray[ParticleArray[i].type].model,0.0f,0.0f); glVertex3f(0.0f,0.01f*ParticleInfoArray[ParticleArray[i].type].model,0.0f);
						glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,((float)ParticleArray[i].life/ParticleArray[i].startlife)*ParticleInfoArray[ParticleArray[i].type].trans); glVertex3f(0.0f,0.0f,0.0f);
						glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,0); glVertex3f(-0.01f*ParticleInfoArray[ParticleArray[i].type].model,0.0f,0.0f); glVertex3f(0.0f,-0.01f*ParticleInfoArray[ParticleArray[i].type].model,0.0f);
						glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,((float)ParticleArray[i].life/ParticleArray[i].startlife)*ParticleInfoArray[ParticleArray[i].type].trans); glVertex3f(0.0f,0.0f,0.0f);
						glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,0); glVertex3f(0.01f*ParticleInfoArray[ParticleArray[i].type].model,0.0f,0.0f); glVertex3f(0.0f,0.01f*ParticleInfoArray[ParticleArray[i].type].model,0.0f);
						glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,((float)ParticleArray[i].life/ParticleArray[i].startlife)*ParticleInfoArray[ParticleArray[i].type].trans); glVertex3f(0.0f,0.0f,0.0f);
						glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,0); glVertex3f(0.01f*ParticleInfoArray[ParticleArray[i].type].model,0.0f,0.0f); glVertex3f(0.0f,-0.01f*ParticleInfoArray[ParticleArray[i].type].model,0.f);

					glEnd();
					glRotatef(ParticleArray[i].zr,0.0f,0.0f,-1.0f);
					glTranslatef(0.0f,0.0f,-0.2f);
					glRotatef(Player.ydir,1.0f,0.0f,0.0f);
					glRotatef(Player.xdir,0.0f,1.0f,0.0f);
					glRotatef(Player.zdir,0.0f,0.0f,1.0f);
				}
				if(ParticleInfoArray[ParticleArray[i].type].mode==6||ParticleInfoArray[ParticleArray[i].type].mode==7||ParticleInfoArray[ParticleArray[i].type].mode==9){
					glTranslatef(-ParticleArray[i].x,-ParticleArray[i].y,-ParticleArray[i].z);
					glLineWidth(ParticleInfoArray[ParticleArray[i].type].model);
					//Lines
					glBegin(GL_LINES);
						glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,((float)ParticleArray[i].life/ParticleArray[i].startlife)*ParticleInfoArray[ParticleArray[i].type].trans);
						glVertex3f(ParticleArray[i].x,ParticleArray[i].y,ParticleArray[i].z);
						if(ParticleInfoArray[ParticleArray[i].type].mode==7)
							glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,0);
						glVertex3f(ParticleArray[i].x2,ParticleArray[i].y2,ParticleArray[i].z2);
					glEnd();
					if(ParticleInfoArray[ParticleArray[i].type].mode==9)
						for(i2=ParticleInfoArray[ParticleArray[i].type].model;i2>0;i2--){
							glLineWidth(i2);
							glBegin(GL_LINES);
								glColor4ub(ParticleInfoArray[ParticleArray[i].type].r,ParticleInfoArray[ParticleArray[i].type].g,ParticleInfoArray[ParticleArray[i].type].b,((float)ParticleArray[i].life/ParticleArray[i].startlife)*ParticleInfoArray[ParticleArray[i].type].trans);
								glVertex3f(ParticleArray[i].x,ParticleArray[i].y,ParticleArray[i].z);
								glVertex3f(ParticleArray[i].x2,ParticleArray[i].y2,ParticleArray[i].z2);
							glEnd();
						}
					glLineWidth(1);
					glTranslatef(ParticleArray[i].x,ParticleArray[i].y,ParticleArray[i].z);
				}
				glTranslatef(-ParticleArray[i].x,-ParticleArray[i].y,-ParticleArray[i].z);
			}
		}
	}

	glDepthMask(GL_TRUE);
}
void DrawNormally(void){
	int i3=0, i4=0, i5=0, i6=0;
	int mi=1, ci=1, thepoly=0;
	GLfloat flx1, flx2, flx3, fly1, fly2, fly3, flz1, flz2, flz3;
	
		

	//Draw normal sides
	for(i=0;i<PolygonArraySize;i++){
		thepoly=i;
		for(i2=0;i2<LinesPerPoly;i2++){
			if(PolygonArray[thepoly].lines[i2] != -1){
				i3=LineArray[PolygonArray[thepoly].lines[i2]].primarytexture;
				if(i3>0){
					if(!ActivateTransfer(i3,false))
						DrawPrimary(PolygonArray[thepoly].lines[i2]);
				}
				i3=LineArray[PolygonArray[thepoly].lines[i2]].secondarytexture;
				if(LineArray[PolygonArray[thepoly].lines[i2]].shared&&i3>0){
					TextureArray[i3].yoffset-=LineArray[PolygonArray[thepoly].lines[i2]].ytexoffset2;
					if(!ActivateTransfer(i3,false))
						DrawNext(PolygonArray[thepoly].lines[i2],false);
					TextureArray[i3].yoffset+=LineArray[PolygonArray[thepoly].lines[i2]].ytexoffset2;
				}
				i3=LineArray[PolygonArray[thepoly].lines[i2]].tertiarytexture;
				if(LineArray[PolygonArray[thepoly].lines[i2]].shared&&i3>0){
					TextureArray[i3].yoffset-=LineArray[PolygonArray[thepoly].lines[i2]].ytexoffset1;
					if(!ActivateTransfer(i3,false))
						DrawNext(PolygonArray[thepoly].lines[i2],true);
					TextureArray[i3].yoffset+=LineArray[PolygonArray[thepoly].lines[i2]].ytexoffset1;
				}
			}
		}

		i6=0;
		i3=PolygonArray[thepoly].ceilingtexture;
		if(i3>0){
			glBindTexture(GL_TEXTURE_2D, BitmapArray[TextureArray[i3].bmpnumber]);
			glColor4ub(LightArray[PolygonArray[thepoly].ceilinglight].CurR,LightArray[PolygonArray[thepoly].ceilinglight].CurG,LightArray[PolygonArray[thepoly].ceilinglight].CurB,Trans);
			if(!ActivateTransfer(i3,false))
				if(!i6){
					glBegin(GL_POLYGON);
						for(i2=0;i2<LinesPerPoly;i2++)
							if(PolygonArray[thepoly].lines[i2] != -1){
								glTexCoord2f((LineArray[PolygonArray[thepoly].lines[i2]].x+TextureArray[i3].xoffset)-(TextureArray[i3].xstretch*(LineArray[PolygonArray[thepoly].lines[i2]].x-PolygonArray[thepoly].centerx)), (LineArray[PolygonArray[thepoly].lines[i2]].y+TextureArray[i3].yoffset)-(TextureArray[i3].ystretch*(LineArray[PolygonArray[thepoly].lines[i2]].y-PolygonArray[thepoly].centery)));
								glVertex3f(LineArray[PolygonArray[thepoly].lines[i2]].x,PolygonArray[thepoly].ceilingheight,LineArray[PolygonArray[thepoly].lines[i2]].y);
								glTexCoord2f((LineArray[PolygonArray[thepoly].lines[i2]].x2+TextureArray[i3].xoffset)-(TextureArray[i3].xstretch*(LineArray[PolygonArray[thepoly].lines[i2]].x2-PolygonArray[thepoly].centerx)), (LineArray[PolygonArray[thepoly].lines[i2]].y2+TextureArray[i3].yoffset)-(TextureArray[i3].ystretch*(LineArray[PolygonArray[thepoly].lines[i2]].y2-PolygonArray[thepoly].centery)));
								glVertex3f(LineArray[PolygonArray[thepoly].lines[i2]].x2,PolygonArray[thepoly].ceilingheight,LineArray[PolygonArray[thepoly].lines[i2]].y2);
							}
					glEnd();
				}
		}
		
		i6=0;
		i3=PolygonArray[thepoly].floortexture;
		if(i3>0){
		glBindTexture(GL_TEXTURE_2D, BitmapArray[TextureArray[i3].bmpnumber]);
		glColor4ub(LightArray[PolygonArray[thepoly].floorlight].CurR,LightArray[PolygonArray[thepoly].floorlight].CurG,LightArray[PolygonArray[thepoly].floorlight].CurB,Trans);
		if(!ActivateTransfer(i3,false))
			if(!i6){
				glBegin(GL_POLYGON);
					for(i2=0;i2<LinesPerPoly;i2++)
						if(PolygonArray[thepoly].lines[i2] != -1){
							glTexCoord2f((LineArray[PolygonArray[thepoly].lines[i2]].x+TextureArray[i3].xoffset)-(TextureArray[i3].xstretch*(LineArray[PolygonArray[thepoly].lines[i2]].x-PolygonArray[thepoly].centerx)), (LineArray[PolygonArray[thepoly].lines[i2]].y+TextureArray[i3].yoffset)-(TextureArray[i3].ystretch*(LineArray[PolygonArray[thepoly].lines[i2]].y-PolygonArray[thepoly].centery)));
							glVertex3f(LineArray[PolygonArray[thepoly].lines[i2]].x,PolygonArray[thepoly].floorheight,LineArray[PolygonArray[thepoly].lines[i2]].y);
							glTexCoord2f((LineArray[PolygonArray[thepoly].lines[i2]].x2+TextureArray[i3].xoffset)-(TextureArray[i3].xstretch*(LineArray[PolygonArray[thepoly].lines[i2]].x2-PolygonArray[thepoly].centerx)), (LineArray[PolygonArray[thepoly].lines[i2]].y2+TextureArray[i3].yoffset)-(TextureArray[i3].ystretch*(LineArray[PolygonArray[thepoly].lines[i2]].y2-PolygonArray[thepoly].centery)));
							glVertex3f(LineArray[PolygonArray[thepoly].lines[i2]].x2,PolygonArray[thepoly].floorheight,LineArray[PolygonArray[thepoly].lines[i2]].y2);
						}
				glEnd();
			}
		}
	}
	
	if(NightVision && FlashMode==0){
		glEnable(GL_BLEND);
		glDepthMask(GL_FALSE);
		Trans=255;
		glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	}else
		glDisable (GL_CULL_FACE);

	glDisable(GL_COLOR_LOGIC_OP);

	for(i=0;i<ItemArraySize;i++){
		if(ItemArray[i].type>0){
			i2=LightArray[PolygonArray[ItemArray[i].polyparent].floorlight].CurR;
			i3=LightArray[PolygonArray[ItemArray[i].polyparent].floorlight].CurG;
			i4=LightArray[PolygonArray[ItemArray[i].polyparent].floorlight].CurB;
			glColor4ub(i2,i3,i4,Trans);
			glTranslatef(ItemArray[i].x,ItemArray[i].y,ItemArray[i].z);
			glRotatef(ItemArray[i].direction,0.0f,-1.0f,0.0f);
			
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, BitmapArray[ItemInfoArray[ItemArray[i].type].skin]);
			if(ItemInfoArray[ItemArray[i].type].sequence>0)
				glCallList(SequenceArray[ItemInfoArray[ItemArray[i].type].sequence].lists[ItemInfoArray[ItemArray[i].type].frame].thelist[(int)ItemInfoArray[ItemArray[i].type].frametimer]);
			glRotatef(ItemArray[i].direction,0.0f,1.0f,0.0f);
			glTranslatef(-ItemArray[i].x,-ItemArray[i].y,-ItemArray[i].z);
		}
	}
	if(Prefs3rdPerson)
		i2=0;
	else
		i2=1;
	for(i=i2;i<MonsterArraySize;i++){
		i2=LightArray[PolygonArray[MonsterArray[i].polyparent].floorlight].CurR;
		i3=LightArray[PolygonArray[MonsterArray[i].polyparent].floorlight].CurG;
		i4=LightArray[PolygonArray[MonsterArray[i].polyparent].floorlight].CurB;
		glColor4ub(i2,i3,i4,Trans);
		glTranslatef(MonsterArray[i].x,MonsterArray[i].y,MonsterArray[i].z);
		if(PrefsNostalgiaMode==true){
			GLfloat dir=int(MonsterArray[i].xdir/45.0f)*45.0f;
			glRotatef(dir+180.0f,0.0f,-1.0f,0.0f);
		}else
			glRotatef(MonsterArray[i].xdir+180.0f,0.0f,-1.0f,0.0f);
		if(MonsterInfoArray[MonsterArray[i].type].flying)
			glRotatef(MonsterArray[i].ydir,1.0f,0.0f,0.0f);
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D,BitmapArray[MonsterInfoArray[MonsterArray[i].type].skin]);
		if(MonsterArray[i].cursequence>0&&MonsterArray[i].frame>0&&MonsterArray[i].visible)
			glCallList(SequenceArray[MonsterArray[i].cursequence].lists[MonsterArray[i].frame].thelist[(int)MonsterArray[i].frametimer]);
		if(MonsterInfoArray[MonsterArray[i].type].flying)
			glRotatef(MonsterArray[i].ydir,-1.0f,0.0f,0.0f);
		if(PrefsNostalgiaMode==true){
			GLfloat dir=int(MonsterArray[i].xdir/45.0f)*45.0f;
			glRotatef(dir+180.0f,0.0f,1.0f,0.0f);
		}else
			glRotatef(MonsterArray[i].xdir+180.0f,0.0f,1.0f,0.0f);
		glTranslatef(-MonsterArray[i].x,-MonsterArray[i].y,-MonsterArray[i].z);
	}
	for(i=0;i<ShotArraySize;i++){
		i2=LightArray[PolygonArray[ShotArray[i].polyparent].floorlight].CurR;
		i3=LightArray[PolygonArray[ShotArray[i].polyparent].floorlight].CurG;
		i4=LightArray[PolygonArray[ShotArray[i].polyparent].floorlight].CurB;
		glColor3ub(i2,i3,i4);
		glTranslatef(ShotArray[i].x,ShotArray[i].y,ShotArray[i].z);
		glRotatef(ShotArray[i].xdir,0.0f,-1.0f,0.0f);
		glRotatef(ShotArray[i].ydir,-1.0f,0.0f,0.0f);
		if(ShotInfoArray[ShotArray[i].type].skin>0)
			glBindTexture(GL_TEXTURE_2D,BitmapArray[ShotInfoArray[ShotArray[i].type].skin]);
		if(ShotInfoArray[ShotArray[i].type].sequence>0&&SequenceArray[ShotInfoArray[ShotArray[i].type].sequence].lists[ShotArray[i].frame].thelist[(int)ShotArray[i].frametimer]>0)
			glCallList(SequenceArray[ShotInfoArray[ShotArray[i].type].sequence].lists[ShotArray[i].frame].thelist[(int)ShotArray[i].frametimer]);
		glRotatef(ShotArray[i].ydir,1.0f,0.0f,0.0f);
		glRotatef(ShotArray[i].xdir,0.0f,1.0f,0.0f);
		glTranslatef(-ShotArray[i].x,-ShotArray[i].y,-ShotArray[i].z);
	}
	

	DrawTransparents();
	return;
}
#ifdef modelformatmeshwork
void LoadShapeIntoMesh(char filepath[255], int slot){
	FILE *fptr;
	int fi=false;
	int ki=0;
	char linedata[255];
	char newpath[255];
	int fodder;
	int LastFoundNormal=0;
	int LastFoundTexcoord=0;
	int LastFoundFace=0;
	int LastFoundPoint=0;
	int LastFoundEdge=0;
	sprintf(newpath,"%s/%s",ScenarioDir,filepath);
	if((fptr = fopen(newpath, "rt"))==NULL){       //Open filestream
		//fprintf(stderr,"Number of models:%i\n",model-1);
		return;
	}
	
	ReadMeshLine(fptr,linedata);
	
	if(sscanf(linedata,"Mesh")){
		fprintf(stderr,"Model %s ain't no Meshwork file.\n",filepath);
		return;
	}
	ReadMeshLine(fptr,linedata);
	
	do{
		ReadMeshLine(fptr,linedata);
		fi=sscanf(linedata, "%i",&LastFoundPoint);
		fi=sscanf(linedata, "%i	%f	%f	%f\n",
				&fodder,
				&models[slot].PointArray[LastFoundPoint].x,
				&models[slot].PointArray[LastFoundPoint].y,
				&models[slot].PointArray[LastFoundPoint].z);
	}while(!sscanf(linedata,"END\n")&&!sscanf(linedata,"EDGES\n")&&fi);
	ReadMeshLine(fptr,linedata);
	do{
		ReadMeshLine(fptr,linedata);
		fi=sscanf(linedata, "%i	%i\n",
				&models[slot].EdgeArray[LastFoundEdge].point[1],
				&models[slot].EdgeArray[LastFoundEdge].point[2]);
		if(fi)
			LastFoundEdge++;
	}while(!sscanf(linedata,"END\n")&&fi);

	do{
		ReadMeshLine(fptr,linedata);
		fi=sscanf(linedata, "%i	%i %i\n",
				&models[slot].FaceArray[LastFoundFace].point[1],
				&models[slot].FaceArray[LastFoundFace].point[2],
				&models[slot].FaceArray[LastFoundFace].point[3]);
		if(fi)
			LastFoundFace++;
	}while(!sscanf(linedata,"END\n")&&fi);

	do{
		ReadMeshLine(fptr,linedata);
		fi=sscanf(linedata, "%i",&LastFoundTexcoord);
		fi=sscanf(linedata, "%i	%f	%f\n",
				&fodder,
				&models[slot].TexcoordArray[LastFoundTexcoord].u,
				&models[slot].TexcoordArray[LastFoundTexcoord].v);
	}while(!sscanf(linedata,"END\n")&&!sscanf(linedata,"EDGES\n")&&fi);
	models[slot].FaceArraySize=LastFoundFace;
	models[slot].PointArraySize=LastFoundPoint;
	models[slot].TexcoordArraySize=LastFoundTexcoord;
	models[slot].NormalArraySize=LastFoundNormal;
	fclose(fptr);		//Close filestream.
	return;
}
#endif
void BuildList(int thelist){
	int i5, i6, i7;
	GLfloat flx1, fly1, flz1, flx2, fly2, flz2, flx3, fly3, flz3;
	GLfloat ffx, ffy, ffz;	//position offsets
	GLfloat frx, fry, frz;	//rotation amounts
	i=thelist;
	sprintf(TermText,"Building display list %i",thelist+1);
	for(i6=1;i6<SequenceArray[i].frames;i6++){
		LoadShapeIntoMesh(SequenceArray[i].frame[i6],1);
		if(SequenceArray[i].frame[i6+1][0]=='-')
			i7=1;
		else
			i7=i6+1;
		
		LoadShapeIntoMesh(SequenceArray[i].frame[i7],2);
			
		SequenceArray[i].lists[i6].thelist = new GLuint[SequenceArray[i].speed[i6]+1];
		//fprintf(stderr, "Building display list %i-%i\n",i,i6);
		for(i5=0;i5<SequenceArray[i].speed[i6]+1;i5+=PrefsFramesSkipFactor){			//For each display list...
			SequenceArray[i].lists[i6].thelist[(int)i5]=glGenLists(1);
			glNewList(SequenceArray[i].lists[i6].thelist[(int)i5],GL_COMPILE);//Create the damn thing...
			
				flx1=0.0f; fly1=0.0f; flz1=0.0f;
				flx2=0.0f; fly2=0.0f; flz2=0.0f;
				flx3=0.0f; fly3=0.0f; flz3=0.0f;
				ffx=SequenceArray[i].xoffset[i6]; ffy=SequenceArray[i].yoffset[i6]; ffz=SequenceArray[i].zoffset[i6];
				//frx=SequenceArray[i].xrot[i6];
				//fry=SequenceArray[i].yrot[i6]; frz=SequenceArray[i].zrot[i6];
			if(SequenceArray[i].inter[i6]){
				frx=SequenceArray[i].xrot[i6]-(((SequenceArray[i].xrot[i6])-(SequenceArray[i].xrot[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]));
				fry=SequenceArray[i].yrot[i6]-(((SequenceArray[i].yrot[i6])-(SequenceArray[i].yrot[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]));
				frz=SequenceArray[i].zrot[i6]-(((SequenceArray[i].zrot[i6])-(SequenceArray[i].zrot[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]));
				ffx=SequenceArray[i].xoffset[i6]-(((SequenceArray[i].xoffset[i6])-(SequenceArray[i].xoffset[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]));
				ffy=SequenceArray[i].yoffset[i6]-(((SequenceArray[i].yoffset[i6])-(SequenceArray[i].yoffset[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]));
				ffz=SequenceArray[i].zoffset[i6]-(((SequenceArray[i].zoffset[i6])-(SequenceArray[i].zoffset[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]));					
			}
			glRotatef(frx,1.0f,0.0f,0.0f);
			glRotatef(fry,0.0f,1.0f,0.0f);
			glRotatef(frz,0.0f,0.0f,1.0f);
			glBegin(GL_TRIANGLES);
			for(i2=0;i2<models[1].FaceArraySize;i2++){		//For each face...
					if(SequenceArray[i].inter[i6]){
						if(SequenceArray[i].ignore[i6]){
							flx1=-((models[1].PointArray[models[1].FaceArray[i2].point[1]].x*SequenceArray[i].scale[i6])-(models[2].PointArray[models[1].FaceArray[i2].point[1]].x*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							flx2=-((models[1].PointArray[models[1].FaceArray[i2].point[2]].x*SequenceArray[i].scale[i6])-(models[2].PointArray[models[1].FaceArray[i2].point[2]].x*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							flx3=-((models[1].PointArray[models[1].FaceArray[i2].point[3]].x*SequenceArray[i].scale[i6])-(models[2].PointArray[models[1].FaceArray[i2].point[3]].x*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							fly1=-((models[1].PointArray[models[1].FaceArray[i2].point[1]].y*SequenceArray[i].scale[i6])-(models[2].PointArray[models[1].FaceArray[i2].point[1]].y*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							fly2=-((models[1].PointArray[models[1].FaceArray[i2].point[2]].y*SequenceArray[i].scale[i6])-(models[2].PointArray[models[1].FaceArray[i2].point[2]].y*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							fly3=-((models[1].PointArray[models[1].FaceArray[i2].point[3]].y*SequenceArray[i].scale[i6])-(models[2].PointArray[models[1].FaceArray[i2].point[3]].y*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							flz1=-((models[1].PointArray[models[1].FaceArray[i2].point[1]].z*SequenceArray[i].scale[i6])-(models[2].PointArray[models[1].FaceArray[i2].point[1]].z*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							flz2=-((models[1].PointArray[models[1].FaceArray[i2].point[2]].z*SequenceArray[i].scale[i6])-(models[2].PointArray[models[1].FaceArray[i2].point[2]].z*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							flz3=-((models[1].PointArray[models[1].FaceArray[i2].point[3]].z*SequenceArray[i].scale[i6])-(models[2].PointArray[models[1].FaceArray[i2].point[3]].z*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
						}else{
							flx1=-((models[1].PointArray[models[1].FaceArray[i2].point[1]].x*SequenceArray[i].scale[i6])-(models[2].PointArray[models[2].FaceArray[i2].point[1]].x*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							flx2=-((models[1].PointArray[models[1].FaceArray[i2].point[2]].x*SequenceArray[i].scale[i6])-(models[2].PointArray[models[2].FaceArray[i2].point[2]].x*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							flx3=-((models[1].PointArray[models[1].FaceArray[i2].point[3]].x*SequenceArray[i].scale[i6])-(models[2].PointArray[models[2].FaceArray[i2].point[3]].x*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							fly1=-((models[1].PointArray[models[1].FaceArray[i2].point[1]].y*SequenceArray[i].scale[i6])-(models[2].PointArray[models[2].FaceArray[i2].point[1]].y*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							fly2=-((models[1].PointArray[models[1].FaceArray[i2].point[2]].y*SequenceArray[i].scale[i6])-(models[2].PointArray[models[2].FaceArray[i2].point[2]].y*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							fly3=-((models[1].PointArray[models[1].FaceArray[i2].point[3]].y*SequenceArray[i].scale[i6])-(models[2].PointArray[models[2].FaceArray[i2].point[3]].y*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							flz1=-((models[1].PointArray[models[1].FaceArray[i2].point[1]].z*SequenceArray[i].scale[i6])-(models[2].PointArray[models[2].FaceArray[i2].point[1]].z*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							flz2=-((models[1].PointArray[models[1].FaceArray[i2].point[2]].z*SequenceArray[i].scale[i6])-(models[2].PointArray[models[2].FaceArray[i2].point[2]].z*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
							flz3=-((models[1].PointArray[models[1].FaceArray[i2].point[3]].z*SequenceArray[i].scale[i6])-(models[2].PointArray[models[2].FaceArray[i2].point[3]].z*SequenceArray[i].scale[i7]))*(i5/(GLfloat)SequenceArray[i].speed[i6]);
						}
					}
					glTexCoord2f(models[1].TexcoordArray[models[1].FaceArray[i2].point[1]].u,models[1].TexcoordArray[models[1].FaceArray[i2].point[1]].v);
					glVertex3f((models[1].PointArray[models[1].FaceArray[i2].point[1]].x*SequenceArray[i].scale[i6])+flx1+ffx,(models[1].PointArray[models[1].FaceArray[i2].point[1]].y*SequenceArray[i].scale[i6])+fly1+ffy,(models[1].PointArray[models[1].FaceArray[i2].point[1]].z*SequenceArray[i].scale[i6])+flz1+ffz);
					glTexCoord2f(models[1].TexcoordArray[models[1].FaceArray[i2].point[2]].u,models[1].TexcoordArray[models[1].FaceArray[i2].point[2]].v);
					glVertex3f((models[1].PointArray[models[1].FaceArray[i2].point[2]].x*SequenceArray[i].scale[i6])+flx2+ffx,(models[1].PointArray[models[1].FaceArray[i2].point[2]].y*SequenceArray[i].scale[i6])+fly2+ffy,(models[1].PointArray[models[1].FaceArray[i2].point[2]].z*SequenceArray[i].scale[i6])+flz2+ffz);
					glTexCoord2f(models[1].TexcoordArray[models[1].FaceArray[i2].point[3]].u,models[1].TexcoordArray[models[1].FaceArray[i2].point[3]].v);
					glVertex3f((models[1].PointArray[models[1].FaceArray[i2].point[3]].x*SequenceArray[i].scale[i6])+flx3+ffx,(models[1].PointArray[models[1].FaceArray[i2].point[3]].y*SequenceArray[i].scale[i6])+fly3+ffy,(models[1].PointArray[models[1].FaceArray[i2].point[3]].z*SequenceArray[i].scale[i6])+flz3+ffz);
			}
			glEnd();
			glRotatef(frz,0.0f,0.0f,-1.0f);
			glRotatef(fry,0.0f,-1.0f,0.0f);
			glRotatef(frx,-1.0f,0.0f,0.0f);
			glEndList();
		}

	}
	

}