#include "e0main.h"

#ifndef E0PHYS
#define E0PHYS




void SwapParents(int theobj, int theline){
	if(MonsterArray[theobj].polyparent==LineArray[theline].user1)
		MonsterArray[theobj].polyparent=LineArray[theline].user2;
	else{
		if(MonsterArray[theobj].polyparent==LineArray[theline].user2)
			MonsterArray[theobj].polyparent=LineArray[theline].user1;
		else
			fprintf(stderr,"Something's gone wrong when trying to swap object parents...\n");
	}

}

GLfloat la;		//Hack variable :( Horribly important!!
GLfloat ld;		//Another

GLfloat DistanceFromLine(int themon, int theline){
	GLfloat	ax = LineArray[theline].x,		ay = LineArray[theline].y;
	GLfloat	bx = LineArray[theline].x2,		by = LineArray[theline].y2;
	GLfloat	px = MonsterArray[themon].x,	py = MonsterArray[themon].z;

	GLfloat	v1x,	v1y,		v2x,	v2y;
	GLfloat	v3x,	v3y,		t;

	GLfloat temp, d;

	v1x = px - ax;	v1y = py - ay;
	
	v2x = bx - ax;	v2y = by - ay;
	temp = sqrt((v2x*v2x)+(v2y*v2y));
	v2x/=temp;			v2y/=temp;

	d=sqrt(((bx-ax)*(bx-ax))+((by-ay)*(by-ay)));

	t = (v1x*v2x)+(v1y*v2y);
	if(t<=0){
		v3x=ax; v3y=ay;
	}else{
		if(t>=d){
			v3x=bx; v3y=by;
		}else{
			v3x	= (v2x*t)+ax;	v3y	= (v2y*t)+ay;
		}

	}

	temp = sqrt(((px-v3x)*(px-v3x))+((py-v3y)*(py-v3y)));
	if(px - v3x>0.0f)
		la	=	-(  acos((py - v3y)/temp)/degrees  );
	else
		la	=	(  acos((py - v3y)/temp)/degrees  );

	if(themon == 0&&rand()%6==3){
		//APx = v3x+sin(la*radians); APy = v3y-cos(la*radians);
		APx = PolygonArray[Player.polyparent].centerx;
		APy = PolygonArray[Player.polyparent].centery;
	}
	
	return	temp;


	//Returns the distance from the nearest point on a given infinite line.
	/*
	//	v1 = vp.minus(a)
	//	v2 = b.minus(a)
	//	v2.normalize
	//	t = (v1.x*v2.x)+(v1.y*v2.y)
	//	v3 = v2.times(t)
	//	vf = a.plus(v3)
	//	return vf
  */

	//APx / y
	return 0.0f;
}
void TestLineCol(int theobj, int line, bool neutered, int tparent){
	int li;
	GLfloat zero = 0.0f;
	#define infinity 1.0f/zero
	#define op		MonsterArray[theobj].polyparent
	#define ort		MonsterInfoArray[MonsterArray[theobj].type].radius

	GLfloat walldist = DistanceFromLine(theobj,line);
	if(!neutered)
		ld=walldist;

	if(LineArray[line].shared){
		int tx;			//mild hack here. Replaces Biggest Hack Ever (tm) at least :)
		if(tparent==LineArray[line].user1)
			tx=LineArray[line].user2;
		else
			tx=LineArray[line].user1;
		
		if(tx<0)		//Something's screwed up :(
			return;		//Ignore it. Used to assume it's solid, but that may have caused all kinds of shit.
	
		if(MonsterArray[theobj].y+MonsterInfoArray[MonsterArray[theobj].type].height <= PolygonArray[tx].ceilingheight){
			if(MonsterArray[theobj].y>=PolygonArray[tx].floorheight-MonsterInfoArray[MonsterArray[theobj].type].stepheight){
				//just test against that poly's sides. Excepting this one! And don't loop!
				if(!neutered)
					for(li=0;li<LinesPerPoly+1;li++){
						if(PolygonArray[tx].lines[li]>0 && PolygonArray[tx].lines[li]!=line)
							TestLineCol(theobj,PolygonArray[tx].lines[li],true,tx);
					}
				else
					if(MonsterArray[theobj].y<PolygonArray[tx].floorheight||MonsterArray[theobj].y+MonsterInfoArray[MonsterArray[theobj].type].height>PolygonArray[tx].ceilingheight)
						goto doNC;		//removing fixes the random solid AND the doors
			}else{
				if(MonsterArray[theobj].y >= PolygonArray[tx].floorheight-MonsterInfoArray[MonsterArray[theobj].type].stepheight)
					if(walldist>-infinity && walldist<infinity && walldist<ort)
						MonsterArray[theobj].ys+=MonsterInfoArray[MonsterArray[theobj].type].stepforce;
				goto doNC;
			}
		}else
			goto doNC;		//removing allows you to pass through the doors
	}else
		goto doNC; //Treat it as a solid
	

goto end;
doNC:

	//If we're actually near it!
		if(walldist>-infinity && walldist<infinity){	//Make sure the wall is in fact valid
			if(walldist<ort){		//-MonsterInfoArray[MonsterArray[theobj].type].radius
				if((MonsterArray[theobj].x+MonsterInfoArray[MonsterArray[theobj].type].radius>LineArray[line].x&&MonsterArray[theobj].x-MonsterInfoArray[MonsterArray[theobj].type].radius<LineArray[line].x2)||(MonsterArray[theobj].x-MonsterInfoArray[MonsterArray[theobj].type].radius<LineArray[line].x&&MonsterArray[theobj].x+MonsterInfoArray[MonsterArray[theobj].type].radius>LineArray[line].x2)){
					if((MonsterArray[theobj].z+MonsterInfoArray[MonsterArray[theobj].type].radius>LineArray[line].y&&MonsterArray[theobj].z-MonsterInfoArray[MonsterArray[theobj].type].radius<LineArray[line].y2)||(MonsterArray[theobj].z-MonsterInfoArray[MonsterArray[theobj].type].radius<LineArray[line].y&&MonsterArray[theobj].z+MonsterInfoArray[MonsterArray[theobj].type].radius>LineArray[line].y2)){
						//MonsterArray[theobj].xs=0.0f;MonsterArray[theobj].zs=0.0f;
						MonsterArray[theobj].x-=sin(la*radians)*(ort-walldist);
						MonsterArray[theobj].z+=cos(la*radians)*(ort-walldist);
					}
				}
			}
		}
	//}
	

end:
	return;
}


void DetermineParent(int theobj){
	//This pwns 4/5d space, but makes the physics structure more stable.
	// It's broken...
#define px MonsterArray[theobj].x
#define py MonsterArray[theobj].z
#define tl PolygonArray[li].lines[zl]
#define m (LineArray[zl].y2-LineArray[zl].y)/(LineArray[zl].x2-LineArray[zl].x)

	bool tin;
	bool ca;
	int li, l2;
	int zl;

	for(li=0;li<PolygonArraySize;li++){
		//if(MonsterArray[theobj].y>=PolygonArray[li].floorheight/*&&MonsterArray[theobj].y+MonsterInfoArray[MonsterArray[theobj].type].height<=PolygonArray[zl].ceilingheight*/){
			tin=true;
			for(zl=0;zl<LinesPerPoly+1;zl++){
				if(py>LineArray[zl].y+(m*(px - LineArray[zl].x))){
					if(PolygonArray[li].centery<LineArray[zl].y+(m*(PolygonArray[li].centerx - LineArray[zl].x)))
						tin=false;	
				}
			}
			if(tin&&zl>=2)
				MonsterArray[theobj].polyparent=li;
				//fprintf(stderr,"Zorg! Object %i should have parent %i.\n", theobj,li);
				//switch parents
		//}
	}


}







void DoPhysics(GLvoid){
	GLfloat xi, yi, xi2, yi2, pxi, pyi, pri, gi;
	GLfloat cxi, cyi, nx, ny, inf;

	nx=1.0f;
	ny=0.0f;
	inf=nx/ny;

	bool cip, cxip, nc;
	int i3;

	
	
	if(Player.polyparent==PolysToVisit[LastVisit]){
		sprintf(TermText,"Objective completed!");
		PrefsTermTrans=1.0f;
		LastVisit++;
	}
	if(PolysToVisit[LastVisit]==-1 || (keys['a'] && keys['p'])){
		keys['p']=false;
		sprintf(TermText,"Final objective complete!");
		PrefsTermTrans=1.0f;
		//CurrentLevel++;
		//CleanUp();
		//ValidateMap(CurrentLevel);
		//LoadPhysics(CurrentLevel);
		//LoadMap(CurrentLevel);
		Quit(0);
	}

	

	if(Player.bobheightphase>180)
		Player.bobheightphase=0;
	if(Player.bobheightphase<0)
		Player.bobheightphase=180;
	if(Player.knocktimer>0)
		Player.knocktimer-=3;
	//Do item physics

	for(i=0;i<ItemArraySize;i++){
		if(ItemArray[i].y<=PolygonArray[ItemArray[i].polyparent].floorheight+0.01f){
			if(PolygonArray[ItemArray[i].polyparent].floorlink==-1){
				ItemArray[i].ys=0.0f;
				ItemArray[i].y=PolygonArray[ItemArray[i].polyparent].floorheight+0.01f;
			}else
				ItemArray[i].polyparent = PolygonArray[ItemArray[i].polyparent].floorlink;
		}else
			ItemArray[i].ys-=ItemInfoArray[ItemArray[i].type].grav;
		if(ItemArray[i].y>=PolygonArray[ItemArray[i].polyparent].ceilingheight)
			if(PolygonArray[ItemArray[i].polyparent].ceilinglink==-1)
				ItemArray[i].y=PolygonArray[ItemArray[i].polyparent].ceilingheight;
			else
				ItemArray[i].polyparent = PolygonArray[ItemArray[i].polyparent].ceilinglink;
		ItemArray[i].y+=ItemArray[i].ys;
	}

	//For each active object...
	for(i=0;i<MonsterArraySize;i++){
		//Is it dead?
		if(MonsterArray[i].health<0){
		//Turn it into a corpse
			if(MonsterInfoArray[MonsterArray[i].type].isplayer || ( MonsterArray[i].curaction==4 && MonsterArray[i].killflag )){
				if(i==0){					//Player is dead
					inputmode=-1;			//Stop input/control
					MonsterArray[i].y+=MonsterInfoArray[MonsterArray[i].type].camheight;	//Make the thingy fall right.
				}
				MonsterArray[i].type=MonsterInfoArray[MonsterArray[i].type].corpse;
				MonsterArray[i].health=0;
				MonsterArray[i].frame=1;			//Update it's animations
				MonsterArray[i].cursequence=MonsterInfoArray[MonsterArray[i].type].sequence[1];
			}
			if(MonsterArray[i].curaction!=4  && !MonsterInfoArray[MonsterArray[i].type].isplayer){
				MonsterArray[i].curaction=4;
				MonsterArray[i].frame=1;
				MonsterArray[i].frametimer=0;
			}
		}
		//'Cool down' weapons
		if(MonsterArray[i].shotdelay>0)
			MonsterArray[i].shotdelay-=speedfactor;
		if(MonsterArray[i].shotdelay2>0)
			MonsterArray[i].shotdelay2-=speedfactor;
	    // Limit speed to absolute maximum
		if(MonsterArray[i].xs>MonsterInfoArray[MonsterArray[i].type].mas)
			MonsterArray[i].xs = MonsterInfoArray[MonsterArray[i].type].mas;
		if(MonsterArray[i].ys>MonsterInfoArray[MonsterArray[i].type].mas)
			MonsterArray[i].ys = MonsterInfoArray[MonsterArray[i].type].mas;
		if(MonsterArray[i].zs>MonsterInfoArray[MonsterArray[i].type].mas)
			MonsterArray[i].zs = MonsterInfoArray[MonsterArray[i].type].mas;
		if(MonsterArray[i].xs<-MonsterInfoArray[MonsterArray[i].type].mas)
			MonsterArray[i].xs = -MonsterInfoArray[MonsterArray[i].type].mas;
		if(MonsterArray[i].ys<-MonsterInfoArray[MonsterArray[i].type].mas)
			MonsterArray[i].ys = -MonsterInfoArray[MonsterArray[i].type].mas;
		if(MonsterArray[i].zs<-MonsterInfoArray[MonsterArray[i].type].mas)
			MonsterArray[i].zs = -MonsterInfoArray[MonsterArray[i].type].mas;
		//If below a de-accel speed, stop the Object. If not, de-accel.
		//Alter this to be properly Pythagoric...
		yi=(MonsterArray[i].zs/sqrt((MonsterArray[i].xs*MonsterArray[i].xs)+(MonsterArray[i].zs*MonsterArray[i].zs)));
		xi=(MonsterArray[i].xs/sqrt((MonsterArray[i].zs*MonsterArray[i].zs)+(MonsterArray[i].xs*MonsterArray[i].xs)));
		if(MonsterArray[i].onground){
			if(MonsterArray[i].xs<MonsterInfoArray[MonsterArray[i].type].ad && MonsterArray[i].xs>-MonsterInfoArray[MonsterArray[i].type].ad){
				MonsterArray[i].xs = 0.0f;
			}else{
				MonsterArray[i].xs -= MonsterInfoArray[MonsterArray[i].type].ad*xi;
			}
			if(MonsterArray[i].zs<MonsterInfoArray[MonsterArray[i].type].ad && MonsterArray[i].zs>-MonsterInfoArray[MonsterArray[i].type].ad){
				MonsterArray[i].zs = 0.0f;
			}else{
				MonsterArray[i].zs -= MonsterInfoArray[MonsterArray[i].type].ad*yi;
			}
		}else{
			if(MonsterArray[i].xs<MonsterInfoArray[MonsterArray[i].type].aad && MonsterArray[i].xs>-MonsterInfoArray[MonsterArray[i].type].aad){
				MonsterArray[i].xs = 0;
			}else{
				if(MonsterArray[i].xs!=0.0f){MonsterArray[i].xs -= MonsterInfoArray[MonsterArray[i].type].aad*xi;}
			}
			if(MonsterArray[i].zs<MonsterInfoArray[MonsterArray[i].type].aad && MonsterArray[i].zs>-MonsterInfoArray[MonsterArray[i].type].aad){
				MonsterArray[i].zs = 0;
			}else{
				if(MonsterArray[i].zs!=0){MonsterArray[i].zs -= MonsterInfoArray[MonsterArray[i].type].aad*yi;}
			}
		}
		MonsterArray[i].xdir+=MonsterArray[i].ts*speedfactor;
		if(i!=0){
			if(MonsterArray[i].xdir>360.0f)
				MonsterArray[i].xdir-=360.0f;
			if(MonsterArray[i].xdir<0.0f)
				MonsterArray[i].xdir+=360.0f;
		}
		if(MonsterArray[i].ts>MonsterInfoArray[MonsterArray[i].type].td)
			MonsterArray[i].ts-=MonsterInfoArray[MonsterArray[i].type].td*speedfactor;
		if(MonsterArray[i].ts<-MonsterInfoArray[MonsterArray[i].type].td)
			MonsterArray[i].ts+=MonsterInfoArray[MonsterArray[i].type].td*speedfactor;
		if(MonsterArray[i].ts>=-MonsterInfoArray[MonsterArray[i].type].td && MonsterArray[i].ts<=MonsterInfoArray[MonsterArray[i].type].td)
			MonsterArray[i].ts = 0;
		//Apply gravity
		if(!MonsterArray[i].onground)
			MonsterArray[i].ys-=MonsterInfoArray[MonsterArray[i].type].va*speedfactor;
		//Move the object
		MonsterArray[i].x+=MonsterArray[i].xs*speedfactor;
		MonsterArray[i].y+=MonsterArray[i].ys*speedfactor;
		MonsterArray[i].z+=MonsterArray[i].zs*speedfactor;
		//Bounce off floors/ceilings
		if(MonsterArray[i].y<=PolygonArray[MonsterArray[i].polyparent].floorheight&&PolygonArray[MonsterArray[i].polyparent].floorlink==-1)
			MonsterArray[i].onground=true;
		else
			MonsterArray[i].onground=false;
		if(MonsterInfoArray[MonsterArray[i].type].bouncecol){
			if(MonsterArray[i].y+MonsterInfoArray[MonsterArray[i].type].height>PolygonArray[MonsterArray[i].polyparent].ceilingheight)
				if(PolygonArray[MonsterArray[i].polyparent].ceilinglink==-1||TestObjectYThingy(i,PolygonArray[MonsterArray[i].polyparent].ceilinglink))
					MonsterArray[i].ys=-MonsterArray[i].ys;
				else
					if(MonsterArray[i].y>=PolygonArray[MonsterArray[i].polyparent].ceilingheight)
						MonsterArray[i].polyparent=PolygonArray[MonsterArray[i].polyparent].ceilinglink;
			if(MonsterArray[i].y<PolygonArray[MonsterArray[i].polyparent].floorheight)
				if(PolygonArray[MonsterArray[i].polyparent].floorlink==-1||TestObjectYThingy(i,PolygonArray[MonsterArray[i].polyparent].floorlink))
					MonsterArray[i].ys=-MonsterArray[i].ys;
				else
					MonsterArray[i].polyparent=PolygonArray[MonsterArray[i].polyparent].floorlink;
		}else{
			if(MonsterArray[i].y+MonsterInfoArray[MonsterArray[i].type].height>=PolygonArray[MonsterArray[i].polyparent].ceilingheight){
				if(PolygonArray[MonsterArray[i].polyparent].ceilinglink==-1||TestObjectYThingy(i,PolygonArray[MonsterArray[i].polyparent].ceilinglink)){
					MonsterArray[i].y=PolygonArray[MonsterArray[i].polyparent].ceilingheight-MonsterInfoArray[MonsterArray[i].type].height-0.0001f;
					MonsterArray[i].bobheightphase=0;
					MonsterArray[i].ys=-MonsterArray[i].ys*0.1f;
				}else
					if(MonsterArray[i].y>=PolygonArray[MonsterArray[i].polyparent].ceilingheight)
						MonsterArray[i].polyparent=PolygonArray[MonsterArray[i].polyparent].ceilinglink;
			}
			if(MonsterArray[i].y<PolygonArray[MonsterArray[i].polyparent].floorheight){
				if(PolygonArray[MonsterArray[i].polyparent].floorlink==-1||TestObjectYThingy(i,PolygonArray[MonsterArray[i].polyparent].floorlink)){
					MonsterArray[i].y=PolygonArray[MonsterArray[i].polyparent].floorheight;
					MonsterArray[i].ys=0.0f;
					MonsterArray[i].onground = true;
				}else
					MonsterArray[i].polyparent=PolygonArray[MonsterArray[i].polyparent].floorlink;
			}
		}
		nc=false;

		


			
			for(i2=0;i2<LinesPerPoly;i2++){
				if(PolygonArray[MonsterArray[i].polyparent].lines[i2]>0){
					TestLineCol(i,PolygonArray[MonsterArray[i].polyparent].lines[i2],false,MonsterArray[i].polyparent);

					xi = LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].x;
					yi = LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].y;
					xi2 = LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].x2;
					yi2 = LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].y2;
					gi = (yi2-yi)/(xi2-xi);
					pxi = MonsterArray[i].x;
					pyi = MonsterArray[i].z;
					pri = MonsterInfoArray[MonsterArray[i].type].radius;
					cxi=PolygonArray[MonsterArray[i].polyparent].centerx;
					cyi=PolygonArray[MonsterArray[i].polyparent].centery;
					if(cyi<(yi + (gi * (cxi - xi))))
						cip = false;
					else
						cip = true;
					nx=MonsterArray[i].x;
					ny=MonsterArray[i].z;
					if(!LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].shared){
		
						/*		if(cip){
									if(pyi<(yi + (gi * (pxi - xi)))){
											MonsterArray[i].x=PolygonArray[MonsterArray[i].polyparent].centerx;
											MonsterArray[i].z=PolygonArray[MonsterArray[i].polyparent].centery;
									}
								}else{
									if(pyi>(yi + (gi * (pxi - xi)))){
											MonsterArray[i].x=PolygonArray[MonsterArray[i].polyparent].centerx;
											MonsterArray[i].z=PolygonArray[MonsterArray[i].polyparent].centery;
									}
								}
						*/
					}else{
						//Fixes various physics stuff, but can cause crap too...
						if(((pxi+0.1f>xi&&pxi-0.1f<xi2)||(pxi+0.1f>xi2&&pxi-0.1f<xi))&&((pyi+0.1f>yi&&pyi-0.1f<yi2)||(pyi+0.1f>yi2&&pyi-0.1f<yi))){
							if(MonsterArray[i].polyparent==LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].user1){
								if(MonsterArray[i].y >= PolygonArray[LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].user2].floorheight-MonsterInfoArray[MonsterArray[i].type].stepheight && MonsterArray[i].y+MonsterInfoArray[MonsterArray[i].type].height < PolygonArray[LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].user2].ceilingheight){							if(cip){
										if(pyi<(yi + (gi * (pxi - xi))))
											MonsterArray[i].polyparent=LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].user2;
									}else{
										if(pyi>(yi + (gi * (pxi - xi))))
											MonsterArray[i].polyparent=LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].user2;
									}
								}
							}else{
								if(MonsterArray[i].y >= PolygonArray[LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].user1].floorheight-MonsterInfoArray[MonsterArray[i].type].stepheight && MonsterArray[i].y+MonsterInfoArray[MonsterArray[i].type].height < PolygonArray[LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].user1].ceilingheight){								if(cip){
										if(pyi<(yi + (gi * (pxi - xi))))
											MonsterArray[i].polyparent=LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].user1;
									}else{
										if(pyi>(yi + (gi * (pxi - xi))))
											MonsterArray[i].polyparent=LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].user1;
									}
								}
							}
							if(MonsterArray[i].polyparent!=LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].user2&&MonsterArray[i].polyparent!=LineArray[PolygonArray[MonsterArray[i].polyparent].lines[i2]].user1){
								fprintf(stderr,"Monster %i not in correct polygon.\n",i);
								//MonsterArray[i].x=PolygonArray[MonsterArray[i].polyparent].centerx;
								//MonsterArray[i].z=PolygonArray[MonsterArray[i].polyparent].centery;
	
							}
							
						}
					}
				}

	//		}}


		}
/*
	//DOES THINGS. KEEP.
		#define lx (MonsterArray[i].x-PolygonArray[MonsterArray[i].polyparent].centerx)
		#define lz (MonsterArray[i].z-PolygonArray[MonsterArray[i].polyparent].centery)
		
		//If we've left the poly and haven't handled it,
		//work out where the hell we actually are
		if(sqrt((lx*lx)+(lz*lz))>PolygonArray[MonsterArray[i].polyparent].highestpointdist+MonsterInfoArray[MonsterArray[i].polyparent].radius){
			//MonsterArray[i].x=PolygonArray[MonsterArray[i].polyparent].centerx;
			//MonsterArray[i].z=PolygonArray[MonsterArray[i].polyparent].centery;
			DetermineParent(i);
		}
		*/
				if(keys['c']){
			MonsterArray[i].x=PolygonArray[MonsterArray[i].polyparent].centerx;
			MonsterArray[i].z=PolygonArray[MonsterArray[i].polyparent].centery;
		}
		//For debugging only
		if(PrefsShowPosition){
			glClear(GL_COLOR_BUFFER_BIT);
			sprintf(TermText,"parent %i @ %f %f %f",Player.polyparent,Player.x,Player.y,Player.z);
			PrefsTermTrans=1.0f;
		}
		//...Check if it's picked up an item...
		for(i2=0;i2<ItemArraySize;i2++)
			if(ItemArray[i2].type>0)
				if(MonsterInfoArray[MonsterArray[i].type].isplayer && i == 0)
					if(MonsterArray[i].polyparent==ItemArray[i2].polyparent||MonsterArray[i].polyparent==PolygonArray[ItemArray[i2].polyparent].floorlink||MonsterArray[i].polyparent==PolygonArray[ItemArray[i2].polyparent].ceilinglink)
						if(MonsterArray[i].x-ItemArray[i2].x>-MonsterInfoArray[MonsterArray[i].type].radius*2.0f &&MonsterArray[i].x-ItemArray[i2].x<MonsterInfoArray[MonsterArray[i].type].radius*2.0f && MonsterArray[i].z-ItemArray[i2].z>-MonsterInfoArray[MonsterArray[i].type].radius*2.0f&& MonsterArray[i].z-ItemArray[i2].z<MonsterInfoArray[MonsterArray[i].type].radius*2.0f)
							if(MonsterArray[i].y<ItemArray[i2].y&&MonsterArray[i].y+MonsterInfoArray[MonsterArray[i].type].height>ItemArray[i2].y){
								if(PlayerInventory[ItemArray[i2].type]<ItemInfoArray[ItemArray[i2].type].max)
									PlayerInventory[ItemArray[i2].type]++;
									if(ItemInfoArray[ItemArray[i2].type].effect==1){
										WeaponAmmo[ItemInfoArray[ItemArray[i2].type].weapon1]=WeaponInfoArray[ItemInfoArray[ItemArray[i2].type].weapon1].clipsize;
										WeaponAmmo[ItemInfoArray[ItemArray[i2].type].weapon2]=WeaponInfoArray[ItemInfoArray[ItemArray[i2].type].weapon2].clipsize;
									}
									sprintf(TermText,"Picked up item: %s",ItemInfoArray[ItemArray[i2].type].name);
									PrefsTermTrans=1.0f;
									ItemArray[i2].type=0;
									PrefsBeltTrans=PrefsMaxBeltTrans;
								}
		//...Check if it's hit another object.
		for(i2=0;i2<MonsterArraySize;i2++)
			if(i!=i2)
				//if(MonsterArray[i].polyparent==MonsterArray[i2].polyparent||PolygonArray[MonsterArray[i].polyparent].ceilinglink==MonsterArray[i2].polyparent||PolygonArray[MonsterArray[i].polyparent].floorlink==MonsterArray[i2].polyparent)
					if(sqrt( ((MonsterArray[i2].x-MonsterArray[i].x)*(MonsterArray[i2].x-MonsterArray[i].x)) + ((MonsterArray[i2].z-MonsterArray[i].z)*(MonsterArray[i2].z-MonsterArray[i].z)) )<MonsterInfoArray[MonsterArray[i].type].radius+MonsterInfoArray[MonsterArray[i2].type].radius)
							if((MonsterArray[i].y+MonsterInfoArray[MonsterArray[i].type].height<=MonsterArray[i2].y+MonsterInfoArray[MonsterArray[i2].type].height && MonsterArray[i].y+MonsterInfoArray[MonsterArray[i].type].height>=MonsterArray[i2].y) || (MonsterArray[i].y<=MonsterArray[i2].y+MonsterInfoArray[MonsterArray[i2].type].height && MonsterArray[i].y>=MonsterArray[i2].y) || (MonsterArray[i2].y+MonsterInfoArray[MonsterArray[i2].type].height<=MonsterArray[i].y+MonsterInfoArray[MonsterArray[i].type].height && MonsterArray[i2].y+MonsterInfoArray[MonsterArray[i2].type].height>=MonsterArray[i].y) || (MonsterArray[i2].y<=MonsterArray[i].y+MonsterInfoArray[MonsterArray[i].type].height && MonsterArray[i2].y>=MonsterArray[i].y))
								if(MonsterInfoArray[MonsterArray[i].type].solid&&MonsterInfoArray[MonsterArray[i2].type].solid)
									if((MonsterArray[i].y>=MonsterArray[i2].y+MonsterInfoArray[MonsterArray[i2].type].height-(MonsterInfoArray[MonsterArray[i].type].stepheight)) && MonsterInfoArray[MonsterArray[i2].type].bridge){
										if((MonsterArray[i].y>=MonsterArray[i2].y+MonsterInfoArray[MonsterArray[i2].type].height-(MonsterInfoArray[MonsterArray[i].type].stepheight/10.0f))){									
											MonsterArray[i].y=MonsterArray[i2].y+MonsterInfoArray[MonsterArray[i2].type].height;
											if(MonsterArray[i].ys<0.0f)
												MonsterArray[i].onground=true;
											MonsterArray[i].ys=0.0f;
										}else
											MonsterArray[i].ys+=MonsterInfoArray[MonsterArray[i].type].stepforce;
									}else{
										if((MonsterArray[i2].y<MonsterArray[i].y+MonsterInfoArray[MonsterArray[i].type].height-(MonsterInfoArray[MonsterArray[i2].type].stepheight))){
											if((MonsterArray[i].y>MonsterArray[i2].y+MonsterInfoArray[MonsterArray[i2].type].height-MonsterInfoArray[MonsterArray[i].type].stepheight) && (MonsterInfoArray[MonsterArray[i2].type].bridge)){
												//Change this
												MonsterArray[i].ys+=MonsterInfoArray[MonsterArray[i].type].stepforce;
												//This was the old system, which made objects sticky.
												MonsterArray[i].z-=MonsterArray[i].zs;
												MonsterArray[i].x-=MonsterArray[i].xs;
											}else{
												//This is the new one, which doesn't.
												//CHANGE THIS!!
												MonsterArray[i].zs-=((MonsterArray[i2].z-MonsterArray[i].z)*0.8f)*MonsterInfoArray[MonsterArray[i].type].forcemultiplier;
												MonsterArray[i].xs-=((MonsterArray[i2].x-MonsterArray[i].x)*0.8f)*MonsterInfoArray[MonsterArray[i].type].forcemultiplier;
												MonsterArray[i2].zs-=((MonsterArray[i].z-MonsterArray[i2].z)*0.8f)*MonsterInfoArray[MonsterArray[i2].type].forcemultiplier;
												MonsterArray[i2].xs-=((MonsterArray[i].x-MonsterArray[i2].x)*0.8f)*MonsterInfoArray[MonsterArray[i2].type].forcemultiplier;

											GLfloat nx=MonsterArray[i2].x;
											GLfloat nz=MonsterArray[i2].z;
											GLfloat	x=MonsterArray[i].x;
											GLfloat z=MonsterArray[i].z;
											GLfloat pr1=MonsterInfoArray[MonsterArray[i].type].radius;
											GLfloat pr2=MonsterInfoArray[MonsterArray[i2].type].radius;
											GLfloat xdist=nx-x;
											GLfloat zdist=nz-z;
											GLfloat tdist=sqrt((xdist*xdist)+(zdist*zdist));
											GLfloat pxdist=xdist/tdist;
											GLfloat pzdist=zdist/tdist;
											GLfloat zero=0.0f;
											
											GLfloat reldir=((acos(-pzdist)/degrees));

											/*if(pzdist<pr1+pr2){
												if(pxdist<0.0f)
													reldir=-reldir;
												MonsterArray[i].x+=(sin(reldir*radians)*((tdist-pr1)-pr2));
												MonsterArray[i].z-=(cos(reldir*radians)*((tdist-pr1)-pr2));
											}*/
											

										//}
									}
								}
							}
	}
	//We're done messing with enemies/players
	
	//Stuff around with particles
	glDisable(GL_TEXTURE_2D);
	if(PrefsParticleFX){
	for(i=0;i<ParticleArraySize;i++){
		if(ParticleArray[i].type!=0){
			ParticleArray[i].x+=ParticleArray[i].xs*speedfactor;
			ParticleArray[i].y+=ParticleArray[i].ys*speedfactor;
			ParticleArray[i].z+=ParticleArray[i].zs*speedfactor;
			
			ParticleArray[i].life-=speedfactor;
			if(ParticleArray[i].life<=0)
				ParticleArray[i].type=0;

			ParticleArray[i].ys-=ParticleInfoArray[ParticleArray[i].type].grav;

			ParticleArray[i].xr+=ParticleArray[i].xrs;
			ParticleArray[i].yr+=ParticleArray[i].yrs;
			ParticleArray[i].zr+=ParticleArray[i].zrs;

			if(ParticleArray[i].y>PolygonArray[ParticleArray[i].parent].ceilingheight&&ParticleInfoArray[ParticleArray[i].type].mode!=6&&ParticleInfoArray[ParticleArray[i].type].mode!=7&&ParticleInfoArray[ParticleArray[i].type].mode!=9)
				if(PolygonArray[ParticleArray[i].parent].ceilinglink==-1){
					ParticleArray[i].ys=-ParticleArray[i].ys*ParticleInfoArray[ParticleArray[i].type].bounce+((((rand()%1000)/1000.0f)-0.5f)*ParticleInfoArray[ParticleArray[i].type].bouncedelta);
					ParticleArray[i].y=PolygonArray[ParticleArray[i].parent].ceilingheight;
					if(ParticleInfoArray[ParticleArray[i].type].bounce==0.0f){
						ParticleArray[i].xs=0.0f;
						ParticleArray[i].zs=0.0f;
					}
				}else
					ParticleArray[i].parent=PolygonArray[ParticleArray[i].parent].ceilinglink;

			if(ParticleArray[i].y<PolygonArray[ParticleArray[i].parent].floorheight&&ParticleInfoArray[ParticleArray[i].type].mode!=6&&ParticleInfoArray[ParticleArray[i].type].mode!=7&&ParticleInfoArray[ParticleArray[i].type].mode!=9)
				if(PolygonArray[ParticleArray[i].parent].floorlink==-1){
					ParticleArray[i].ys=-ParticleArray[i].ys*ParticleInfoArray[ParticleArray[i].type].bounce+((((rand()%1000)/1000.0f)-0.5f)*ParticleInfoArray[ParticleArray[i].type].bouncedelta);
					ParticleArray[i].y=PolygonArray[ParticleArray[i].parent].floorheight;
					if(ParticleInfoArray[ParticleArray[i].type].bounce==0.0f){
						ParticleArray[i].xs=0.0f;
						ParticleArray[i].zs=0.0f;
					}
				}else
					ParticleArray[i].parent=PolygonArray[ParticleArray[i].parent].floorlink;
		
			for(i2=0;i2<LinesPerPoly;i2++){
				if(PolygonArray[ParticleArray[i].parent].lines[i2]>-1){
					xi = LineArray[PolygonArray[ParticleArray[i].parent].lines[i2]].x;
					yi = LineArray[PolygonArray[ParticleArray[i].parent].lines[i2]].y;
					xi2 = LineArray[PolygonArray[ParticleArray[i].parent].lines[i2]].x2;
					yi2 = LineArray[PolygonArray[ParticleArray[i].parent].lines[i2]].y2;
					gi = (yi2-yi)/(xi2-xi);
					
					pxi = ParticleArray[i].x;
					pyi = ParticleArray[i].z;
					
					cxi=PolygonArray[ParticleArray[i].parent].centerx;
					cyi=PolygonArray[ParticleArray[i].parent].centery;
					
					if(cyi<(yi + (gi * (cxi - xi))))
						cip = false;
					else
						cip = true;
					
					nx=ParticleArray[i].x;
					ny=ParticleArray[i].z;
					if(ParticleArray[i].parent==LineArray[PolygonArray[ParticleArray[i].parent].lines[i2]].user1){
						//if(ParticleArray[i].y>PolygonArray[LineArray[PolygonArray[ParticleArray[i].parent].lines[i2]].user2].floorheight&&ParticleArray[i].y<PolygonArray[LineArray[PolygonArray[ParticleArray[i].parent].lines[i2]].user2].ceilingheight){
							if(cip){
								if(pyi<(yi + (gi * (pxi - xi))))
									ParticleArray[i].parent=LineArray[PolygonArray[ParticleArray[i].parent].lines[i2]].user2;
							}else{
								if(pyi>(yi + (gi * (pxi - xi))))
									ParticleArray[i].parent=LineArray[PolygonArray[ParticleArray[i].parent].lines[i2]].user2;
							}
						//}
					}else{
						//if(ParticleArray[i].y>PolygonArray[LineArray[PolygonArray[ParticleArray[i].parent].lines[i2]].user1].floorheight&&ParticleArray[i].y<PolygonArray[LineArray[PolygonArray[ParticleArray[i].parent].lines[i2]].user1].ceilingheight){
							if(cip){
								if(pyi<(yi + (gi * (pxi - xi))))
									ParticleArray[i].parent=LineArray[PolygonArray[ParticleArray[i].parent].lines[i2]].user1;
							}else{
								if(pyi>(yi + (gi * (pxi - xi))))
									ParticleArray[i].parent=LineArray[PolygonArray[ParticleArray[i].parent].lines[i2]].user1;
							}
						//}
					}
				}
			}
		}
	}
	}
	//Check if any shots have hit walls, etc,and move them all
	for(i=0;i<ShotArraySize;i++)
		TestShotCol();
	
	//NOW DO LIGHTS
	for(i=0;i<LightArraySize;i++){
		
		if(LightArray[i].SecPhase){
			if(LightArray[i].Active)
				LightArray[i].Pos+=LightArray[i].ActSecSpd;
			else
				LightArray[i].Pos+=LightArray[i].InActSecSpd;
		}else{
			if(LightArray[i].Active)
				LightArray[i].Pos+=LightArray[i].ActPriSpd;
			else
				LightArray[i].Pos+=LightArray[i].InActPriSpd;
		}
		if(LightArray[i].Pos>=16384){
			LightArray[i].SecPhase=!LightArray[i].SecPhase;
			LightArray[i].Pos=0;
			
			if(LightArray[i].SecPhase){
				if(LightArray[i].Active){
					LightArray[i].CurrentFDelta=(rand()%LightArray[i].ActSecDel)-(LightArray[i].ActSecDel/2);
					LightArray[i].CurrentDelta=LightArray[i].CurrentFDelta;
				}else{
					LightArray[i].CurrentFDelta=(rand()%LightArray[i].InActSecDel)-(LightArray[i].InActSecDel/2);
					LightArray[i].CurrentDelta=LightArray[i].CurrentFDelta;}
			}else{
				if(LightArray[i].Active){
					LightArray[i].CurrentFDelta=(rand()%LightArray[i].ActPriDel)-(LightArray[i].ActPriDel/2);
					LightArray[i].CurrentDelta=LightArray[i].CurrentFDelta;
				}else{
					LightArray[i].CurrentFDelta=(rand()%LightArray[i].InActPriDel)-(LightArray[i].InActPriDel/2);
					LightArray[i].CurrentDelta=LightArray[i].CurrentFDelta;}
			}
		}
		
		
		//Modes: 0=Constant 1=Smooth 2=Flicker 3=ColorFlicker
		if(LightArray[i].SecPhase){	//We're in the secondary phase
			if(LightArray[i].Active){
				if(LightArray[i].ActSecMode==0){	//Constant light mode
					LightArray[i].CurR=LightArray[i].ActSecBriR+LightArray[i].CurrentDelta;
					LightArray[i].CurG=LightArray[i].ActSecBriG+LightArray[i].CurrentDelta;
					LightArray[i].CurB=LightArray[i].ActSecBriB+LightArray[i].CurrentDelta;
				}
				if(LightArray[i].ActSecMode==1){	//Smooth mode
					LightArray[i].CurR=(LightArray[i].ActSecBriR+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriR+LightArray[i].CurrentFDelta)-(LightArray[i].ActSecBriR+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f));
					LightArray[i].CurG=(LightArray[i].ActSecBriG+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriG+LightArray[i].CurrentFDelta)-(LightArray[i].ActSecBriG+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f));
					LightArray[i].CurB=(LightArray[i].ActSecBriB+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriB+LightArray[i].CurrentFDelta)-(LightArray[i].ActSecBriB+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f));
				}
				if(LightArray[i].ActSecMode==2){	//Flicker mode
					i2=rand()%LightArray[i].ActSecDel;
					LightArray[i].CurR=(LightArray[i].ActSecBriR+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriR+LightArray[i].CurrentFDelta)-(LightArray[i].ActSecBriR+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+i2;
					LightArray[i].CurG=(LightArray[i].ActSecBriG+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriG+LightArray[i].CurrentFDelta)-(LightArray[i].ActSecBriG+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+i2;
					LightArray[i].CurB=(LightArray[i].ActSecBriB+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriB+LightArray[i].CurrentFDelta)-(LightArray[i].ActSecBriB+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+i2;
				}
				if(LightArray[i].ActSecMode==3){	//ColorFlicker mode
					LightArray[i].CurR=(LightArray[i].ActSecBriR+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriR+LightArray[i].CurrentFDelta)-(LightArray[i].ActSecBriR+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+(rand()%LightArray[i].ActSecDel);
					LightArray[i].CurG=(LightArray[i].ActSecBriG+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriG+LightArray[i].CurrentFDelta)-(LightArray[i].ActSecBriG+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+(rand()%LightArray[i].ActSecDel);
					LightArray[i].CurB=(LightArray[i].ActSecBriB+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriB+LightArray[i].CurrentFDelta)-(LightArray[i].ActSecBriB+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+(rand()%LightArray[i].ActSecDel);
				}
				if(LightArray[i].ActSecMode==4){	//Sinewave (Smoother) mode
					LightArray[i].CurR=(LightArray[i].ActSecBriR+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriR+LightArray[i].CurrentFDelta)-(LightArray[i].ActSecBriR+LightArray[i].CurrentDelta))*   (((  sin((LightArray[i].Pos/16384.0f)*180.0f*radians)  )*0.5f)+0.5f)   );
					LightArray[i].CurG=(LightArray[i].ActSecBriG+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriG+LightArray[i].CurrentFDelta)-(LightArray[i].ActSecBriG+LightArray[i].CurrentDelta))*   (((  sin((LightArray[i].Pos/16384.0f)*180.0f*radians)  )*0.5f)+0.5f)   );
					LightArray[i].CurB=(LightArray[i].ActSecBriB+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriB+LightArray[i].CurrentFDelta)-(LightArray[i].ActSecBriB+LightArray[i].CurrentDelta))*   (((  sin((LightArray[i].Pos/16384.0f)*180.0f*radians)  )*0.5f)+0.5f)   );
				}
			}else{
				if(LightArray[i].InActSecMode==0){	//Constant light mode
					LightArray[i].CurR=LightArray[i].InActSecBriR+LightArray[i].CurrentDelta;
					LightArray[i].CurG=LightArray[i].InActSecBriG+LightArray[i].CurrentDelta;
					LightArray[i].CurB=LightArray[i].InActSecBriB+LightArray[i].CurrentDelta;
				}
				if(LightArray[i].InActSecMode==1){	//Smooth mode
					LightArray[i].CurR=(LightArray[i].InActSecBriR+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriR+LightArray[i].CurrentFDelta)-(LightArray[i].InActSecBriR+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f));
					LightArray[i].CurG=(LightArray[i].InActSecBriG+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriG+LightArray[i].CurrentFDelta)-(LightArray[i].InActSecBriG+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f));
					LightArray[i].CurB=(LightArray[i].InActSecBriB+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriB+LightArray[i].CurrentFDelta)-(LightArray[i].InActSecBriB+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f));
				}
				if(LightArray[i].InActSecMode==2){	//Flicker mode
					i2=rand()%LightArray[i].InActSecDel;
					LightArray[i].CurR=(LightArray[i].InActSecBriR+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriR+LightArray[i].CurrentFDelta)-(LightArray[i].InActSecBriR+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+i2;
					LightArray[i].CurG=(LightArray[i].InActSecBriG+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriG+LightArray[i].CurrentFDelta)-(LightArray[i].InActSecBriG+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+i2;
					LightArray[i].CurB=(LightArray[i].InActSecBriB+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriB+LightArray[i].CurrentFDelta)-(LightArray[i].InActSecBriB+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+i2;
				}
				if(LightArray[i].InActSecMode==3){	//ColorFlicker mode
					LightArray[i].CurR=(LightArray[i].InActSecBriR+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriR+LightArray[i].CurrentFDelta)-(LightArray[i].InActSecBriR+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+(rand()%LightArray[i].InActSecDel);
					LightArray[i].CurG=(LightArray[i].InActSecBriG+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriG+LightArray[i].CurrentFDelta)-(LightArray[i].InActSecBriG+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+(rand()%LightArray[i].InActSecDel);
					LightArray[i].CurB=(LightArray[i].InActSecBriB+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriB+LightArray[i].CurrentFDelta)-(LightArray[i].InActSecBriB+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+(rand()%LightArray[i].InActSecDel);
				}
				if(LightArray[i].InActSecMode==4){	//Sinewave (Smoother) mode
					LightArray[i].CurR=(LightArray[i].InActSecBriR+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriR+LightArray[i].CurrentFDelta)-(LightArray[i].InActSecBriR+LightArray[i].CurrentDelta))*   (((  sin((LightArray[i].Pos/16384.0f)*180.0f*radians)  )*0.5f)+0.5f)   );
					LightArray[i].CurG=(LightArray[i].InActSecBriG+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriG+LightArray[i].CurrentFDelta)-(LightArray[i].InActSecBriG+LightArray[i].CurrentDelta))*   (((  sin((LightArray[i].Pos/16384.0f)*180.0f*radians)  )*0.5f)+0.5f)   );
					LightArray[i].CurB=(LightArray[i].InActSecBriB+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriB+LightArray[i].CurrentFDelta)-(LightArray[i].InActSecBriB+LightArray[i].CurrentDelta))*   (((  sin((LightArray[i].Pos/16384.0f)*180.0f*radians)  )*0.5f)+0.5f)   );
				}
			}
		}else{	//It's the primary phase
			if(LightArray[i].Active){
				if(LightArray[i].ActPriMode==0){	//Constant light mode
					LightArray[i].CurR=LightArray[i].ActPriBriR+LightArray[i].CurrentDelta;
					LightArray[i].CurG=LightArray[i].ActPriBriG+LightArray[i].CurrentDelta;
					LightArray[i].CurB=LightArray[i].ActPriBriB+LightArray[i].CurrentDelta;
				}
				if(LightArray[i].ActPriMode==1){	//Smooth mode
					LightArray[i].CurR=(LightArray[i].ActPriBriR+LightArray[i].CurrentDelta)+(((LightArray[i].ActSecBriR+LightArray[i].CurrentFDelta)-(LightArray[i].ActPriBriR+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f));
					LightArray[i].CurG=(LightArray[i].ActPriBriG+LightArray[i].CurrentDelta)+(((LightArray[i].ActSecBriG+LightArray[i].CurrentFDelta)-(LightArray[i].ActPriBriG+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f));
					LightArray[i].CurB=(LightArray[i].ActPriBriB+LightArray[i].CurrentDelta)+(((LightArray[i].ActSecBriB+LightArray[i].CurrentFDelta)-(LightArray[i].ActPriBriB+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f));
				}
				if(LightArray[i].ActPriMode==2){	//Flicker mode
					i2=rand()%LightArray[i].ActPriDel;
					LightArray[i].CurR=(LightArray[i].ActPriBriR+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriR+LightArray[i].CurrentFDelta)-(LightArray[i].ActPriBriR+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+i2;
					LightArray[i].CurG=(LightArray[i].ActPriBriG+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriG+LightArray[i].CurrentFDelta)-(LightArray[i].ActPriBriG+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+i2;
					LightArray[i].CurB=(LightArray[i].ActPriBriB+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriB+LightArray[i].CurrentFDelta)-(LightArray[i].ActPriBriB+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+i2;
				}
				if(LightArray[i].ActPriMode==3){	//Color Flicker mode
					LightArray[i].CurR=(LightArray[i].ActPriBriR+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriR+LightArray[i].CurrentFDelta)-(LightArray[i].ActPriBriR+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+(rand()%LightArray[i].ActPriDel);
					LightArray[i].CurG=(LightArray[i].ActPriBriG+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriG+LightArray[i].CurrentFDelta)-(LightArray[i].ActPriBriG+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+(rand()%LightArray[i].ActPriDel);
					LightArray[i].CurB=(LightArray[i].ActPriBriB+LightArray[i].CurrentDelta)+(((LightArray[i].ActPriBriB+LightArray[i].CurrentFDelta)-(LightArray[i].ActPriBriB+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+(rand()%LightArray[i].ActPriDel);
				}
				if(LightArray[i].ActPriMode==4){	//Sinewave (Smoother) mode
					LightArray[i].CurR=(LightArray[i].ActPriBriR+LightArray[i].CurrentDelta)+(((LightArray[i].ActSecBriR+LightArray[i].CurrentFDelta)-(LightArray[i].ActPriBriR+LightArray[i].CurrentDelta))*   (((  sin((LightArray[i].Pos/16384.0f)*180.0f*radians)  )*0.5f)+0.5f)   );
					LightArray[i].CurG=(LightArray[i].ActPriBriG+LightArray[i].CurrentDelta)+(((LightArray[i].ActSecBriG+LightArray[i].CurrentFDelta)-(LightArray[i].ActPriBriG+LightArray[i].CurrentDelta))*   (((  sin((LightArray[i].Pos/16384.0f)*180.0f*radians)  )*0.5f)+0.5f)   );
					LightArray[i].CurB=(LightArray[i].ActPriBriB+LightArray[i].CurrentDelta)+(((LightArray[i].ActSecBriB+LightArray[i].CurrentFDelta)-(LightArray[i].ActPriBriB+LightArray[i].CurrentDelta))*   (((  sin((LightArray[i].Pos/16384.0f)*180.0f*radians)  )*0.5f)+0.5f)   );
				}
			}else{
				if(LightArray[i].InActPriMode==0){	//Constant light mode
					LightArray[i].CurR=LightArray[i].InActPriBriR+LightArray[i].CurrentDelta;
					LightArray[i].CurG=LightArray[i].InActPriBriG+LightArray[i].CurrentDelta;
					LightArray[i].CurB=LightArray[i].InActPriBriB+LightArray[i].CurrentDelta;
				}
				if(LightArray[i].InActPriMode==1){	//Smooth mode
					LightArray[i].CurR=(LightArray[i].InActPriBriR+LightArray[i].CurrentDelta)+(((LightArray[i].InActSecBriR+LightArray[i].CurrentFDelta)-(LightArray[i].InActPriBriR+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f));
					LightArray[i].CurG=(LightArray[i].InActPriBriG+LightArray[i].CurrentDelta)+(((LightArray[i].InActSecBriG+LightArray[i].CurrentFDelta)-(LightArray[i].InActPriBriG+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f));
					LightArray[i].CurB=(LightArray[i].InActPriBriB+LightArray[i].CurrentDelta)+(((LightArray[i].InActSecBriB+LightArray[i].CurrentFDelta)-(LightArray[i].InActPriBriB+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f));
				}
				if(LightArray[i].InActPriMode==2){	//Flicker mode
					i2=rand()%LightArray[i].InActPriDel;
					LightArray[i].CurR=(LightArray[i].InActPriBriR+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriR+LightArray[i].CurrentFDelta)-(LightArray[i].InActPriBriR+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+i2;
					LightArray[i].CurG=(LightArray[i].InActPriBriG+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriG+LightArray[i].CurrentFDelta)-(LightArray[i].InActPriBriG+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+i2;
					LightArray[i].CurB=(LightArray[i].InActPriBriB+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriB+LightArray[i].CurrentFDelta)-(LightArray[i].InActPriBriB+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+i2;
				}
				if(LightArray[i].InActPriMode==3){	//ColorFlicker mode
					LightArray[i].CurR=(LightArray[i].InActPriBriR+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriR+LightArray[i].CurrentFDelta)-(LightArray[i].InActPriBriR+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+(rand()%LightArray[i].InActPriDel);
					LightArray[i].CurG=(LightArray[i].InActPriBriG+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriG+LightArray[i].CurrentFDelta)-(LightArray[i].InActPriBriG+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+(rand()%LightArray[i].InActPriDel);
					LightArray[i].CurB=(LightArray[i].InActPriBriB+LightArray[i].CurrentDelta)+(((LightArray[i].InActPriBriB+LightArray[i].CurrentFDelta)-(LightArray[i].InActPriBriB+LightArray[i].CurrentDelta))*(LightArray[i].Pos/16384.0f))+(rand()%LightArray[i].InActPriDel);
				}
				if(LightArray[i].InActPriMode==4){	//Sinewave (Smoother) mode
					LightArray[i].CurR=(LightArray[i].InActPriBriR+LightArray[i].CurrentDelta)+(((LightArray[i].InActSecBriR+LightArray[i].CurrentFDelta)-(LightArray[i].InActPriBriR+LightArray[i].CurrentDelta))*   (((  sin((LightArray[i].Pos/16384.0f)*180.0f*radians)  )*0.5f)+0.5f)   );
					LightArray[i].CurG=(LightArray[i].InActPriBriG+LightArray[i].CurrentDelta)+(((LightArray[i].InActSecBriG+LightArray[i].CurrentFDelta)-(LightArray[i].InActPriBriG+LightArray[i].CurrentDelta))*   (((  sin((LightArray[i].Pos/16384.0f)*180.0f*radians)  )*0.5f)+0.5f)   );
					LightArray[i].CurB=(LightArray[i].InActPriBriB+LightArray[i].CurrentDelta)+(((LightArray[i].InActSecBriB+LightArray[i].CurrentFDelta)-(LightArray[i].InActPriBriB+LightArray[i].CurrentDelta))*   (((  sin((LightArray[i].Pos/16384.0f)*180.0f*radians)  )*0.5f)+0.5f)   );
				}
			}
		}
	}
	
	for(i=1;i<PlatformArraySize+1;i++){
		if(PlatformArray[i].delayed){
			PlatformArray[i].timer-=speedfactor;
			if(PlatformArray[i].timer<=0.0f)
				PlatformArray[i].delayed=false;
		}
		if(PlatformArray[i].active&&!PlatformArray[i].delayed){
			if(PlatformArray[i].highestfloor!=PlatformArray[i].lowestfloor)
				if(PlatformArray[i].floorrising)
					PlatformArray[i].floorposition+=PlatformArray[i].risespeed;
				else
					PlatformArray[i].floorposition-=PlatformArray[i].risespeed;
			
			if(PlatformArray[i].highestceiling!=PlatformArray[i].lowestceiling)
				if(PlatformArray[i].ceilingrising)
					PlatformArray[i].ceilingposition+=PlatformArray[i].risespeed;
				else
					PlatformArray[i].ceilingposition-=PlatformArray[i].risespeed;
		}else{
			//Temporary...
			//PlatformArray[i].active=true;
		}
		if(PlatformArray[i].floorposition>PlatformArray[i].highestfloor){
			PlatformArray[i].floorposition=PlatformArray[i].highestfloor;
			PlatformArray[i].floorrising=false;
			PlatformArray[i].delayed=true;
			PlatformArray[i].timer=PlatformArray[i].apexdelay;
			PlatformArray[i].active=false;
		}
		if(PlatformArray[i].floorposition<PlatformArray[i].lowestfloor){
			PlatformArray[i].floorposition=PlatformArray[i].lowestfloor;
			PlatformArray[i].floorrising=true;
			PlatformArray[i].delayed=true;
			PlatformArray[i].timer=PlatformArray[i].nadirdelay;
		}
		if(PlatformArray[i].ceilingposition>PlatformArray[i].highestceiling){
			PlatformArray[i].ceilingposition=PlatformArray[i].highestceiling;
			PlatformArray[i].ceilingrising=false;
			PlatformArray[i].delayed=true;
			PlatformArray[i].timer=PlatformArray[i].apexdelay;
		}
		if(PlatformArray[i].ceilingposition<PlatformArray[i].lowestceiling){
			PlatformArray[i].ceilingposition=PlatformArray[i].lowestceiling;
			PlatformArray[i].ceilingrising=true;
			PlatformArray[i].delayed=true;
			PlatformArray[i].timer=PlatformArray[i].nadirdelay;
			PlatformArray[i].active=false;
		}
		if(PlatformArray[i].delayed){
			if(PlatformArray[i].ceilingrising==true)
				PlatformArray[i].ceilingposition=PlatformArray[i].lowestceiling;
			else
				PlatformArray[i].ceilingposition=PlatformArray[i].highestceiling;

			if(PlatformArray[i].floorrising==true)
				PlatformArray[i].floorposition=PlatformArray[i].lowestfloor;
			else
				PlatformArray[i].floorposition=PlatformArray[i].highestfloor;
		}
		
		for(i2=0;i2<LinesPerPoly&&PolygonArray[PlatformArray[i].poly].lines[i2]>0;i2++){
			if(LineArray[PolygonArray[PlatformArray[i].poly].lines[i2]].shared){
				if(PlatformArray[i].poly==LineArray[PolygonArray[PlatformArray[i].poly].lines[i2]].user1){
					if(PolygonArray[PlatformArray[i].poly].floorheight>PolygonArray[LineArray[PolygonArray[PlatformArray[i].poly].lines[i2]].user2].floorheight){
						LineArray[PolygonArray[PlatformArray[i].poly].lines[i2]].ytexoffset1=PlatformArray[i].floorposition;
					}
					if(PolygonArray[PlatformArray[i].poly].ceilingheight<PolygonArray[LineArray[PolygonArray[PlatformArray[i].poly].lines[i2]].user2].ceilingheight){
						LineArray[PolygonArray[PlatformArray[i].poly].lines[i2]].ytexoffset2=PlatformArray[i].ceilingposition;
					}
				}else{
					if(PolygonArray[PlatformArray[i].poly].floorheight>PolygonArray[LineArray[PolygonArray[PlatformArray[i].poly].lines[i2]].user1].floorheight){
						LineArray[PolygonArray[PlatformArray[i].poly].lines[i2]].ytexoffset1=PlatformArray[i].floorposition;
					}
					if(PolygonArray[PlatformArray[i].poly].ceilingheight<PolygonArray[LineArray[PolygonArray[PlatformArray[i].poly].lines[i2]].user1].ceilingheight){
						LineArray[PolygonArray[PlatformArray[i].poly].lines[i2]].ytexoffset2=PlatformArray[i].ceilingposition;
					}
				}
			}
			
		}
		PolygonArray[PlatformArray[i].poly].floorheight = PlatformArray[i].floorposition;
		PolygonArray[PlatformArray[i].poly].ceilingheight = PlatformArray[i].ceilingposition;
	
		for(i2=0;i2<MonsterArraySize;i2++){
			if(MonsterArray[i2].polyparent==PlatformArray[i].poly && MonsterArray[i2].y+MonsterInfoArray[MonsterArray[i2].type].height>=PlatformArray[i].ceilingposition){
				PlatformArray[i].floorrising=false;
				PlatformArray[i].ceilingrising=true;
			}
		}


	}
	
	
	
	//          									      																	           																																																						"/*i'd be suspicious of any comment with a */ in it too"
	return;
}


void TestShotCol(void){
	GLfloat xi, yi, xi2, yi2, pxi, pyi, pri, gi, ngi;
	GLfloat cxi, cyi, nx, ny;
	bool cip, cxip, nc;

	if(ShotInfoArray[ShotArray[i].type].noofparticles>0)
		CreateParticles(ShotInfoArray[ShotArray[i].type].particle,ShotInfoArray[ShotArray[i].type].noofparticles,ShotArray[i].x,ShotArray[i].y,ShotArray[i].z, ShotArray[i].polyparent);
	//Move the shot
	ShotArray[i].x+=ShotArray[i].xs*speedfactor;
	ShotArray[i].y+=ShotArray[i].ys*speedfactor;
	ShotArray[i].z+=ShotArray[i].zs*speedfactor;
	//Apply gravity
	ShotArray[i].ys-=ShotInfoArray[ShotArray[i].type].grav;
	//Aim closer to the player
	if(ShotInfoArray[ShotArray[i].type].guided)
		ShotArray[i].turntopoint(MonsterArray[ShotArray[i].target].x,MonsterArray[ShotArray[i].target].y,MonsterArray[ShotArray[i].target].z);

	//Update the shot's particle
	if(ShotArray[i].beamno>=0){
		ParticleArray[ShotArray[i].beamno].x=ShotArray[i].x;
		ParticleArray[ShotArray[i].beamno].y=ShotArray[i].y;
		ParticleArray[ShotArray[i].beamno].z=ShotArray[i].z;
	}

	if(ShotInfoArray[ShotArray[i].type].particle>0)
		CreateParticles(ShotInfoArray[ShotArray[i].type].particle,ShotInfoArray[ShotArray[i].type].noofparticles,ShotArray[i].x,ShotArray[i].y,ShotArray[i].z,ShotArray[i].polyparent);
	if(ShotInfoArray[ShotArray[i].type].lifetime!=0){
		ShotArray[i].age++;
		if(ShotArray[i].age>=ShotInfoArray[ShotArray[i].type].lifetime){
			ShotArray[i].beamno=-1;
			ShotArray[i].x=0.0f;
			ShotArray[i].y=0.0f;
			ShotArray[i].z=0.0f;
			ShotArray[i].xs=0.0f;
			ShotArray[i].ys=0.0f;
			ShotArray[i].zs=0.0f;
			ShotArray[i].type=0;
		}
	}

	for(i2=0;i2<LinesPerPoly;i2++){
		if(PolygonArray[ShotArray[i].polyparent].lines[i2]!=-1){
			xi = LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].x;
			yi = LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].y;
			xi2 = LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].x2;
			yi2 = LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].y2;
			gi = (yi2-yi)/(xi2-xi);
			ngi = (xi2-xi)/(yi2-yi);
			pxi = ShotArray[i].x;
			pyi = ShotArray[i].z;
			pri = ShotInfoArray[ShotArray[i].type].radius;
			cyi=PolygonArray[ShotArray[i].polyparent].centery;
			cxi=PolygonArray[ShotArray[i].polyparent].centerx;
			
			if(cyi<(yi + (gi * (cxi - xi))))
				cip = false;
			else
				cip = true;
			if(cxi<(xi + (ngi * (cyi - yi))))
				cxip = false;
			else
				cxip = true;
			
			nx=ShotArray[i].x;
			ny=ShotArray[i].z;
			
			nc=false;
			if(!LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].shared){
				nc=true;
			}else{
				if(ShotArray[i].polyparent==LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].user1){
					if(ShotArray[i].y-pri >= PolygonArray[LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].user2].floorheight && ShotArray[i].y+ShotInfoArray[ShotArray[i].type].radius < PolygonArray[LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].user2].ceilingheight){
						if(cip){
							if(pyi<(yi + (gi * (pxi - xi))))
								ShotArray[i].polyparent=LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].user2;
						}else{
							if(pyi>(yi + (gi * (pxi - xi))))
								ShotArray[i].polyparent=LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].user2;
						}
					
					}else
						nc=true;
				
				}else{
					if(ShotArray[i].y-pri >= PolygonArray[LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].user1].floorheight && ShotArray[i].y+ShotInfoArray[ShotArray[i].type].radius < PolygonArray[LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].user1].ceilingheight){
						if(cip){
							if(pyi<(yi + (gi * (pxi - xi))))
								ShotArray[i].polyparent=LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].user1;
						}else{
							if(pyi>(yi + (gi * (pxi - xi))))
								ShotArray[i].polyparent=LineArray[PolygonArray[ShotArray[i].polyparent].lines[i2]].user1;
						}
					}else
						nc=true;
				}
			}
			if(nc){
				nc=false;
				if(cip){
					
					if(pyi+pri<(yi + (gi * (pxi - xi)))||pyi-pri<(yi + (gi * (pxi - xi)))){
							DestroyShot(i,true);
					}
				}else{
					if(pyi+pri>(yi + (gi * (pxi - xi)))||pyi-pri>(yi + (gi * (pxi - xi)))){
							DestroyShot(i,true);
					}
				}
				if(cxip){
					if(pxi+pri<(xi + (ngi * (pyi - yi)))||pxi-pri<(xi + (ngi * (pyi - yi)))){
							DestroyShot(i,true);
					}
				}else{
					if(pxi+pri>(xi + (ngi * (pyi - yi)))||pxi-pri>(xi + (ngi * (pyi - yi)))){
							DestroyShot(i,true);
					}
				}
				}
			}
		}
	if(ShotArray[i].y<PolygonArray[ShotArray[i].polyparent].floorheight){
		if(PolygonArray[ShotArray[i].polyparent].floorlink==-1){
			DestroyShot(i,true);
		}else{
			ShotArray[i].polyparent=PolygonArray[ShotArray[i].polyparent].floorlink;
		}
	}
	if(ShotArray[i].y>PolygonArray[ShotArray[i].polyparent].ceilingheight){
		if(PolygonArray[ShotArray[i].polyparent].ceilinglink==-1){
			DestroyShot(i,true);
		}else{
			ShotArray[i].polyparent=PolygonArray[ShotArray[i].polyparent].ceilinglink;
		}
	}
		//...Check if it's hit an enemy...
		for(i2=0;i2<MonsterArraySize;i2++)
			if(MonsterArray[i2].polyparent==ShotArray[i].polyparent||ShotInfoArray[ShotArray[i].type].intercol)
				if(MonsterArray[i2].x-ShotArray[i].x>-MonsterInfoArray[MonsterArray[i2].type].radius &&MonsterArray[i2].x-ShotArray[i].x<MonsterInfoArray[MonsterArray[i2].type].radius && MonsterArray[i2].z-ShotArray[i].z>-MonsterInfoArray[MonsterArray[i2].type].radius&& MonsterArray[i2].z-ShotArray[i].z<MonsterInfoArray[MonsterArray[i2].type].radius)
					if(MonsterArray[i2].y<ShotArray[i].y&&MonsterArray[i2].y+MonsterInfoArray[MonsterArray[i2].type].height>ShotArray[i].y)
						if(ShotArray[i].origin!=i2||ShotInfoArray[ShotArray[i].type].inclusivehits){
							MonsterArray[i2].health-=ShotInfoArray[ShotArray[i].type].damage;
							if(MonsterArray[i2].curaction!=4){	//If they're not dying
								MonsterArray[i2].curaction=3;	//Set them to flinch
								MonsterArray[i2].frame=1;
								MonsterArray[i2].frametimer=0;
							}
							MonsterArray[i2].xdir+=(((rand()%8192)/8192.0f)-0.5f)*ShotInfoArray[ShotArray[i].type].disruption;
							MonsterArray[i2].ydir+=(((rand()%8192)/8192.0f)-0.5f)*ShotInfoArray[ShotArray[i].type].disruption;
							if(i2==0){//If it's the player, flash our view...
								colorarray[4][2][0]=FlashArray[ShotInfoArray[ShotArray[i].type].flash].a*16;
								colorarray[1][2][0]=FlashArray[ShotInfoArray[ShotArray[i].type].flash].r;
								colorarray[2][2][0]=FlashArray[ShotInfoArray[ShotArray[i].type].flash].g;
								colorarray[3][2][0]=FlashArray[ShotInfoArray[ShotArray[i].type].flash].b;
								FlashFadeSpeed=FlashArray[ShotInfoArray[ShotArray[i].type].flash].fadespeed;
								FlashMode=FlashArray[ShotInfoArray[ShotArray[i].type].flash].mode;
							}
							if(ShotInfoArray[ShotArray[i].type].sharp){
								CreateParticles(MonsterInfoArray[MonsterArray[i2].type].sharphitparticletype,MonsterInfoArray[MonsterArray[i2].type].sharphitparticleno,ShotArray[i].x,ShotArray[i].y,ShotArray[i].z, ShotArray[i].polyparent);
								DestroyShot(i,false);
							}else
								DestroyShot(i,true);
						}
	return;
}
void DestroyShot(int theshot, bool makeparticles){
	//if(ShotArray[theshot].type==0)
		//return;
	//CreateParticles(1,5,3.0f,0.0f,0.0f,0.001f,1.0f);
	if(ShotArray[theshot].type==0)
		return;
	hitpointx=ShotArray[theshot].x;
	hitpointy=ShotArray[theshot].y;
	hitpointz=ShotArray[theshot].z;

	if(makeparticles){
		CreateParticles(ShotInfoArray[ShotArray[theshot].type].deathparticle,ShotInfoArray[ShotArray[theshot].type].noofdeathparticles,ShotArray[theshot].x,ShotArray[theshot].y,ShotArray[theshot].z, ShotArray[theshot].polyparent);
		if(ShotInfoArray[ShotArray[theshot].type].deathsound>=1)
			PlayASound(ShotInfoArray[ShotArray[theshot].type].deathsound);
	}
	
	ShotArray[theshot].beamno=-1;
	ShotArray[theshot].x=0.0f;
	ShotArray[theshot].y=0.0f;
	ShotArray[theshot].z=0.0f;
	ShotArray[theshot].xs=0.0f;
	ShotArray[theshot].ys=0.0f;
	ShotArray[theshot].zs=0.0f;
	ShotArray[theshot].type=0;
	
	return;
}

void monstertype::shoot(int theobject, int wep, bool sec){
	int gi, ji, ti;
	
	if(wep<=0)
		return;
	if((MonsterInfoArray[MonsterArray[theobject].type].isplayer||theobject==0)&&ItemInfoArray[PlayerSelection].seperatetriggers){
		if(theobject==0){
			if(!sec&&Player.shotdelay>0)
				return;
			if(sec&&(Player.shotdelay2>0||PlayerInventory[PlayerSelection]<=1))
				return;
		}else{
			//Put something here sometime
		}

	}else{		//We're dealing with a stupid _monster_ here... or a player not dual-wielding
		//Don't shoot if the delay ain't up
		if(!sec&&MonsterArray[theobject].shotdelay>0)
			return;
		if(sec&&MonsterArray[theobject].shotdelay2>0)
			return;
	}
	if(theobject==0&&WeaponInfoArray[wep].clipsize!=-1){
		if(WeaponAmmo[wep]==0)
			return;
		else
			WeaponAmmo[wep]--;
	}
	if(theobject==0){
		if(!sec)
			gi=PlayerPriSelection;
		else
			gi=PlayerSecSelection;
		WeaponInfoArray[gi].sequence = WeaponInfoArray[gi].shootsequence;
		WeaponInfoArray[gi].frame=1;
		WeaponInfoArray[gi].frametimer=0.0f;
	}
	if(WeaponInfoArray[wep].shotsound>0)
		PlayASound(WeaponInfoArray[wep].shotsound);
	for(ti=1;ti<=WeaponInfoArray[wep].shotspershot;ti++){
		for(gi=1;ShotArray[gi].type>0;gi++){}
		if(gi > ShotArraySize)
			ShotArraySize=gi;
		if(ShotArraySize>=MaxShotArraySize-1)
			ShotArraySize=MaxShotArraySize-2;
		ShotArray[gi].frame=1;
		ShotArray[gi].frametimer=1;
		ShotArray[gi].polyparent=MonsterArray[theobject].polyparent;
		ShotArray[gi].origin=theobject;
		ShotArray[gi].type=WeaponInfoArray[wep].wot;
		ShotArray[gi].zs=-cos((MonsterArray[theobject].xdir+(((((rand()%1024)/1024.0f)-((rand()%1024)/1024.0f)))*MonsterArray[theobject].inaccuracy*WeaponInfoArray[wep].inaccfactor))*radians)*ShotInfoArray[ShotArray[gi].type].speed*cos((MonsterArray[theobject].ydir+(((((rand()%1024)/1024.0f)-((rand()%1024)/1024.0f)))*MonsterArray[theobject].inaccuracy*WeaponInfoArray[wep].inaccfactor))*radians);
		ShotArray[gi].ys=-sin((MonsterArray[theobject].ydir+(((((rand()%1024)/1024.0f)-((rand()%1024)/1024.0f)))*MonsterArray[theobject].inaccuracy*WeaponInfoArray[wep].inaccfactor))*radians)*ShotInfoArray[ShotArray[gi].type].speed;
		ShotArray[gi].xs= sin((MonsterArray[theobject].xdir+(((((rand()%1024)/1024.0f)-((rand()%1024)/1024.0f)))*MonsterArray[theobject].inaccuracy*WeaponInfoArray[wep].inaccfactor))*radians)*ShotInfoArray[ShotArray[gi].type].speed*cos((MonsterArray[theobject].ydir+(((((rand()%1024)/1024.0f)-((rand()%1024)/1024.0f)))*MonsterArray[theobject].inaccuracy*WeaponInfoArray[wep].inaccfactor))*radians);
		ShotArray[gi].x=MonsterArray[theobject].x-((sin((MonsterArray[theobject].xdir-90.0f)*radians)*WeaponInfoArray[wep].xo)) + ((sin((MonsterArray[theobject].xdir)*radians)*WeaponInfoArray[wep].zo)*cos(MonsterArray[theobject].ydir*radians));
		ShotArray[gi].y=(MonsterArray[theobject].y+WeaponInfoArray[wep].yo)-((sin(MonsterArray[theobject].ydir*radians)*WeaponInfoArray[wep].zo))+sin(Player.bobheightphase*radians)*MonsterInfoArray[Player.type].maxbobheight;
		ShotArray[gi].z=MonsterArray[theobject].z+((cos((MonsterArray[theobject].xdir-90.0f)*radians)*WeaponInfoArray[wep].xo)) - ((cos((MonsterArray[theobject].xdir)*radians)*WeaponInfoArray[wep].zo)*cos(MonsterArray[theobject].ydir*radians));
		ShotArray[gi].xdir=MonsterArray[theobject].xdir;
		ShotArray[gi].ydir=MonsterArray[theobject].ydir;
		ShotArray[gi].age=0;
		if(ShotInfoArray[ShotArray[gi].type].instant)
			for(i=gi;ShotArray[gi].type>0;TestShotCol()){
				ShotArray[gi].beamno=CreateParticles(WeaponInfoArray[wep].shotparticle,WeaponInfoArray[wep].noofshotparticles,ShotArray[gi].x,ShotArray[gi].y,ShotArray[gi].z,MonsterArray[theobject].polyparent);
			}
	}
	if(!ShotInfoArray[WeaponInfoArray[wep].wot].instant){
		ShotArray[gi].beamno=CreateParticles(WeaponInfoArray[wep].shotparticle,WeaponInfoArray[wep].noofshotparticles,ShotArray[gi].x,ShotArray[gi].y,ShotArray[gi].z,MonsterArray[theobject].polyparent);
	}

	MonsterArray[theobject].xs-=sin(MonsterArray[theobject].xdir*radians)*WeaponInfoArray[wep].recoil*cos(MonsterArray[theobject].ydir*radians);
	MonsterArray[theobject].ys+=sin(MonsterArray[theobject].ydir*radians)*WeaponInfoArray[wep].recoil;
	MonsterArray[theobject].zs+=cos(MonsterArray[theobject].xdir*radians)*WeaponInfoArray[wep].recoil*cos(MonsterArray[theobject].ydir*radians);

	MonsterArray[theobject].xdir+=((rand()/16384.0f)*WeaponInfoArray[wep].knock)-((rand()/16384.0f)*WeaponInfoArray[wep].knock);
	MonsterArray[theobject].ydir+=((rand()/16384.0f)*WeaponInfoArray[wep].knock)-((rand()/16384.0f)*WeaponInfoArray[wep].knock);
	MonsterArray[theobject].ydir-=WeaponInfoArray[wep].kick;
	
	if(sec)
		MonsterArray[theobject].shotdelay2=WeaponInfoArray[wep].rate;
	else
		MonsterArray[theobject].shotdelay=WeaponInfoArray[wep].rate;

	
	return;
}

bool TestObjectYThingy(int ji, int parent){
	GLfloat xi, yi, xi2, yi2, pxi, pyi, pri, gi, ngi, cyi, cxi;
	bool cip, cxip;
	int i2;
	bool r = false;
	
	for(i2=0;i2<LinesPerPoly;i2++){
		xi = LineArray[PolygonArray[parent].lines[i2]].x;
		yi = LineArray[PolygonArray[parent].lines[i2]].y;
		xi2 = LineArray[PolygonArray[parent].lines[i2]].x2;
		yi2 = LineArray[PolygonArray[parent].lines[i2]].y2;
		gi = (yi2-yi)/(xi2-xi);
		ngi = (xi2-xi)/(yi2-yi);
		
		pxi = MonsterArray[ji].x;
		pyi = MonsterArray[ji].z;
		pri = MonsterInfoArray[MonsterArray[i].type].radius*0.8;
		
		cyi=PolygonArray[parent].centery;
		cxi=PolygonArray[parent].centerx;
		if(cyi<(yi + (gi * (cxi - xi))))
			cip = false;
		else
			cip = true;
		
		if(cxi<(xi + (ngi * (cyi - yi))))
			cxip = false;
		else
			cxip = true;
		
		if(cip){
			if(pyi-pri<(yi + (gi * (pxi - xi))))
				r = true;
		}else{
			if(pyi+pri>(yi + (gi * (pxi - xi))))
				r = true;
		}
		if(cxip){
			if(pxi-pri<(xi + (ngi * (pyi - yi))))
				r = true;
		}else{
			if(pxi+pri>(xi + (ngi * (pyi - yi))))
				r = true;
		}

		
	}

	return r;
}


int CreateParticles(int type, int number, GLfloat x, GLfloat y, GLfloat z,int parent){
	int ri;
	int fi=1;
	GLfloat speed;
	GLfloat spin;
	if(PrefsParticleFX){
		for(ri=0;ri<number;ri++){
			for(fi=1;ParticleArray[fi].type>0&&fi<ParticleArraySize;fi++){}
			ParticleArray[fi].type=type;
			speed=ParticleInfoArray[type].speed;
			spin=ParticleInfoArray[type].spin;
			ParticleArray[fi].life=ParticleInfoArray[type].lifespan;
			ParticleArray[fi].startlife=ParticleInfoArray[type].lifespan;
			ParticleArray[fi].parent=parent;
			ParticleArray[fi].x=x;
			ParticleArray[fi].x2=x;
			ParticleArray[fi].y=y;
			ParticleArray[fi].y2=y;
			ParticleArray[fi].z=z;
			ParticleArray[fi].z2=z;
			ParticleArray[fi].xs=(((rand()%200)/200.0f)*speed)-(((rand()%200)/200.0f)*speed);
			ParticleArray[fi].ys=(((rand()%200)/200.0f)*speed)-(((rand()%200)/200.0f)*speed);
			ParticleArray[fi].zs=(((rand()%200)/200.0f)*speed)-(((rand()%200)/200.0f)*speed);
			ParticleArray[fi].xr=rand()%360;
			ParticleArray[fi].yr=rand()%360;
			ParticleArray[fi].zr=rand()%360;
			ParticleArray[fi].xrs=(((rand()%200)/200.0f)*spin)-(((rand()%200)/200.0f)*spin);
			ParticleArray[fi].yrs=(((rand()%200)/200.0f)*spin)-(((rand()%200)/200.0f)*spin);
			ParticleArray[fi].zrs=(((rand()%200)/200.0f)*spin)-(((rand()%200)/200.0f)*spin);
			ParticleArray[fi].x+=ParticleArray[fi].xs*3.0f;
			ParticleArray[fi].y+=ParticleArray[fi].ys*3.0f;
			ParticleArray[fi].z+=ParticleArray[fi].zs*3.0f;
		}
	}
	return fi;
}
#endif