#include "e0main.h"


int LoadAndPlaySong(const char thefile[]){
	char newpath[255];
	FILE *fptr;
	sprintf(newpath,"%s/%s",ScenarioDir,thefile);

	if((fptr = fopen(newpath, "rt"))==NULL){       //Open filestream
		fprintf(stderr, "Missing music file: %s\n", newpath);
		return 0;
	}
	fprintf(stderr, "Opened music file OK: %s\n", newpath);
	fclose(fptr);
	TheMusic=Mix_LoadMUS(newpath);
	Mix_PlayMusic(TheMusic, -1);
	return 0;
}

void SetupSounds(void){
	int audio_rate = 22050;
	Uint16 audio_format = AUDIO_S16; // 16-bit stereo
	int audio_channels = 2;
	int audio_buffers = 4096;
	
	if(Mix_OpenAudio(audio_rate, audio_format, audio_channels, audio_buffers))
		fprintf(stderr,"Unable to open audio!\n");
}



inline void PlayASound(int thesound){
	int li;
	if(SoundArray[thesound].NoOfAlts==0)
		li = 0;
	else
		li = (rand()%(SoundArray[thesound].NoOfAlts+1));
	if(li<=0)
		Mix_PlayChannel(-1, SoundArray[thesound].TheSound, 0);
	else{
		li=SoundArray[thesound].Alts[li];
		Mix_PlayChannel(-1, SoundArray[li].TheSound, 0);
	}
	
}
void DoSounds(GLvoid){
	
	
	
	return;
}